/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 5.4.3
 * @date    2020-01-02T20:43:17.349Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t,e){return t(e={exports:{}},e.exports),e.exports}var r=function(t){return t&&t.Math==Math&&t},i=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof e&&e)||Function("return this")(),o=function(t){try{return!!t()}catch(t){return!0}},a=!o((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),s={}.propertyIsEnumerable,u=Object.getOwnPropertyDescriptor,c={f:u&&!s.call({1:2},1)?function(t){var e=u(this,t);return!!e&&e.enumerable}:s},l=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},h={}.toString,f=function(t){return h.call(t).slice(8,-1)},d="".split,p=o((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==f(t)?d.call(t,""):Object(t)}:Object,y=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},v=function(t){return p(y(t))},m=function(t){return"object"==typeof t?null!==t:"function"==typeof t},g=function(t,e){if(!m(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!m(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!m(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},_={}.hasOwnProperty,w=function(t,e){return _.call(t,e)},b=i.document,S=m(b)&&m(b.createElement),x=function(t){return S?b.createElement(t):{}},O=!a&&!o((function(){return 7!=Object.defineProperty(x("div"),"a",{get:function(){return 7}}).a})),k=Object.getOwnPropertyDescriptor,M={f:a?k:function(t,e){if(t=v(t),e=g(e,!0),O)try{return k(t,e)}catch(t){}if(w(t,e))return l(!c.f.call(t,e),t[e])}},D=/#|\.prototype\./,T=function(t,e){var n=A[P(t)];return n==L||n!=E&&("function"==typeof e?o(e):!!e)},P=T.normalize=function(t){return String(t).replace(D,".").toLowerCase()},A=T.data={},E=T.NATIVE="N",L=T.POLYFILL="P",C=T,Y={},j=function(t,e,n){if(function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function")}(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},R=function(t){if(!m(t))throw TypeError(String(t)+" is not an object");return t},I=Object.defineProperty,N={f:a?I:function(t,e,n){if(R(t),e=g(e,!0),R(n),O)try{return I(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},F=a?function(t,e,n){return N.f(t,e,l(1,n))}:function(t,e,n){return t[e]=n,t},W=M.f,z=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},G=function(t,e){var n,r,o,a,s,u,c,l,h=t.target,f=t.global,d=t.stat,p=t.proto,y=f?i:d?i[h]:(i[h]||{}).prototype,v=f?Y:Y[h]||(Y[h]={}),m=v.prototype;for(o in e)n=!C(f?o:h+(d?".":"#")+o,t.forced)&&y&&w(y,o),s=v[o],n&&(u=t.noTargetGet?(l=W(y,o))&&l.value:y[o]),a=n&&u?u:e[o],n&&typeof s==typeof a||(c=t.bind&&n?j(a,i):t.wrap&&n?z(a):p&&"function"==typeof a?j(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&F(c,"sham",!0),v[o]=c,p&&(w(Y,r=h+"Prototype")||F(Y,r,{}),Y[r][o]=a,t.real&&m&&!m[o]&&F(m,o,a)))};G({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperty:N.f});var V=n((function(t){var e=Y.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)})),H=V,U=Math.ceil,B=Math.floor,Z=function(t){return isNaN(t=+t)?0:(t>0?B:U)(t)},X=Math.min,q=function(t){return t>0?X(Z(t),9007199254740991):0},J=Math.max,$=Math.min,Q=function(t,e){var n=Z(t);return n<0?J(n+e,0):$(n,e)},K=function(t){return function(e,n,r){var i,o=v(e),a=q(o.length),s=Q(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},tt={includes:K(!0),indexOf:K(!1)},et={},nt=tt.indexOf,rt=function(t,e){var n,r=v(t),i=0,o=[];for(n in r)!w(et,n)&&w(r,n)&&o.push(n);for(;e.length>i;)w(r,n=e[i++])&&(~nt(o,n)||o.push(n));return o},it=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],ot=Object.keys||function(t){return rt(t,it)},at=a?Object.defineProperties:function(t,e){R(t);for(var n,r=ot(e),i=r.length,o=0;i>o;)N.f(t,n=r[o++],e[n]);return t};G({target:"Object",stat:!0,forced:!a,sham:!a},{defineProperties:at});var st=n((function(t){var e=Y.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)})),ut=function(t){return"function"==typeof t?t:void 0},ct=function(t,e){return arguments.length<2?ut(Y[t])||ut(i[t]):Y[t]&&Y[t][e]||i[t]&&i[t][e]},lt=it.concat("length","prototype"),ht={f:Object.getOwnPropertyNames||function(t){return rt(t,lt)}},ft={f:Object.getOwnPropertySymbols},dt=ct("Reflect","ownKeys")||function(t){var e=ht.f(R(t)),n=ft.f;return n?e.concat(n(t)):e},pt=function(t,e,n){var r=g(e);r in t?N.f(t,r,l(0,n)):t[r]=n};G({target:"Object",stat:!0,sham:!a},{getOwnPropertyDescriptors:function(t){for(var e,n,r=v(t),i=M.f,o=dt(r),a={},s=0;o.length>s;)void 0!==(n=i(r,e=o[s++]))&&pt(a,e,n);return a}});var yt=Y.Object.getOwnPropertyDescriptors,vt=M.f,mt=o((function(){vt(1)}));G({target:"Object",stat:!0,forced:!a||mt,sham:!a},{getOwnPropertyDescriptor:function(t,e){return vt(v(t),e)}});var gt,_t=n((function(t){var e=Y.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)})),wt=!!Object.getOwnPropertySymbols&&!o((function(){return!String(Symbol())})),bt=wt&&!Symbol.sham&&"symbol"==typeof Symbol(),St=Array.isArray||function(t){return"Array"==f(t)},xt=function(t){return Object(y(t))},Ot=ct("document","documentElement"),kt=i["__core-js_shared__"]||function(t,e){try{F(i,t,e)}catch(n){i[t]=e}return e}("__core-js_shared__",{}),Mt=n((function(t){(t.exports=function(t,e){return kt[t]||(kt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.0",mode:"pure",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),Dt=0,Tt=Math.random(),Pt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Dt+Tt).toString(36)},At=Mt("keys"),Et=function(t){return At[t]||(At[t]=Pt(t))},Lt=Et("IE_PROTO"),Ct=function(){},Yt=function(t){return"<script>"+t+"<\/script>"},jt=function(){try{gt=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;jt=gt?function(t){t.write(Yt("")),t.close();var e=t.parentWindow.Object;return t=null,e}(gt):((e=x("iframe")).style.display="none",Ot.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Yt("document.F=Object")),t.close(),t.F);for(var n=it.length;n--;)delete jt.prototype[it[n]];return jt()};et[Lt]=!0;var Rt=Object.create||function(t,e){var n;return null!==t?(Ct.prototype=R(t),n=new Ct,Ct.prototype=null,n[Lt]=t):n=jt(),void 0===e?n:at(n,e)},It=ht.f,Nt={}.toString,Ft="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Wt={f:function(t){return Ft&&"[object Window]"==Nt.call(t)?function(t){try{return It(t)}catch(t){return Ft.slice()}}(t):It(v(t))}},zt=function(t,e,n,r){r&&r.enumerable?t[e]=n:F(t,e,n)},Gt=Mt("wks"),Vt=i.Symbol,Ht=bt?Vt:Pt,Ut=function(t){return w(Gt,t)||(wt&&w(Vt,t)?Gt[t]=Vt[t]:Gt[t]=Ht("Symbol."+t)),Gt[t]},Bt={f:Ut},Zt=N.f,Xt=function(t){var e=Y.Symbol||(Y.Symbol={});w(e,t)||Zt(e,t,{value:Bt.f(t)})},qt={};qt[Ut("toStringTag")]="z";var Jt="[object z]"===String(qt),$t=Ut("toStringTag"),Qt="Arguments"==f(function(){return arguments}()),Kt=Jt?f:function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),$t))?n:Qt?f(e):"Object"==(r=f(e))&&"function"==typeof e.callee?"Arguments":r},te=Jt?{}.toString:function(){return"[object "+Kt(this)+"]"},ee=N.f,ne=Ut("toStringTag"),re=function(t,e,n,r){if(t){var i=n?t:t.prototype;w(i,ne)||ee(i,ne,{configurable:!0,value:e}),r&&!Jt&&F(i,"toString",te)}},ie=Function.toString;"function"!=typeof kt.inspectSource&&(kt.inspectSource=function(t){return ie.call(t)});var oe,ae,se,ue=kt.inspectSource,ce=i.WeakMap,le="function"==typeof ce&&/native code/.test(ue(ce)),he=i.WeakMap;if(le){var fe=new he,de=fe.get,pe=fe.has,ye=fe.set;oe=function(t,e){return ye.call(fe,t,e),e},ae=function(t){return de.call(fe,t)||{}},se=function(t){return pe.call(fe,t)}}else{var ve=Et("state");et[ve]=!0,oe=function(t,e){return F(t,ve,e),e},ae=function(t){return w(t,ve)?t[ve]:{}},se=function(t){return w(t,ve)}}var me={set:oe,get:ae,has:se,enforce:function(t){return se(t)?ae(t):oe(t,{})},getterFor:function(t){return function(e){var n;if(!m(e)||(n=ae(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},ge=Ut("species"),_e=function(t,e){var n;return St(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!St(n.prototype)?m(n)&&null===(n=n[ge])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},we=[].push,be=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=5==t||o;return function(s,u,c,l){for(var h,f,d=xt(s),y=p(d),v=j(u,c,3),m=q(y.length),g=0,_=l||_e,w=e?_(s,m):n?_(s,0):void 0;m>g;g++)if((a||g in y)&&(f=v(h=y[g],g,d),t))if(e)w[g]=f;else if(f)switch(t){case 3:return!0;case 5:return h;case 6:return g;case 2:we.call(w,h)}else if(i)return!1;return o?-1:r||i?i:w}},Se={forEach:be(0),map:be(1),filter:be(2),some:be(3),every:be(4),find:be(5),findIndex:be(6)},xe=Se.forEach,Oe=Et("hidden"),ke=Ut("toPrimitive"),Me=me.set,De=me.getterFor("Symbol"),Te=Object.prototype,Pe=i.Symbol,Ae=ct("JSON","stringify"),Ee=M.f,Le=N.f,Ce=Wt.f,Ye=c.f,je=Mt("symbols"),Re=Mt("op-symbols"),Ie=Mt("string-to-symbol-registry"),Ne=Mt("symbol-to-string-registry"),Fe=Mt("wks"),We=i.QObject,ze=!We||!We.prototype||!We.prototype.findChild,Ge=a&&o((function(){return 7!=Rt(Le({},"a",{get:function(){return Le(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=Ee(Te,e);r&&delete Te[e],Le(t,e,n),r&&t!==Te&&Le(Te,e,r)}:Le,Ve=function(t,e){var n=je[t]=Rt(Pe.prototype);return Me(n,{type:"Symbol",tag:t,description:e}),a||(n.description=e),n},He=wt&&"symbol"==typeof Pe.iterator?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Pe},Ue=function(t,e,n){t===Te&&Ue(Re,e,n),R(t);var r=g(e,!0);return R(n),w(je,r)?(n.enumerable?(w(t,Oe)&&t[Oe][r]&&(t[Oe][r]=!1),n=Rt(n,{enumerable:l(0,!1)})):(w(t,Oe)||Le(t,Oe,l(1,{})),t[Oe][r]=!0),Ge(t,r,n)):Le(t,r,n)},Be=function(t,e){R(t);var n=v(e),r=ot(n).concat(Je(n));return xe(r,(function(e){a&&!Ze.call(n,e)||Ue(t,e,n[e])})),t},Ze=function(t){var e=g(t,!0),n=Ye.call(this,e);return!(this===Te&&w(je,e)&&!w(Re,e))&&(!(n||!w(this,e)||!w(je,e)||w(this,Oe)&&this[Oe][e])||n)},Xe=function(t,e){var n=v(t),r=g(e,!0);if(n!==Te||!w(je,r)||w(Re,r)){var i=Ee(n,r);return!i||!w(je,r)||w(n,Oe)&&n[Oe][r]||(i.enumerable=!0),i}},qe=function(t){var e=Ce(v(t)),n=[];return xe(e,(function(t){w(je,t)||w(et,t)||n.push(t)})),n},Je=function(t){var e=t===Te,n=Ce(e?Re:v(t)),r=[];return xe(n,(function(t){!w(je,t)||e&&!w(Te,t)||r.push(je[t])})),r};if(wt||(zt((Pe=function(){if(this instanceof Pe)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Pt(t),n=function(t){this===Te&&n.call(Re,t),w(this,Oe)&&w(this[Oe],e)&&(this[Oe][e]=!1),Ge(this,e,l(1,t))};return a&&ze&&Ge(Te,e,{configurable:!0,set:n}),Ve(e,t)}).prototype,"toString",(function(){return De(this).tag})),c.f=Ze,N.f=Ue,M.f=Xe,ht.f=Wt.f=qe,ft.f=Je,a&&Le(Pe.prototype,"description",{configurable:!0,get:function(){return De(this).description}})),bt||(Bt.f=function(t){return Ve(Ut(t),t)}),G({global:!0,wrap:!0,forced:!wt,sham:!wt},{Symbol:Pe}),xe(ot(Fe),(function(t){Xt(t)})),G({target:"Symbol",stat:!0,forced:!wt},{for:function(t){var e=String(t);if(w(Ie,e))return Ie[e];var n=Pe(e);return Ie[e]=n,Ne[n]=e,n},keyFor:function(t){if(!He(t))throw TypeError(t+" is not a symbol");if(w(Ne,t))return Ne[t]},useSetter:function(){ze=!0},useSimple:function(){ze=!1}}),G({target:"Object",stat:!0,forced:!wt,sham:!a},{create:function(t,e){return void 0===e?Rt(t):Be(Rt(t),e)},defineProperty:Ue,defineProperties:Be,getOwnPropertyDescriptor:Xe}),G({target:"Object",stat:!0,forced:!wt},{getOwnPropertyNames:qe,getOwnPropertySymbols:Je}),G({target:"Object",stat:!0,forced:o((function(){ft.f(1)}))},{getOwnPropertySymbols:function(t){return ft.f(xt(t))}}),Ae){var $e=!wt||o((function(){var t=Pe();return"[null]"!=Ae([t])||"{}"!=Ae({a:t})||"{}"!=Ae(Object(t))}));G({target:"JSON",stat:!0,forced:$e},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(m(e)||void 0!==t)&&!He(t))return St(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!He(e))return e}),i[1]=e,Ae.apply(null,i)}})}Pe.prototype[ke]||F(Pe.prototype,ke,Pe.prototype.valueOf),re(Pe,"Symbol"),et[Oe]=!0;var Qe,Ke,tn,en=Y.Object.getOwnPropertySymbols,nn={},rn=!o((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),on=Et("IE_PROTO"),an=Object.prototype,sn=rn?Object.getPrototypeOf:function(t){return t=xt(t),w(t,on)?t[on]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?an:null},un=(Ut("iterator"),!1);[].keys&&("next"in(tn=[].keys())?(Ke=sn(sn(tn)))!==Object.prototype&&(Qe=Ke):un=!0),null==Qe&&(Qe={});var cn={IteratorPrototype:Qe,BUGGY_SAFARI_ITERATORS:un},ln=cn.IteratorPrototype,hn=function(){return this},fn=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}}(),cn.IteratorPrototype),dn=cn.BUGGY_SAFARI_ITERATORS,pn=Ut("iterator"),yn=function(){return this},vn=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Rt(ln,{next:l(1,n)}),re(t,r,!1,!0),nn[r]=hn}(n,e,r);var s,u,c,h=function(t){if(t===i&&v)return v;if(!dn&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},f=e+" Iterator",d=!1,p=t.prototype,y=p[pn]||p["@@iterator"]||i&&p[i],v=!dn&&y||h(i),m="Array"==e&&p.entries||y;if(m&&(s=sn(m.call(new t)),fn!==Object.prototype&&s.next&&(re(s,f,!0,!0),nn[f]=yn)),"values"==i&&y&&"values"!==y.name&&(d=!0,v=function(){return y.call(this)}),a&&p[pn]!==v&&F(p,pn,v),nn[e]=v,i)if(u={values:h("values"),keys:o?v:h("keys"),entries:h("entries")},a)for(c in u)!dn&&!d&&c in p||zt(p,c,u[c]);else G({target:e,proto:!0,forced:dn||d},u);return u},mn=me.set,gn=me.getterFor("Array Iterator");vn(Array,"Array",(function(t,e){mn(this,{type:"Array Iterator",target:v(t),index:0,kind:e})}),(function(){var t=gn(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");nn.Arguments=nn.Array;var _n=Ut("toStringTag");for(var wn in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var bn=i[wn],Sn=bn&&bn.prototype;Sn&&!Sn[_n]&&F(Sn,_n,wn),nn[wn]=nn.Array}var xn=function(t){return function(e,n){var r,i,o=String(y(e)),a=Z(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},On={codeAt:xn(!1),charAt:xn(!0)}.charAt,kn=me.set,Mn=me.getterFor("String Iterator");vn(String,"String",(function(t){kn(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Mn(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=On(n,r),e.index+=t.length,{value:t,done:!1})}));var Dn=Ut("iterator"),Tn=function(t){if(null!=t)return t[Dn]||t["@@iterator"]||nn[Kt(t)]},Pn=function(t){var e=Tn(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return R(e.call(t))};G({target:"Object",stat:!0,sham:!a},{create:Rt});var An=Y.Object,En=function(t,e){return An.create(t,e)},Ln=V;var Cn=function(t,e,n){return e in t?Ln(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):t[e]=n,t},Yn=o((function(){ot(1)}));G({target:"Object",stat:!0,forced:Yn},{keys:function(t){return ot(xt(t))}});var jn,Rn=Y.Object.keys,In="\t\n\v\f\r                　\u2028\u2029\ufeff",Nn="["+In+"]",Fn=RegExp("^"+Nn+Nn+"*"),Wn=RegExp(Nn+Nn+"*$"),zn=function(t){return function(e){var n=String(y(e));return 1&t&&(n=n.replace(Fn,"")),2&t&&(n=n.replace(Wn,"")),n}},Gn={start:zn(1),end:zn(2),trim:zn(3)},Vn=Gn.trim;G({target:"String",proto:!0,forced:(jn="trim",o((function(){return!!In[jn]()||"​᠎"!="​᠎"[jn]()||In[jn].name!==jn})))},{trim:function(){return Vn(this)}});var Hn=function(t){return Y[t+"Prototype"]},Un=Hn("String").trim,Bn=String.prototype,Zn=function(t){var e=t.trim;return"string"==typeof t||t===Bn||t instanceof String&&e===Bn.trim?Un:e},Xn=function(t,e){var n=[][t];return!n||!o((function(){n.call(null,e||function(){throw 1},1)}))},qn=Se.forEach,Jn=Xn("forEach")?function(t){return qn(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;G({target:"Array",proto:!0,forced:[].forEach!=Jn},{forEach:Jn});var $n,Qn,Kn=Hn("Array").forEach,tr=Array.prototype,er={DOMTokenList:!0,NodeList:!0},nr=function(t){var e=t.forEach;return t===tr||t instanceof Array&&e===tr.forEach||er.hasOwnProperty(Kt(t))?Kn:e},rr=ct("navigator","userAgent")||"",ir=i.process,or=ir&&ir.versions,ar=or&&or.v8;ar?Qn=($n=ar.split("."))[0]+$n[1]:rr&&(!($n=rr.match(/Edge\/(\d+)/))||$n[1]>=74)&&($n=rr.match(/Chrome\/(\d+)/))&&(Qn=$n[1]);var sr=Qn&&+Qn,ur=Ut("species"),cr=function(t){return sr>=51||!o((function(){var e=[];return(e.constructor={})[ur]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},lr=Se.map,hr=cr("map"),fr=hr&&!o((function(){[].map.call({length:-1,0:1},(function(t){throw t}))}));G({target:"Array",proto:!0,forced:!hr||!fr},{map:function(t){return lr(this,t,arguments.length>1?arguments[1]:void 0)}});var dr=Hn("Array").map,pr=Array.prototype,yr=function(t){var e=t.map;return t===pr||t instanceof Array&&e===pr.map?dr:e},vr=Gn.trim,mr=i.parseInt,gr=/^[+-]?0[Xx]/,_r=8!==mr(In+"08")||22!==mr(In+"0x16")?function(t,e){var n=vr(String(t));return mr(n,e>>>0||(gr.test(n)?16:10))}:mr;G({global:!0,forced:parseInt!=_r},{parseInt:_r});var wr=Y.parseInt,br=c.f,Sr=function(t){return function(e){for(var n,r=v(e),i=ot(r),o=i.length,s=0,u=[];o>s;)n=i[s++],a&&!br.call(r,n)||u.push(t?[n,r[n]]:r[n]);return u}},xr={entries:Sr(!0),values:Sr(!1)}.values;G({target:"Object",stat:!0},{values:function(t){return xr(t)}});var Or=Y.Object.values,kr=Se.filter,Mr=cr("filter"),Dr=Mr&&!o((function(){[].filter.call({length:-1,0:1},(function(t){throw t}))}));G({target:"Array",proto:!0,forced:!Mr||!Dr},{filter:function(t){return kr(this,t,arguments.length>1?arguments[1]:void 0)}});var Tr=Hn("Array").filter,Pr=Array.prototype,Ar=function(t){var e=t.filter;return t===Pr||t instanceof Array&&e===Pr.filter?Tr:e},Er=Ut("isConcatSpreadable"),Lr=sr>=51||!o((function(){var t=[];return t[Er]=!1,t.concat()[0]!==t})),Cr=cr("concat"),Yr=function(t){if(!m(t))return!1;var e=t[Er];return void 0!==e?!!e:St(t)};G({target:"Array",proto:!0,forced:!Lr||!Cr},{concat:function(t){var e,n,r,i,o,a=xt(this),s=_e(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],Yr(o)){if(u+(i=q(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,u++)n in o&&pt(s,u,o[n])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");pt(s,u++,o)}return s.length=u,s}});var jr=Hn("Array").concat,Rr=Array.prototype,Ir=function(t){var e=t.concat;return t===Rr||t instanceof Array&&e===Rr.concat?jr:e};G({target:"Array",stat:!0},{isArray:St});var Nr=Y.Array.isArray,Fr=Nr;var Wr=function(t){if(Fr(t)){for(var e=0,n=new Array(t.length);e<t.length;e++)n[e]=t[e];return n}},zr=function(t,e,n,r){try{return r?e(R(n)[0],n[1]):e(n)}catch(e){var i=t.return;throw void 0!==i&&R(i.call(t)),e}},Gr=Ut("iterator"),Vr=Array.prototype,Hr=function(t){return void 0!==t&&(nn.Array===t||Vr[Gr]===t)},Ur=Ut("iterator"),Br=!1;try{var Zr=0,Xr={next:function(){return{done:!!Zr++}},return:function(){Br=!0}};Xr[Ur]=function(){return this},Array.from(Xr,(function(){throw 2}))}catch(t){}var qr=!function(t,e){if(!e&&!Br)return!1;var n=!1;try{var r={};r[Ur]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));G({target:"Array",stat:!0,forced:qr},{from:function(t){var e,n,r,i,o,a=xt(t),s="function"==typeof this?this:Array,u=arguments.length,c=u>1?arguments[1]:void 0,l=void 0!==c,h=0,f=Tn(a);if(l&&(c=j(c,u>2?arguments[2]:void 0,2)),null==f||s==Array&&Hr(f))for(n=new s(e=q(a.length));e>h;h++)pt(n,h,l?c(a[h],h):a[h]);else for(o=(i=f.call(a)).next,n=new s;!(r=o.call(i)).done;h++)pt(n,h,l?zr(i,c,[r.value,h],!0):r.value);return n.length=h,n}});var Jr=Y.Array.from,$r=Ut("iterator"),Qr=function(t){var e=Object(t);return void 0!==e[$r]||"@@iterator"in e||nn.hasOwnProperty(Kt(e))};var Kr=function(t){if(Qr(Object(t))||"[object Arguments]"===Object.prototype.toString.call(t))return Jr(t)};var ti=function(){throw new TypeError("Invalid attempt to spread non-iterable instance")};var ei=function(t){return Wr(t)||Kr(t)||ti()},ni=Ut("species"),ri=[].slice,ii=Math.max;G({target:"Array",proto:!0,forced:!cr("slice")},{slice:function(t,e){var n,r,i,o=v(this),a=q(o.length),s=Q(t,a),u=Q(void 0===e?a:e,a);if(St(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!St(n.prototype)?m(n)&&null===(n=n[ni])&&(n=void 0):n=void 0,n===Array||void 0===n))return ri.call(o,s,u);for(r=new(void 0===n?Array:n)(ii(u-s,0)),i=0;s<u;s++,i++)s in o&&pt(r,i,o[s]);return r.length=i,r}});var oi=Hn("Array").slice,ai=Array.prototype,si=function(t){var e=t.slice;return t===ai||t instanceof Array&&e===ai.slice?oi:e},ui=o((function(){sn(1)}));G({target:"Object",stat:!0,forced:ui,sham:!rn},{getPrototypeOf:function(t){return sn(xt(t))}});var ci=Y.Object.getPrototypeOf,li=tt.indexOf,hi=[].indexOf,fi=!!hi&&1/[1].indexOf(1,-0)<0,di=Xn("indexOf");G({target:"Array",proto:!0,forced:fi||di},{indexOf:function(t){return fi?hi.apply(this,arguments)||0:li(this,t,arguments.length>1?arguments[1]:void 0)}});var pi=Hn("Array").indexOf,yi=Array.prototype,vi=function(t){var e=t.indexOf;return t===yi||t instanceof Array&&e===yi.indexOf?pi:e},mi=Nr,gi=Object.assign,_i=Object.defineProperty,wi=!gi||o((function(){if(a&&1!==gi({b:1},gi(_i({},"a",{enumerable:!0,get:function(){_i(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=gi({},t)[n]||"abcdefghijklmnopqrst"!=ot(gi({},e)).join("")}))?function(t,e){for(var n=xt(t),r=arguments.length,i=1,o=ft.f,s=c.f;r>i;)for(var u,l=p(arguments[i++]),h=o?ot(l).concat(o(l)):ot(l),f=h.length,d=0;f>d;)u=h[d++],a&&!s.call(l,u)||(n[u]=l[u]);return n}:gi;G({target:"Object",stat:!0,forced:Object.assign!==wi},{assign:wi});var bi=Y.Object.assign;Xt("iterator");var Si=Bt.f("iterator");Xt("asyncIterator"),Xt("hasInstance"),Xt("isConcatSpreadable"),Xt("match"),Xt("matchAll"),Xt("replace"),Xt("search"),Xt("species"),Xt("split"),Xt("toPrimitive"),Xt("toStringTag"),Xt("unscopables"),re(Math,"Math",!0),re(i.JSON,"JSON",!0);var xi=Y.Symbol;Xt("asyncDispose"),Xt("dispose"),Xt("observable"),Xt("patternMatch"),Xt("replaceAll");for(var Oi=xi,ki=n((function(t){function e(n){return t.exports=e="function"==typeof Oi&&"symbol"==typeof Si?function(t){return typeof t}:function(t){return t&&"function"==typeof Oi&&t.constructor===Oi&&t!==Oi.prototype?"symbol":typeof t},e(n)}t.exports=e})),Mi=[],Di=0;Di<256;Di++)Mi[Di]=(Di+256).toString(16).substr(1);for(var Ti=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,n=0;n<16;n++)0==(3&n)&&(t=4294967296*Math.random()),e[n]=t>>>((3&n)<<3)&255;return e}}(),Pi=[],Ai=0;Ai<256;Ai++)Pi[Ai]=(Ai+256).toString(16).substr(1);var Ei=Ti();Ei[0],Ei[1],Ei[2],Ei[3],Ei[4],Ei[5],Ei[6],Ei[7];function Li(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},e=arguments.length>1?arguments[1]:void 0,n=arguments.length>2?arguments[2]:void 0,r=e&&n||0;"string"==typeof t&&(e="binary"===t?new Array(16):void 0,t={});var i=t.random||(t.rng||Ti)();if(i[6]=15&i[6]|64,i[8]=63&i[8]|128,e)for(var o=0;o<16;o++)e[r+o]=i[o];return e||function(t,e){var n=e||0,r=Mi;return r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]}(i)}function Ci(t,e){var n=Rn(t);if(en){var r=en(t);e&&(r=Ar(r).call(r,(function(e){return _t(t,e).enumerable}))),n.push.apply(n,r)}return n}var Yi=/^\/?Date\((-?\d+)/i,ji=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Ri=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Ii=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Ni=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Fi(t){return t instanceof Number||"number"==typeof t}function Wi(t){if(t)for(;!0===t.hasChildNodes();){var e=t.firstChild;e&&(Wi(e),t.removeChild(e))}}function zi(t){return t instanceof String||"string"==typeof t}function Gi(t){return"object"===ki(t)&&null!==t}function Vi(t){if(t instanceof Date)return!0;if(zi(t)){if(Yi.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1}function Hi(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}function Ui(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var r in t)if(void 0!==e[r])if(null===e[r]||"object"!==ki(e[r]))Hi(t,e,r,n);else{var i=t[r],o=e[r];Gi(i)&&Gi(o)&&Ui(i,o,n)}}var Bi=bi;function Zi(t,e){if(!mi(t))throw new Error("Array with property names expected as first argument");for(var n=arguments.length,r=new Array(n>2?n-2:0),i=2;i<n;i++)r[i-2]=arguments[i];for(var o=0,a=r;o<a.length;o++)for(var s=a[o],u=0;u<t.length;u++){var c=t[u];s&&Object.prototype.hasOwnProperty.call(s,c)&&(e[c]=s[c])}return e}function Xi(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(mi(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(n,o))if(n[o]&&n[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Ji(e[o],n[o],!1,r):Hi(e,n,o,r);else{if(mi(n[o]))throw new TypeError("Arrays are not supported by deepExtend");Hi(e,n,o,r)}}return e}function qi(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(mi(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i in n)if(Object.prototype.hasOwnProperty.call(n,i)&&-1===vi(t).call(t,i))if(n[i]&&n[i].constructor===Object)void 0===e[i]&&(e[i]={}),e[i].constructor===Object?Ji(e[i],n[i]):Hi(e,n,i,r);else if(mi(n[i])){e[i]=[];for(var o=0;o<n[i].length;o++)e[i].push(n[i][o])}else Hi(e,n,i,r);return e}function Ji(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===n)if("object"===ki(e[i])&&null!==e[i]&&ci(e[i])===Object.prototype)void 0===t[i]?t[i]=Ji({},e[i],n):"object"===ki(t[i])&&null!==t[i]&&ci(t[i])===Object.prototype?Ji(t[i],e[i],n):Hi(t,e,i,r);else if(mi(e[i])){var o;t[i]=si(o=e[i]).call(o)}else Hi(t,e,i,r);return t}function $i(t,e){if(t.length!==e.length)return!1;for(var n=0,r=t.length;n<r;n++)if(t[n]!=e[n])return!1;return!0}function Qi(t){var e=ki(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":mi(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Ki(t,e){var n;return Ir(n=[]).call(n,ei(t),[e])}function to(t){return si(t).call(t)}function eo(t){return t.getBoundingClientRect().left}function no(t){return t.getBoundingClientRect().right}function ro(t){return t.getBoundingClientRect().top}function io(t,e){var n=t.className.split(" "),r=e.split(" ");n=Ir(n).call(n,Ar(r).call(r,(function(t){return vi(n).call(n,t)<0}))),t.className=n.join(" ")}function oo(t,e){var n=t.className.split(" "),r=e.split(" ");n=Ar(n).call(n,(function(t){return vi(r).call(r,t)<0})),t.className=n.join(" ")}function ao(t,e){if(mi(t))for(var n=t.length,r=0;r<n;r++)e(t[r],r,t);else for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&e(t[i],i,t)}var so=Or;function uo(t,e,n){return t[e]!==n&&(t[e]=n,!0)}function co(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}}function lo(t,e,n,r){var i;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&vi(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,n,r)):t.attachEvent("on"+e,n)}function ho(t,e,n,r){var i;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&vi(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,n,r)):t.detachEvent("on"+e,n)}function fo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function po(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null}function yo(t,e){for(var n=t;n;){if(n===e)return!0;if(!n.parentNode)return!1;n=n.parentNode}return!1}var vo={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),zi(t)?t:Fi(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function mo(t){var e;switch(t.length){case 3:case 4:return(e=Ri.exec(t))?{r:wr(e[1]+e[1],16),g:wr(e[2]+e[2],16),b:wr(e[3]+e[3],16)}:null;case 6:case 7:return(e=ji.exec(t))?{r:wr(e[1],16),g:wr(e[2],16),b:wr(e[3],16)}:null;default:return null}}function go(t,e){if(-1!==vi(t).call(t,"rgba"))return t;if(-1!==vi(t).call(t,"rgb")){var n=t.substr(vi(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+n[0]+","+n[1]+","+n[2]+","+e+")"}var r=mo(t);return null==r?t:"rgba("+r.r+","+r.g+","+r.b+","+e+")"}function _o(t,e,n){var r;return"#"+si(r=((1<<24)+(t<<16)+(e<<8)+n).toString(16)).call(r,1)}function wo(t,e){if(zi(t)){var n=t;if(Po(n)){var r,i=yr(r=n.substr(4).substr(0,n.length-5).split(",")).call(r,(function(t){return wr(t)}));n=_o(i[0],i[1],i[2])}if(!0===To(n)){var o=Do(n),a={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},s={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},u=Mo(s.h,s.s,s.v),c=Mo(a.h,a.s,a.v);return{background:n,border:u,highlight:{background:c,border:u},hover:{background:c,border:u}}}return{background:n,border:n,highlight:{background:n,border:n},hover:{background:n,border:n}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:zi(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:zi(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:zi(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:zi(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}}function bo(t,e,n){t/=255,e/=255,n/=255;var r=Math.min(t,Math.min(e,n)),i=Math.max(t,Math.max(e,n));return r===i?{h:0,s:0,v:r}:{h:60*((t===r?3:n===r?1:5)-(t===r?e-n:n===r?t-e:n-t)/(i-r))/360,s:(i-r)/i,v:i}}var So={split:function(t){var e,n={};return nr(e=t.split(";")).call(e,(function(t){if(""!=Zn(t).call(t)){var e,r,i=t.split(":"),o=Zn(e=i[0]).call(e),a=Zn(r=i[1]).call(r);n[o]=a}})),n},join:function(t){var e;return yr(e=Rn(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function xo(t,e){var n=function(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)nr(n=Ci(Object(r),!0)).call(n,(function(e){Cn(t,e,r[e])}));else if(yt)st(t,yt(r));else{var i;nr(i=Ci(Object(r))).call(i,(function(e){H(t,e,_t(r,e))}))}}return t}({},So.split(t.style.cssText),{},So.split(e));t.style.cssText=So.join(n)}function Oo(t,e){var n=So.split(t.style.cssText),r=So.split(e);for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&delete n[i];t.style.cssText=So.join(n)}function ko(t,e,n){var r,i,o,a=Math.floor(6*t),s=6*t-a,u=n*(1-e),c=n*(1-s*e),l=n*(1-(1-s)*e);switch(a%6){case 0:r=n,i=l,o=u;break;case 1:r=c,i=n,o=u;break;case 2:r=u,i=n,o=l;break;case 3:r=u,i=c,o=n;break;case 4:r=l,i=u,o=n;break;case 5:r=n,i=u,o=c}return{r:Math.floor(255*r),g:Math.floor(255*i),b:Math.floor(255*o)}}function Mo(t,e,n){var r=ko(t,e,n);return _o(r.r,r.g,r.b)}function Do(t){var e=mo(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return bo(e.r,e.g,e.b)}function To(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function Po(t){return Ii.test(t)}function Ao(t){return Ni.test(t)}function Eo(t,e){if(null!==e&&"object"===ki(e)){for(var n=En(e),r=0;r<t.length;r++)Object.prototype.hasOwnProperty.call(e,t[r])&&"object"==ki(e[t[r]])&&(n[t[r]]=Lo(e[t[r]]));return n}return null}function Lo(t){if(null===t||"object"!==ki(t))return null;if(t instanceof Element)return t;var e=En(t);for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&"object"==ki(t[n])&&(e[n]=Lo(t[n]));return e}function Co(t,e){for(var n=0;n<t.length;n++){var r=t[n],i=void 0;for(i=n;i>0&&e(r,t[i-1])<0;i--)t[i]=t[i-1];t[i]=r}return t}function Yo(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=function(t){return null!=t},o=function(t){return null!==t&&"object"===ki(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!i(n))throw new Error("Parameter option must have a value");if(!o(r))throw new Error("Parameter globalOptions must be an object");var a=e[n],s=o(r)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(r)?r[n]:void 0,u=s?s.enabled:void 0;if(void 0!==a){if("boolean"==typeof a)return o(t[n])||(t[n]={}),void(t[n].enabled=a);if(null===a&&!o(t[n])){if(!i(s))return;t[n]=En(s)}if(o(a)){var c=!0;void 0!==a.enabled?c=a.enabled:void 0!==u&&(c=s.enabled),function(t,e,n){o(t[n])||(t[n]={});var r=e[n],i=t[n];for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(i[a]=r[a])}(t,e,n),t[n].enabled=c}}}function jo(t,e,n,r){for(var i=0,o=0,a=t.length-1;o<=a&&i<1e4;){var s=Math.floor((o+a)/2),u=t[s],c=e(void 0===r?u[n]:u[n][r]);if(0==c)return s;-1==c?o=s+1:a=s-1,i++}return-1}function Ro(t,e,n,r,i){var o,a,s,u,c=0,l=0,h=t.length-1;for(i=null!=i?i:function(t,e){return t==e?0:t<e?-1:1};l<=h&&c<1e4;){if(u=Math.floor(.5*(h+l)),o=t[Math.max(0,u-1)][n],a=t[u][n],s=t[Math.min(t.length-1,u+1)][n],0==i(a,e))return u;if(i(o,e)<0&&i(a,e)>0)return"before"==r?Math.max(0,u-1):u;if(i(a,e)<0&&i(s,e)>0)return"before"==r?u:Math.min(t.length-1,u+1);i(a,e)<0?l=u+1:h=u-1,c++}return-1}var Io={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}};function No(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var n=t.offsetWidth;e.style.overflow="scroll";var r=t.offsetWidth;return n==r&&(r=e.clientWidth),document.body.removeChild(e),n-r}function Fo(t,e){var n;mi(e)||(e=[e]);var r=!0,i=!1,o=void 0;try{for(var a,s=Pn(t);!(r=(a=s.next()).done);r=!0){var u=a.value;if(u){n=u[e[0]];for(var c=1;c<e.length;c++)n&&(n=n[e[c]]);if(void 0!==n)break}}}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return n}var Wo=Object.freeze({__proto__:null,isNumber:Fi,recursiveDOMDelete:Wi,isString:zi,isObject:Gi,isDate:Vi,fillIfDefined:Ui,extend:Bi,selectiveExtend:Zi,selectiveDeepExtend:Xi,selectiveNotDeepExtend:qi,deepExtend:Ji,equalArray:$i,getType:Qi,copyAndExtendArray:Ki,copyArray:to,getAbsoluteLeft:eo,getAbsoluteRight:no,getAbsoluteTop:ro,addClassName:io,removeClassName:oo,forEach:ao,toArray:so,updateProperty:uo,throttle:co,addEventListener:lo,removeEventListener:ho,preventDefault:fo,getTarget:po,hasParent:yo,option:vo,hexToRGB:mo,overrideOpacity:go,RGBToHex:_o,parseColor:wo,RGBToHSV:bo,addCssText:xo,removeCssText:Oo,HSVToRGB:ko,HSVToHex:Mo,hexToHSV:Do,isValidHex:To,isValidRGB:Po,isValidRGBA:Ao,selectiveBridgeObject:Eo,bridgeObject:Lo,insertSort:Co,mergeOptions:Yo,binarySearchCustom:jo,binarySearchValue:Ro,easingFunctions:Io,getScrollBarWidth:No,topMost:Fo,randomUUID:Li}),zo=Object.freeze({default:Wo,HSVToHex:Mo,HSVToRGB:ko,RGBToHSV:bo,RGBToHex:_o,addClassName:io,addCssText:xo,addEventListener:lo,binarySearchCustom:jo,binarySearchValue:Ro,bridgeObject:Lo,copyAndExtendArray:Ki,copyArray:to,deepExtend:Ji,easingFunctions:Io,equalArray:$i,extend:Bi,fillIfDefined:Ui,forEach:ao,getAbsoluteLeft:eo,getAbsoluteRight:no,getAbsoluteTop:ro,getScrollBarWidth:No,getTarget:po,getType:Qi,hasParent:yo,hexToHSV:Do,hexToRGB:mo,insertSort:Co,isDate:Vi,isNumber:Fi,isObject:Gi,isString:zi,isValidHex:To,isValidRGB:Po,isValidRGBA:Ao,mergeOptions:Yo,option:vo,overrideOpacity:go,parseColor:wo,preventDefault:fo,randomUUID:Li,recursiveDOMDelete:Wi,removeClassName:oo,removeCssText:Oo,removeEventListener:ho,selectiveBridgeObject:Eo,selectiveDeepExtend:Xi,selectiveExtend:Zi,selectiveNotDeepExtend:qi,throttle:co,toArray:so,topMost:Fo,updateProperty:uo}),Go="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Vo(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function Ho(t,e){return t(e={exports:{}},e.exports),e.exports}function Uo(t){return t&&t.default||t}var Bo=Ho((function(t,e){e.prepareElements=function(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])},e.cleanupElements=function(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var n=0;n<t[e].redundant.length;n++)t[e].redundant[n].parentNode.removeChild(t[e].redundant[n]);t[e].redundant=[]}},e.resetElements=function(t){e.prepareElements(t),e.cleanupElements(t),e.prepareElements(t)},e.getSVGElement=function(t,e,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElementNS("http://www.w3.org/2000/svg",t),n.appendChild(r)):(r=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},n.appendChild(r)),e[t].used.push(r),r},e.getDOMElement=function(t,e,n,r){var i;return e.hasOwnProperty(t)?e[t].redundant.length>0?(i=e[t].redundant[0],e[t].redundant.shift()):(i=document.createElement(t),void 0!==r?n.insertBefore(i,r):n.appendChild(i)):(i=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==r?n.insertBefore(i,r):n.appendChild(i)),e[t].used.push(i),i},e.drawPoint=function(t,n,r,i,o,a){var s;if("circle"==r.style?((s=e.getSVGElement("circle",i,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",n),s.setAttributeNS(null,"r",.5*r.size)):((s=e.getSVGElement("rect",i,o)).setAttributeNS(null,"x",t-.5*r.size),s.setAttributeNS(null,"y",n-.5*r.size),s.setAttributeNS(null,"width",r.size),s.setAttributeNS(null,"height",r.size)),void 0!==r.styles&&s.setAttributeNS(null,"style",r.styles),s.setAttributeNS(null,"class",r.className+" vis-point"),a){var u=e.getSVGElement("text",i,o);a.xOffset&&(t+=a.xOffset),a.yOffset&&(n+=a.yOffset),a.content&&(u.textContent=a.content),a.className&&u.setAttributeNS(null,"class",a.className+" vis-label"),u.setAttributeNS(null,"x",t),u.setAttributeNS(null,"y",n)}return s},e.drawBar=function(t,n,r,i,o,a,s,u){if(0!=i){i<0&&(n-=i*=-1);var c=e.getSVGElement("rect",a,s);c.setAttributeNS(null,"x",t-.5*r),c.setAttributeNS(null,"y",n),c.setAttributeNS(null,"width",r),c.setAttributeNS(null,"height",i),c.setAttributeNS(null,"class",o),u&&c.setAttributeNS(null,"style",u)}}})),Zo=(Bo.prepareElements,Bo.cleanupElements,Bo.resetElements,Bo.getSVGElement,Bo.getDOMElement,Bo.drawPoint,Bo.drawBar,"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{});function Xo(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function qo(t,e){return t(e={exports:{}},e.exports),e.exports}var Jo=function(t){return t&&t.Math==Math&&t},$o=Jo("object"==typeof globalThis&&globalThis)||Jo("object"==typeof window&&window)||Jo("object"==typeof self&&self)||Jo("object"==typeof Zo&&Zo)||Function("return this")(),Qo=function(t){try{return!!t()}catch(t){return!0}},Ko=!Qo((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),ta={}.propertyIsEnumerable,ea=Object.getOwnPropertyDescriptor,na={f:ea&&!ta.call({1:2},1)?function(t){var e=ea(this,t);return!!e&&e.enumerable}:ta},ra=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},ia={}.toString,oa=function(t){return ia.call(t).slice(8,-1)},aa="".split,sa=Qo((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==oa(t)?aa.call(t,""):Object(t)}:Object,ua=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},ca=function(t){return sa(ua(t))},la=function(t){return"object"==typeof t?null!==t:"function"==typeof t},ha=function(t,e){if(!la(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!la(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!la(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!la(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},fa={}.hasOwnProperty,da=function(t,e){return fa.call(t,e)},pa=$o.document,ya=la(pa)&&la(pa.createElement),va=function(t){return ya?pa.createElement(t):{}},ma=!Ko&&!Qo((function(){return 7!=Object.defineProperty(va("div"),"a",{get:function(){return 7}}).a})),ga=Object.getOwnPropertyDescriptor,_a={f:Ko?ga:function(t,e){if(t=ca(t),e=ha(e,!0),ma)try{return ga(t,e)}catch(t){}if(da(t,e))return ra(!na.f.call(t,e),t[e])}},wa=/#|\.prototype\./,ba=function(t,e){var n=xa[Sa(t)];return n==ka||n!=Oa&&("function"==typeof e?Qo(e):!!e)},Sa=ba.normalize=function(t){return String(t).replace(wa,".").toLowerCase()},xa=ba.data={},Oa=ba.NATIVE="N",ka=ba.POLYFILL="P",Ma=ba,Da={},Ta=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},Pa=function(t,e,n){if(Ta(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},Aa=function(t){if(!la(t))throw TypeError(String(t)+" is not an object");return t},Ea=Object.defineProperty,La={f:Ko?Ea:function(t,e,n){if(Aa(t),e=ha(e,!0),Aa(n),ma)try{return Ea(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},Ca=Ko?function(t,e,n){return La.f(t,e,ra(1,n))}:function(t,e,n){return t[e]=n,t},Ya=_a.f,ja=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},Ra=function(t,e){var n,r,i,o,a,s,u,c,l=t.target,h=t.global,f=t.stat,d=t.proto,p=h?$o:f?$o[l]:($o[l]||{}).prototype,y=h?Da:Da[l]||(Da[l]={}),v=y.prototype;for(i in e)n=!Ma(h?i:l+(f?".":"#")+i,t.forced)&&p&&da(p,i),a=y[i],n&&(s=t.noTargetGet?(c=Ya(p,i))&&c.value:p[i]),o=n&&s?s:e[i],n&&typeof a==typeof o||(u=t.bind&&n?Pa(o,$o):t.wrap&&n?ja(o):d&&"function"==typeof o?Pa(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&Ca(u,"sham",!0),y[i]=u,d&&(da(Da,r=l+"Prototype")||Ca(Da,r,{}),Da[r][i]=o,t.real&&v&&!v[i]&&Ca(v,i,o)))};Ra({target:"Object",stat:!0,forced:!Ko,sham:!Ko},{defineProperty:La.f});var Ia=qo((function(t){var e=Da.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)})),Na=Ia,Fa=Math.ceil,Wa=Math.floor,za=function(t){return isNaN(t=+t)?0:(t>0?Wa:Fa)(t)},Ga=Math.min,Va=function(t){return t>0?Ga(za(t),9007199254740991):0},Ha=Math.max,Ua=Math.min,Ba=function(t,e){var n=za(t);return n<0?Ha(n+e,0):Ua(n,e)},Za=function(t){return function(e,n,r){var i,o=ca(e),a=Va(o.length),s=Ba(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},Xa={includes:Za(!0),indexOf:Za(!1)},qa={},Ja=Xa.indexOf,$a=function(t,e){var n,r=ca(t),i=0,o=[];for(n in r)!da(qa,n)&&da(r,n)&&o.push(n);for(;e.length>i;)da(r,n=e[i++])&&(~Ja(o,n)||o.push(n));return o},Qa=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Ka=Object.keys||function(t){return $a(t,Qa)},ts=Ko?Object.defineProperties:function(t,e){Aa(t);for(var n,r=Ka(e),i=r.length,o=0;i>o;)La.f(t,n=r[o++],e[n]);return t};Ra({target:"Object",stat:!0,forced:!Ko,sham:!Ko},{defineProperties:ts});var es=qo((function(t){var e=Da.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)})),ns=function(t){return"function"==typeof t?t:void 0},rs=function(t,e){return arguments.length<2?ns(Da[t])||ns($o[t]):Da[t]&&Da[t][e]||$o[t]&&$o[t][e]},is=Qa.concat("length","prototype"),os={f:Object.getOwnPropertyNames||function(t){return $a(t,is)}},as={f:Object.getOwnPropertySymbols},ss=rs("Reflect","ownKeys")||function(t){var e=os.f(Aa(t)),n=as.f;return n?e.concat(n(t)):e},us=function(t,e,n){var r=ha(e);r in t?La.f(t,r,ra(0,n)):t[r]=n};Ra({target:"Object",stat:!0,sham:!Ko},{getOwnPropertyDescriptors:function(t){for(var e,n,r=ca(t),i=_a.f,o=ss(r),a={},s=0;o.length>s;)void 0!==(n=i(r,e=o[s++]))&&us(a,e,n);return a}});var cs,ls,hs,fs=Da.Object.getOwnPropertyDescriptors,ds={},ps=$o["__core-js_shared__"]||function(t,e){try{Ca($o,t,e)}catch(n){$o[t]=e}return e}("__core-js_shared__",{}),ys=qo((function(t){(t.exports=function(t,e){return ps[t]||(ps[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.4.5",mode:"pure",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),vs=Function.toString,ms=ys("inspectSource",(function(t){return vs.call(t)})),gs=$o.WeakMap,_s="function"==typeof gs&&/native code/.test(ms(gs)),ws=0,bs=Math.random(),Ss=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++ws+bs).toString(36)},xs=ys("keys"),Os=function(t){return xs[t]||(xs[t]=Ss(t))},ks=$o.WeakMap;if(_s){var Ms=new ks,Ds=Ms.get,Ts=Ms.has,Ps=Ms.set;cs=function(t,e){return Ps.call(Ms,t,e),e},ls=function(t){return Ds.call(Ms,t)||{}},hs=function(t){return Ts.call(Ms,t)}}else{var As=Os("state");qa[As]=!0,cs=function(t,e){return Ca(t,As,e),e},ls=function(t){return da(t,As)?t[As]:{}},hs=function(t){return da(t,As)}}var Es,Ls,Cs,Ys={set:cs,get:ls,has:hs,enforce:function(t){return hs(t)?ls(t):cs(t,{})},getterFor:function(t){return function(e){var n;if(!la(e)||(n=ls(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},js=function(t){return Object(ua(t))},Rs=!Qo((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Is=Os("IE_PROTO"),Ns=Object.prototype,Fs=Rs?Object.getPrototypeOf:function(t){return t=js(t),da(t,Is)?t[Is]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ns:null},Ws=!!Object.getOwnPropertySymbols&&!Qo((function(){return!String(Symbol())})),zs=Ws&&!Symbol.sham&&"symbol"==typeof Symbol(),Gs=ys("wks"),Vs=$o.Symbol,Hs=zs?Vs:Ss,Us=function(t){return da(Gs,t)||(Ws&&da(Vs,t)?Gs[t]=Vs[t]:Gs[t]=Hs("Symbol."+t)),Gs[t]},Bs=(Us("iterator"),!1);[].keys&&("next"in(Cs=[].keys())?(Ls=Fs(Fs(Cs)))!==Object.prototype&&(Es=Ls):Bs=!0),null==Es&&(Es={});var Zs={IteratorPrototype:Es,BUGGY_SAFARI_ITERATORS:Bs},Xs=rs("document","documentElement"),qs=Os("IE_PROTO"),Js=function(){},$s=function(){var t,e=va("iframe"),n=Qa.length;for(e.style.display="none",Xs.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write("<script>document.F=Object<\/script>"),t.close(),$s=t.F;n--;)delete $s.prototype[Qa[n]];return $s()},Qs=Object.create||function(t,e){var n;return null!==t?(Js.prototype=Aa(t),n=new Js,Js.prototype=null,n[qs]=t):n=$s(),void 0===e?n:ts(n,e)};qa[qs]=!0;var Ks={};Ks[Us("toStringTag")]="z";var tu="[object z]"===String(Ks),eu=Us("toStringTag"),nu="Arguments"==oa(function(){return arguments}()),ru=tu?oa:function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),eu))?n:nu?oa(e):"Object"==(r=oa(e))&&"function"==typeof e.callee?"Arguments":r},iu=tu?{}.toString:function(){return"[object "+ru(this)+"]"},ou=La.f,au=Us("toStringTag"),su=function(t,e,n,r){if(t){var i=n?t:t.prototype;da(i,au)||ou(i,au,{configurable:!0,value:e}),r&&!tu&&Ca(i,"toString",iu)}},uu=Zs.IteratorPrototype,cu=function(){return this},lu=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}return function(n,r){return Aa(n),function(t){if(!la(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(r),e?t.call(n,r):n.__proto__=r,n}}():void 0),hu=function(t,e,n,r){r&&r.enumerable?t[e]=n:Ca(t,e,n)},fu=Zs.IteratorPrototype,du=Zs.BUGGY_SAFARI_ITERATORS,pu=Us("iterator"),yu=function(){return this},vu=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Qs(uu,{next:ra(1,n)}),su(t,r,!1,!0),ds[r]=cu}(n,e,r);var s,u,c,l=function(t){if(t===i&&y)return y;if(!du&&t in d)return d[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},h=e+" Iterator",f=!1,d=t.prototype,p=d[pu]||d["@@iterator"]||i&&d[i],y=!du&&p||l(i),v="Array"==e&&d.entries||p;if(v&&(s=Fs(v.call(new t)),fu!==Object.prototype&&s.next&&(su(s,h,!0,!0),ds[h]=yu)),"values"==i&&p&&"values"!==p.name&&(f=!0,y=function(){return p.call(this)}),a&&d[pu]!==y&&Ca(d,pu,y),ds[e]=y,i)if(u={values:l("values"),keys:o?y:l("keys"),entries:l("entries")},a)for(c in u)!du&&!f&&c in d||hu(d,c,u[c]);else Ra({target:e,proto:!0,forced:du||f},u);return u},mu=Ys.set,gu=Ys.getterFor("Array Iterator");vu(Array,"Array",(function(t,e){mu(this,{type:"Array Iterator",target:ca(t),index:0,kind:e})}),(function(){var t=gu(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");ds.Arguments=ds.Array;var _u=Us("toStringTag");for(var wu in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var bu=$o[wu],Su=bu&&bu.prototype;Su&&!Su[_u]&&Ca(Su,_u,wu),ds[wu]=ds.Array}var xu=Array.isArray||function(t){return"Array"==oa(t)},Ou=Us("species"),ku=function(t,e){var n;return xu(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!xu(n.prototype)?la(n)&&null===(n=n[Ou])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},Mu=[].push,Du=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=5==t||o;return function(s,u,c,l){for(var h,f,d=js(s),p=sa(d),y=Pa(u,c,3),v=Va(p.length),m=0,g=l||ku,_=e?g(s,v):n?g(s,0):void 0;v>m;m++)if((a||m in p)&&(f=y(h=p[m],m,d),t))if(e)_[m]=f;else if(f)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:Mu.call(_,h)}else if(i)return!1;return o?-1:r||i?i:_}},Tu={forEach:Du(0),map:Du(1),filter:Du(2),some:Du(3),every:Du(4),find:Du(5),findIndex:Du(6)},Pu=function(t,e){var n=[][t];return!n||!Qo((function(){n.call(null,e||function(){throw 1},1)}))},Au=Tu.forEach,Eu=Pu("forEach")?function(t){return Au(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;Ra({target:"Array",proto:!0,forced:[].forEach!=Eu},{forEach:Eu});var Lu=function(t){return Da[t+"Prototype"]},Cu=Lu("Array").forEach,Yu=Array.prototype,ju={DOMTokenList:!0,NodeList:!0},Ru=function(t){var e=t.forEach;return t===Yu||t instanceof Array&&e===Yu.forEach||ju.hasOwnProperty(ru(t))?Cu:e},Iu=_a.f,Nu=Qo((function(){Iu(1)}));Ra({target:"Object",stat:!0,forced:!Ko||Nu,sham:!Ko},{getOwnPropertyDescriptor:function(t,e){return Iu(ca(t),e)}});var Fu=qo((function(t){var e=Da.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)})),Wu=os.f,zu={}.toString,Gu="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Vu={f:function(t){return Gu&&"[object Window]"==zu.call(t)?function(t){try{return Wu(t)}catch(t){return Gu.slice()}}(t):Wu(ca(t))}},Hu={f:Us},Uu=La.f,Bu=function(t){var e=Da.Symbol||(Da.Symbol={});da(e,t)||Uu(e,t,{value:Hu.f(t)})},Zu=Tu.forEach,Xu=Os("hidden"),qu=Us("toPrimitive"),Ju=Ys.set,$u=Ys.getterFor("Symbol"),Qu=Object.prototype,Ku=$o.Symbol,tc=rs("JSON","stringify"),ec=_a.f,nc=La.f,rc=Vu.f,ic=na.f,oc=ys("symbols"),ac=ys("op-symbols"),sc=ys("string-to-symbol-registry"),uc=ys("symbol-to-string-registry"),cc=ys("wks"),lc=$o.QObject,hc=!lc||!lc.prototype||!lc.prototype.findChild,fc=Ko&&Qo((function(){return 7!=Qs(nc({},"a",{get:function(){return nc(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=ec(Qu,e);r&&delete Qu[e],nc(t,e,n),r&&t!==Qu&&nc(Qu,e,r)}:nc,dc=function(t,e){var n=oc[t]=Qs(Ku.prototype);return Ju(n,{type:"Symbol",tag:t,description:e}),Ko||(n.description=e),n},pc=Ws&&"symbol"==typeof Ku.iterator?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ku},yc=function(t,e,n){t===Qu&&yc(ac,e,n),Aa(t);var r=ha(e,!0);return Aa(n),da(oc,r)?(n.enumerable?(da(t,Xu)&&t[Xu][r]&&(t[Xu][r]=!1),n=Qs(n,{enumerable:ra(0,!1)})):(da(t,Xu)||nc(t,Xu,ra(1,{})),t[Xu][r]=!0),fc(t,r,n)):nc(t,r,n)},vc=function(t,e){Aa(t);var n=ca(e),r=Ka(n).concat(wc(n));return Zu(r,(function(e){Ko&&!mc.call(n,e)||yc(t,e,n[e])})),t},mc=function(t){var e=ha(t,!0),n=ic.call(this,e);return!(this===Qu&&da(oc,e)&&!da(ac,e))&&(!(n||!da(this,e)||!da(oc,e)||da(this,Xu)&&this[Xu][e])||n)},gc=function(t,e){var n=ca(t),r=ha(e,!0);if(n!==Qu||!da(oc,r)||da(ac,r)){var i=ec(n,r);return!i||!da(oc,r)||da(n,Xu)&&n[Xu][r]||(i.enumerable=!0),i}},_c=function(t){var e=rc(ca(t)),n=[];return Zu(e,(function(t){da(oc,t)||da(qa,t)||n.push(t)})),n},wc=function(t){var e=t===Qu,n=rc(e?ac:ca(t)),r=[];return Zu(n,(function(t){!da(oc,t)||e&&!da(Qu,t)||r.push(oc[t])})),r};if(Ws||(hu((Ku=function(){if(this instanceof Ku)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ss(t),n=function(t){this===Qu&&n.call(ac,t),da(this,Xu)&&da(this[Xu],e)&&(this[Xu][e]=!1),fc(this,e,ra(1,t))};return Ko&&hc&&fc(Qu,e,{configurable:!0,set:n}),dc(e,t)}).prototype,"toString",(function(){return $u(this).tag})),na.f=mc,La.f=yc,_a.f=gc,os.f=Vu.f=_c,as.f=wc,Ko&&nc(Ku.prototype,"description",{configurable:!0,get:function(){return $u(this).description}})),zs||(Hu.f=function(t){return dc(Us(t),t)}),Ra({global:!0,wrap:!0,forced:!Ws,sham:!Ws},{Symbol:Ku}),Zu(Ka(cc),(function(t){Bu(t)})),Ra({target:"Symbol",stat:!0,forced:!Ws},{for:function(t){var e=String(t);if(da(sc,e))return sc[e];var n=Ku(e);return sc[e]=n,uc[n]=e,n},keyFor:function(t){if(!pc(t))throw TypeError(t+" is not a symbol");if(da(uc,t))return uc[t]},useSetter:function(){hc=!0},useSimple:function(){hc=!1}}),Ra({target:"Object",stat:!0,forced:!Ws,sham:!Ko},{create:function(t,e){return void 0===e?Qs(t):vc(Qs(t),e)},defineProperty:yc,defineProperties:vc,getOwnPropertyDescriptor:gc}),Ra({target:"Object",stat:!0,forced:!Ws},{getOwnPropertyNames:_c,getOwnPropertySymbols:wc}),Ra({target:"Object",stat:!0,forced:Qo((function(){as.f(1)}))},{getOwnPropertySymbols:function(t){return as.f(js(t))}}),tc){var bc=!Ws||Qo((function(){var t=Ku();return"[null]"!=tc([t])||"{}"!=tc({a:t})||"{}"!=tc(Object(t))}));Ra({target:"JSON",stat:!0,forced:bc},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(la(e)||void 0!==t)&&!pc(t))return xu(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!pc(e))return e}),i[1]=e,tc.apply(null,i)}})}Ku.prototype[qu]||Ca(Ku.prototype,qu,Ku.prototype.valueOf),su(Ku,"Symbol"),qa[Xu]=!0;var Sc=Da.Object.getOwnPropertySymbols,xc=Lu("Array").entries,Oc=Array.prototype,kc={DOMTokenList:!0,NodeList:!0},Mc=function(t){var e=t.entries;return t===Oc||t instanceof Array&&e===Oc.entries||kc.hasOwnProperty(ru(t))?xc:e},Dc=[].slice,Tc={},Pc=function(t,e,n){if(!(e in Tc)){for(var r=[],i=0;i<e;i++)r[i]="a["+i+"]";Tc[e]=Function("C,a","return new C("+r.join(",")+")")}return Tc[e](t,n)},Ac=Function.bind||function(t){var e=Ta(this),n=Dc.call(arguments,1),r=function(){var i=n.concat(Dc.call(arguments));return this instanceof r?Pc(e,i.length,i):e.apply(t,i)};return la(e.prototype)&&(r.prototype=e.prototype),r};Ra({target:"Function",proto:!0},{bind:Ac});var Ec=Lu("Function").bind,Lc=Function.prototype,Cc=function(t){var e=t.bind;return t===Lc||t instanceof Function&&e===Lc.bind?Ec:e},Yc=qo((function(t){var e=function(t){var e,n=Object.prototype,r=n.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",s=i.toStringTag||"@@toStringTag";function u(t,e,n,r){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new D(r||[]);return o._invoke=function(t,e,n){var r=l;return function(i,o){if(r===f)throw new Error("Generator is already running");if(r===d){if("throw"===i)throw o;return P()}for(n.method=i,n.arg=o;;){var a=n.delegate;if(a){var s=O(a,n);if(s){if(s===p)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===l)throw r=d,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=f;var u=c(t,e,n);if("normal"===u.type){if(r=n.done?d:h,u.arg===p)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(r=d,n.method="throw",n.arg=u.arg)}}}(t,n,a),o}function c(t,e,n){try{return{type:"normal",arg:t.call(e,n)}}catch(t){return{type:"throw",arg:t}}}t.wrap=u;var l="suspendedStart",h="suspendedYield",f="executing",d="completed",p={};function y(){}function v(){}function m(){}var g={};g[o]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(T([])));w&&w!==n&&r.call(w,o)&&(g=w);var b=m.prototype=y.prototype=Object.create(g);function S(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function x(t){var e;this._invoke=function(n,i){function o(){return new Promise((function(e,o){!function e(n,i,o,a){var s=c(t[n],t,i);if("throw"!==s.type){var u=s.arg,l=u.value;return l&&"object"==typeof l&&r.call(l,"__await")?Promise.resolve(l.__await).then((function(t){e("next",t,o,a)}),(function(t){e("throw",t,o,a)})):Promise.resolve(l).then((function(t){u.value=t,o(u)}),(function(t){return e("throw",t,o,a)}))}a(s.arg)}(n,i,e,o)}))}return e=e?e.then(o,o):o()}}function O(t,n){var r=t.iterator[n.method];if(r===e){if(n.delegate=null,"throw"===n.method){if(t.iterator.return&&(n.method="return",n.arg=e,O(t,n),"throw"===n.method))return p;n.method="throw",n.arg=new TypeError("The iterator does not provide a 'throw' method")}return p}var i=c(r,t.iterator,n.arg);if("throw"===i.type)return n.method="throw",n.arg=i.arg,n.delegate=null,p;var o=i.arg;return o?o.done?(n[t.resultName]=o.value,n.next=t.nextLoc,"return"!==n.method&&(n.method="next",n.arg=e),n.delegate=null,p):o:(n.method="throw",n.arg=new TypeError("iterator result is not an object"),n.delegate=null,p)}function k(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function M(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function D(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(k,this),this.reset(!0)}function T(t){if(t){var n=t[o];if(n)return n.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function n(){for(;++i<t.length;)if(r.call(t,i))return n.value=t[i],n.done=!1,n;return n.value=e,n.done=!0,n};return a.next=a}}return{next:P}}function P(){return{value:e,done:!0}}return v.prototype=b.constructor=m,m.constructor=v,m[s]=v.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===v||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,s in t||(t[s]="GeneratorFunction")),t.prototype=Object.create(b),t},t.awrap=function(t){return{__await:t}},S(x.prototype),x.prototype[a]=function(){return this},t.AsyncIterator=x,t.async=function(e,n,r,i){var o=new x(u(e,n,r,i));return t.isGeneratorFunction(n)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},S(b),b[s]="Generator",b[o]=function(){return this},b.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var n in t)e.push(n);return e.reverse(),function n(){for(;e.length;){var r=e.pop();if(r in t)return n.value=r,n.done=!1,n}return n.done=!0,n}},t.values=T,D.prototype={constructor:D,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(M),!t)for(var n in this)"t"===n.charAt(0)&&r.call(this,n)&&!isNaN(+n.slice(1))&&(this[n]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var n=this;function i(r,i){return s.type="throw",s.arg=t,n.next=r,i&&(n.method="next",n.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],s=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var u=r.call(a,"catchLoc"),c=r.call(a,"finallyLoc");if(u&&c){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(u){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n];if(i.tryLoc<=this.prev&&r.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,p):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),p},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.finallyLoc===t)return this.complete(n.completion,n.afterLoc),M(n),p}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.tryLoc===t){var r=n.completion;if("throw"===r.type){var i=r.arg;M(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,n,r){return this.delegate={iterator:T(t),resultName:n,nextLoc:r},"next"===this.method&&(this.arg=e),p}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}}));Bu("iterator");var jc=function(t){return function(e,n){var r,i,o=String(ua(e)),a=za(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},Rc={codeAt:jc(!1),charAt:jc(!0)}.charAt,Ic=Ys.set,Nc=Ys.getterFor("String Iterator");vu(String,"String",(function(t){Ic(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Nc(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=Rc(n,r),e.index+=t.length,{value:t,done:!1})}));var Fc=Hu.f("iterator"),Wc=Fc,zc=rs("JSON","stringify"),Gc=/[\uD800-\uDFFF]/g,Vc=/^[\uD800-\uDBFF]$/,Hc=/^[\uDC00-\uDFFF]$/,Uc=function(t,e,n){var r=n.charAt(e-1),i=n.charAt(e+1);return Vc.test(t)&&!Hc.test(i)||Hc.test(t)&&!Vc.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},Bc=Qo((function(){return'"\\udf06\\ud834"'!==zc("\udf06\ud834")||'"\\udead"'!==zc("\udead")}));zc&&Ra({target:"JSON",stat:!0,forced:Bc},{stringify:function(t,e,n){var r=zc.apply(null,arguments);return"string"==typeof r?r.replace(Gc,Uc):r}}),Da.JSON||(Da.JSON={stringify:JSON.stringify});var Zc=function(t,e,n){return Da.JSON.stringify.apply(null,arguments)},Xc=Ia;var qc=function(t,e,n){return e in t?Xc(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):t[e]=n,t},Jc=Lu("Array").values,$c=Array.prototype,Qc={DOMTokenList:!0,NodeList:!0},Kc=function(t){var e=t.values;return t===$c||t instanceof Array&&e===$c.values||Qc.hasOwnProperty(ru(t))?Jc:e},tl=Us("iterator"),el=function(t){if(null!=t)return t[tl]||t["@@iterator"]||ds[ru(t)]},nl=function(t){var e=el(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return Aa(e.call(t))},rl=[],il=rl.sort,ol=Qo((function(){rl.sort(void 0)})),al=Qo((function(){rl.sort(null)})),sl=Pu("sort");Ra({target:"Array",proto:!0,forced:ol||!al||sl},{sort:function(t){return void 0===t?il.call(js(this)):il.call(js(this),Ta(t))}});var ul=Lu("Array").sort,cl=Array.prototype,ll=function(t){var e=t.sort;return t===cl||t instanceof Array&&e===cl.sort?ul:e},hl=function(t){return function(e,n,r,i){Ta(n);var o=js(e),a=sa(o),s=Va(o.length),u=t?s-1:0,c=t?-1:1;if(r<2)for(;;){if(u in a){i=a[u],u+=c;break}if(u+=c,t?u<0:s<=u)throw TypeError("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=c)u in a&&(i=n(i,a[u],u,o));return i}},fl={left:hl(!1),right:hl(!0)}.left;Ra({target:"Array",proto:!0,forced:Pu("reduce")},{reduce:function(t){return fl(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var dl=Lu("Array").reduce,pl=Array.prototype,yl=function(t){var e=t.reduce;return t===pl||t instanceof Array&&e===pl.reduce?dl:e},vl=Lu("Array").keys,ml=Array.prototype,gl={DOMTokenList:!0,NodeList:!0},_l=function(t){var e=t.keys;return t===ml||t instanceof Array&&e===ml.keys||gl.hasOwnProperty(ru(t))?vl:e};Ra({target:"Array",stat:!0},{isArray:xu});var wl=Da.Array.isArray,bl=wl;var Sl=function(t){if(bl(t)){for(var e=0,n=new Array(t.length);e<t.length;e++)n[e]=t[e];return n}},xl=function(t,e,n,r){try{return r?e(Aa(n)[0],n[1]):e(n)}catch(e){var i=t.return;throw void 0!==i&&Aa(i.call(t)),e}},Ol=Us("iterator"),kl=Array.prototype,Ml=function(t){return void 0!==t&&(ds.Array===t||kl[Ol]===t)},Dl=Us("iterator"),Tl=!1;try{var Pl=0,Al={next:function(){return{done:!!Pl++}},return:function(){Tl=!0}};Al[Dl]=function(){return this},Array.from(Al,(function(){throw 2}))}catch(t){}var El=!function(t,e){if(!e&&!Tl)return!1;var n=!1;try{var r={};r[Dl]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));Ra({target:"Array",stat:!0,forced:El},{from:function(t){var e,n,r,i,o,a=js(t),s="function"==typeof this?this:Array,u=arguments.length,c=u>1?arguments[1]:void 0,l=void 0!==c,h=0,f=el(a);if(l&&(c=Pa(c,u>2?arguments[2]:void 0,2)),null==f||s==Array&&Ml(f))for(n=new s(e=Va(a.length));e>h;h++)us(n,h,l?c(a[h],h):a[h]);else for(o=(i=f.call(a)).next,n=new s;!(r=o.call(i)).done;h++)us(n,h,l?xl(i,c,[r.value,h],!0):r.value);return n.length=h,n}});var Ll=Da.Array.from,Cl=Us("iterator"),Yl=function(t){var e=Object(t);return void 0!==e[Cl]||"@@iterator"in e||ds.hasOwnProperty(ru(e))};var jl=function(t){if(Yl(Object(t))||"[object Arguments]"===Object.prototype.toString.call(t))return Ll(t)};var Rl=function(){throw new TypeError("Invalid attempt to spread non-iterable instance")};var Il,Nl,Fl=function(t){return Sl(t)||jl(t)||Rl()},Wl=rs("navigator","userAgent")||"",zl=$o.process,Gl=zl&&zl.versions,Vl=Gl&&Gl.v8;Vl?Nl=(Il=Vl.split("."))[0]+Il[1]:Wl&&(!(Il=Wl.match(/Edge\/(\d+)/))||Il[1]>=74)&&(Il=Wl.match(/Chrome\/(\d+)/))&&(Nl=Il[1]);var Hl=Nl&&+Nl,Ul=Us("species"),Bl=function(t){return Hl>=51||!Qo((function(){var e=[];return(e.constructor={})[Ul]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Zl=Tu.filter,Xl=Bl("filter"),ql=Xl&&!Qo((function(){[].filter.call({length:-1,0:1},(function(t){throw t}))}));Ra({target:"Array",proto:!0,forced:!Xl||!ql},{filter:function(t){return Zl(this,t,arguments.length>1?arguments[1]:void 0)}});var Jl=Lu("Array").filter,$l=Array.prototype,Ql=function(t){var e=t.filter;return t===$l||t instanceof Array&&e===$l.filter?Jl:e},Kl=Us("isConcatSpreadable"),th=Hl>=51||!Qo((function(){var t=[];return t[Kl]=!1,t.concat()[0]!==t})),eh=Bl("concat"),nh=function(t){if(!la(t))return!1;var e=t[Kl];return void 0!==e?!!e:xu(t)};Ra({target:"Array",proto:!0,forced:!th||!eh},{concat:function(t){var e,n,r,i,o,a=js(this),s=ku(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],nh(o)){if(u+(i=Va(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,u++)n in o&&us(s,u,o[n])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");us(s,u++,o)}return s.length=u,s}});var rh=Lu("Array").concat,ih=Array.prototype,oh=function(t){var e=t.concat;return t===ih||t instanceof Array&&e===ih.concat?rh:e},ah=Object.assign,sh=Object.defineProperty,uh=!ah||Qo((function(){if(Ko&&1!==ah({b:1},ah(sh({},"a",{enumerable:!0,get:function(){sh(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ah({},t)[n]||"abcdefghijklmnopqrst"!=Ka(ah({},e)).join("")}))?function(t,e){for(var n=js(t),r=arguments.length,i=1,o=as.f,a=na.f;r>i;)for(var s,u=sa(arguments[i++]),c=o?Ka(u).concat(o(u)):Ka(u),l=c.length,h=0;l>h;)s=c[h++],Ko&&!a.call(u,s)||(n[s]=u[s]);return n}:ah;Ra({target:"Object",stat:!0,forced:Object.assign!==uh},{assign:uh});var ch=Da.Object.assign,lh=Tu.some;Ra({target:"Array",proto:!0,forced:Pu("some")},{some:function(t){return lh(this,t,arguments.length>1?arguments[1]:void 0)}});var hh=Lu("Array").some,fh=Array.prototype,dh=function(t){var e=t.some;return t===fh||t instanceof Array&&e===fh.some?hh:e},ph=Tu.map,yh=Bl("map"),vh=yh&&!Qo((function(){[].map.call({length:-1,0:1},(function(t){throw t}))}));Ra({target:"Array",proto:!0,forced:!yh||!vh},{map:function(t){return ph(this,t,arguments.length>1?arguments[1]:void 0)}});var mh=Lu("Array").map,gh=Array.prototype,_h=function(t){var e=t.map;return t===gh||t instanceof Array&&e===gh.map?mh:e},wh=Fc;Bu("asyncIterator"),Bu("hasInstance"),Bu("isConcatSpreadable"),Bu("match"),Bu("matchAll"),Bu("replace"),Bu("search"),Bu("species"),Bu("split"),Bu("toPrimitive"),Bu("toStringTag"),Bu("unscopables"),su(Math,"Math",!0),su($o.JSON,"JSON",!0);var bh=Da.Symbol;Bu("asyncDispose"),Bu("dispose"),Bu("observable"),Bu("patternMatch"),Bu("replaceAll");var Sh=bh,xh=qo((function(t){function e(t){return(e="function"==typeof Sh&&"symbol"==typeof wh?function(t){return typeof t}:function(t){return t&&"function"==typeof Sh&&t.constructor===Sh&&t!==Sh.prototype?"symbol":typeof t})(t)}function n(r){return"function"==typeof Sh&&"symbol"===e(wh)?t.exports=n=function(t){return e(t)}:t.exports=n=function(t){return t&&"function"==typeof Sh&&t.constructor===Sh&&t!==Sh.prototype?"symbol":e(t)},n(r)}t.exports=n})),Oh=Qo((function(){Ka(1)}));Ra({target:"Object",stat:!0,forced:Oh},{keys:function(t){return Ka(js(t))}});var kh=Da.Object.keys,Mh=!Qo((function(){return Object.isExtensible(Object.preventExtensions({}))})),Dh=qo((function(t){var e=La.f,n=Ss("meta"),r=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,n,{value:{objectID:"O"+ ++r,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!la(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!da(t,n)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[n].objectID},getWeakData:function(t,e){if(!da(t,n)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[n].weakData},onFreeze:function(t){return Mh&&a.REQUIRED&&i(t)&&!da(t,n)&&o(t),t}};qa[n]=!0})),Th=(Dh.REQUIRED,Dh.fastKey,Dh.getWeakData,Dh.onFreeze,qo((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,n,r,i,o){var a,s,u,c,l,h,f,d=Pa(n,r,i?2:1);if(o)a=t;else{if("function"!=typeof(s=el(t)))throw TypeError("Target is not iterable");if(Ml(s)){for(u=0,c=Va(t.length);c>u;u++)if((l=i?d(Aa(f=t[u])[0],f[1]):d(t[u]))&&l instanceof e)return l;return new e(!1)}a=s.call(t)}for(h=a.next;!(f=h.call(a)).done;)if("object"==typeof(l=xl(a,d,f.value,i))&&l&&l instanceof e)return l;return new e(!1)}).stop=function(t){return new e(!0,t)}}))),Ph=function(t,e,n){if(!(t instanceof e))throw TypeError("Incorrect "+(n?n+" ":"")+"invocation");return t},Ah=La.f,Eh=Tu.forEach,Lh=Ys.set,Ch=Ys.getterFor,Yh=function(t,e,n){var r,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",s=$o[t],u=s&&s.prototype,c={};if(Ko&&"function"==typeof s&&(o||u.forEach&&!Qo((function(){(new s).entries().next()})))){r=e((function(e,n){Lh(Ph(e,r,t),{type:t,collection:new s}),null!=n&&Th(n,e[a],e,i)}));var l=Ch(t);Eh(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;t in u&&(!o||"clear"!=t)&&Ca(r.prototype,t,(function(n,r){var i=l(this).collection;if(!e&&o&&!la(n))return"get"==t&&void 0;var a=i[t](0===n?0:n,r);return e?this:a}))})),o||Ah(r.prototype,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else r=n.getConstructor(e,t,i,a),Dh.REQUIRED=!0;return su(r,t,!1,!0),c[t]=r,Ra({global:!0,forced:!0},c),o||n.setStrong(r,t,i),r},jh=function(t,e,n){for(var r in e)n&&n.unsafe&&t[r]?t[r]=e[r]:hu(t,r,e[r],n);return t},Rh=Us("species"),Ih=La.f,Nh=Dh.fastKey,Fh=Ys.set,Wh=Ys.getterFor,zh={getConstructor:function(t,e,n,r){var i=t((function(t,o){Ph(t,i,e),Fh(t,{type:e,index:Qs(null),first:void 0,last:void 0,size:0}),Ko||(t.size=0),null!=o&&Th(o,t[r],t,n)})),o=Wh(e),a=function(t,e,n){var r,i,a=o(t),u=s(t,e);return u?u.value=n:(a.last=u={index:i=Nh(e,!0),key:e,value:n,previous:r=a.last,next:void 0,removed:!1},a.first||(a.first=u),r&&(r.next=u),Ko?a.size++:t.size++,"F"!==i&&(a.index[i]=u)),t},s=function(t,e){var n,r=o(t),i=Nh(e);if("F"!==i)return r.index[i];for(n=r.first;n;n=n.next)if(n.key==e)return n};return jh(i.prototype,{clear:function(){for(var t=o(this),e=t.index,n=t.first;n;)n.removed=!0,n.previous&&(n.previous=n.previous.next=void 0),delete e[n.index],n=n.next;t.first=t.last=void 0,Ko?t.size=0:this.size=0},delete:function(t){var e=o(this),n=s(this,t);if(n){var r=n.next,i=n.previous;delete e.index[n.index],n.removed=!0,i&&(i.next=r),r&&(r.previous=i),e.first==n&&(e.first=r),e.last==n&&(e.last=i),Ko?e.size--:this.size--}return!!n},forEach:function(t){for(var e,n=o(this),r=Pa(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:n.first;)for(r(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),jh(i.prototype,n?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),Ko&&Ih(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,n){var r=e+" Iterator",i=Wh(e),o=Wh(r);vu(t,e,(function(t,e){Fh(this,{type:r,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,n=t.last;n&&n.removed;)n=n.previous;return t.target&&(t.last=n=n?n.next:t.state.first)?"keys"==e?{value:n.key,done:!1}:"values"==e?{value:n.value,done:!1}:{value:[n.key,n.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),n?"entries":"values",!n,!0),function(t){var e=rs(t),n=La.f;Ko&&e&&!e[Rh]&&n(e,Rh,{configurable:!0,get:function(){return this}})}(e)}},Gh=(Yh("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),zh),Da.Map),Vh=wl;var Hh=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Uh(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Xc(t,r.key,r)}}var Bh=function(t,e,n){return e&&Uh(t.prototype,e),n&&Uh(t,n),t};var Zh=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Xh=function(t,e){return!e||"object"!==xh(e)&&"function"!=typeof e?Zh(t):e},qh=Qo((function(){Fs(1)}));Ra({target:"Object",stat:!0,forced:qh,sham:!Rs},{getPrototypeOf:function(t){return Fs(js(t))}});var Jh=Da.Object.getPrototypeOf;Ra({target:"Object",stat:!0},{setPrototypeOf:lu});var $h=Da.Object.setPrototypeOf,Qh=qo((function(t){function e(n){return t.exports=e=$h?Jh:function(t){return t.__proto__||Jh(t)},e(n)}t.exports=e}));Ra({target:"Object",stat:!0,sham:!Ko},{create:Qs});var Kh=Da.Object,tf=function(t,e){return Kh.create(t,e)},ef=tf,nf=qo((function(t){function e(n,r){return t.exports=e=$h||function(t,e){return t.__proto__=e,t},e(n,r)}t.exports=e}));for(var rf=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=ef(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&nf(t,e)},of=[],af=0;af<256;af++)of[af]=(af+256).toString(16).substr(1);for(var sf=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,n=0;n<16;n++)0==(3&n)&&(t=4294967296*Math.random()),e[n]=t>>>((3&n)<<3)&255;return e}}(),uf=[],cf=0;cf<256;cf++)uf[cf]=(cf+256).toString(16).substr(1);var lf=sf();lf[0],lf[1],lf[2],lf[3],lf[4],lf[5],lf[6],lf[7];function hf(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},e=arguments.length>1?arguments[1]:void 0,n=arguments.length>2?arguments[2]:void 0,r=e&&n||0;"string"==typeof t&&(e="binary"===t?new Array(16):void 0,t={});var i=t.random||(t.rng||sf)();if(i[6]=15&i[6]|64,i[8]=63&i[8]|128,e)for(var o=0;o<16;o++)e[r+o]=i[o];return e||function(t,e){var n=e||0,r=of;return r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]}(i)}var ff="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function df(t,e){return t(e={exports:{}},e.exports),e.exports}var pf=function(t){return t&&t.Math==Math&&t},yf=pf("object"==typeof globalThis&&globalThis)||pf("object"==typeof window&&window)||pf("object"==typeof self&&self)||pf("object"==typeof ff&&ff)||Function("return this")(),vf=function(t){try{return!!t()}catch(t){return!0}},mf=!vf((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),gf={}.propertyIsEnumerable,_f=Object.getOwnPropertyDescriptor,wf={f:_f&&!gf.call({1:2},1)?function(t){var e=_f(this,t);return!!e&&e.enumerable}:gf},bf=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},Sf={}.toString,xf=function(t){return Sf.call(t).slice(8,-1)},Of="".split,kf=vf((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==xf(t)?Of.call(t,""):Object(t)}:Object,Mf=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},Df=function(t){return kf(Mf(t))},Tf=function(t){return"object"==typeof t?null!==t:"function"==typeof t},Pf=function(t,e){if(!Tf(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!Tf(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!Tf(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!Tf(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},Af={}.hasOwnProperty,Ef=function(t,e){return Af.call(t,e)},Lf=yf.document,Cf=Tf(Lf)&&Tf(Lf.createElement),Yf=function(t){return Cf?Lf.createElement(t):{}},jf=!mf&&!vf((function(){return 7!=Object.defineProperty(Yf("div"),"a",{get:function(){return 7}}).a})),Rf=Object.getOwnPropertyDescriptor,If={f:mf?Rf:function(t,e){if(t=Df(t),e=Pf(e,!0),jf)try{return Rf(t,e)}catch(t){}if(Ef(t,e))return bf(!wf.f.call(t,e),t[e])}},Nf=/#|\.prototype\./,Ff=function(t,e){var n=zf[Wf(t)];return n==Vf||n!=Gf&&("function"==typeof e?vf(e):!!e)},Wf=Ff.normalize=function(t){return String(t).replace(Nf,".").toLowerCase()},zf=Ff.data={},Gf=Ff.NATIVE="N",Vf=Ff.POLYFILL="P",Hf=Ff,Uf={},Bf=function(t,e,n){if(function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function")}(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},Zf=function(t){if(!Tf(t))throw TypeError(String(t)+" is not an object");return t},Xf=Object.defineProperty,qf={f:mf?Xf:function(t,e,n){if(Zf(t),e=Pf(e,!0),Zf(n),jf)try{return Xf(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},Jf=mf?function(t,e,n){return qf.f(t,e,bf(1,n))}:function(t,e,n){return t[e]=n,t},$f=If.f,Qf=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},Kf=function(t,e){var n,r,i,o,a,s,u,c,l=t.target,h=t.global,f=t.stat,d=t.proto,p=h?yf:f?yf[l]:(yf[l]||{}).prototype,y=h?Uf:Uf[l]||(Uf[l]={}),v=y.prototype;for(i in e)n=!Hf(h?i:l+(f?".":"#")+i,t.forced)&&p&&Ef(p,i),a=y[i],n&&(s=t.noTargetGet?(c=$f(p,i))&&c.value:p[i]),o=n&&s?s:e[i],n&&typeof a==typeof o||(u=t.bind&&n?Bf(o,yf):t.wrap&&n?Qf(o):d&&"function"==typeof o?Bf(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&Jf(u,"sham",!0),y[i]=u,d&&(Ef(Uf,r=l+"Prototype")||Jf(Uf,r,{}),Uf[r][i]=o,t.real&&v&&!v[i]&&Jf(v,i,o)))};Kf({target:"Object",stat:!0,forced:!mf,sham:!mf},{defineProperty:qf.f});df((function(t){var e=Uf.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)}));var td=Math.ceil,ed=Math.floor,nd=function(t){return isNaN(t=+t)?0:(t>0?ed:td)(t)},rd=Math.min,id=function(t){return t>0?rd(nd(t),9007199254740991):0},od=Math.max,ad=Math.min,sd=function(t,e){var n=nd(t);return n<0?od(n+e,0):ad(n,e)},ud=function(t){return function(e,n,r){var i,o=Df(e),a=id(o.length),s=sd(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},cd={includes:ud(!0),indexOf:ud(!1)},ld={},hd=cd.indexOf,fd=function(t,e){var n,r=Df(t),i=0,o=[];for(n in r)!Ef(ld,n)&&Ef(r,n)&&o.push(n);for(;e.length>i;)Ef(r,n=e[i++])&&(~hd(o,n)||o.push(n));return o},dd=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],pd=Object.keys||function(t){return fd(t,dd)},yd=mf?Object.defineProperties:function(t,e){Zf(t);for(var n,r=pd(e),i=r.length,o=0;i>o;)qf.f(t,n=r[o++],e[n]);return t};Kf({target:"Object",stat:!0,forced:!mf,sham:!mf},{defineProperties:yd});df((function(t){var e=Uf.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)}));var vd=function(t){return"function"==typeof t?t:void 0},md=function(t,e){return arguments.length<2?vd(Uf[t])||vd(yf[t]):Uf[t]&&Uf[t][e]||yf[t]&&yf[t][e]},gd=dd.concat("length","prototype"),_d={f:Object.getOwnPropertyNames||function(t){return fd(t,gd)}},wd={f:Object.getOwnPropertySymbols},bd=md("Reflect","ownKeys")||function(t){var e=_d.f(Zf(t)),n=wd.f;return n?e.concat(n(t)):e},Sd=function(t,e,n){var r=Pf(e);r in t?qf.f(t,r,bf(0,n)):t[r]=n};Kf({target:"Object",stat:!0,sham:!mf},{getOwnPropertyDescriptors:function(t){for(var e,n,r=Df(t),i=If.f,o=bd(r),a={},s=0;o.length>s;)void 0!==(n=i(r,e=o[s++]))&&Sd(a,e,n);return a}});Uf.Object.getOwnPropertyDescriptors;var xd=If.f,Od=vf((function(){xd(1)}));Kf({target:"Object",stat:!0,forced:!mf||Od,sham:!mf},{getOwnPropertyDescriptor:function(t,e){return xd(Df(t),e)}});df((function(t){var e=Uf.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)}));var kd=!!Object.getOwnPropertySymbols&&!vf((function(){return!String(Symbol())})),Md=Array.isArray||function(t){return"Array"==xf(t)},Dd=function(t){return Object(Mf(t))},Td=md("document","documentElement"),Pd=yf["__core-js_shared__"]||function(t,e){try{Jf(yf,t,e)}catch(n){yf[t]=e}return e}("__core-js_shared__",{}),Ad=df((function(t){(t.exports=function(t,e){return Pd[t]||(Pd[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.4.1",mode:"pure",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),Ed=0,Ld=Math.random(),Cd=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Ed+Ld).toString(36)},Yd=Ad("keys"),jd=function(t){return Yd[t]||(Yd[t]=Cd(t))},Rd=jd("IE_PROTO"),Id=function(){},Nd=function(){var t,e=Yf("iframe"),n=dd.length;for(e.style.display="none",Td.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write("<script>document.F=Object<\/script>"),t.close(),Nd=t.F;n--;)delete Nd.prototype[dd[n]];return Nd()},Fd=Object.create||function(t,e){var n;return null!==t?(Id.prototype=Zf(t),n=new Id,Id.prototype=null,n[Rd]=t):n=Nd(),void 0===e?n:yd(n,e)};ld[Rd]=!0;var Wd=_d.f,zd={}.toString,Gd="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Vd={f:function(t){return Gd&&"[object Window]"==zd.call(t)?function(t){try{return Wd(t)}catch(t){return Gd.slice()}}(t):Wd(Df(t))}},Hd=function(t,e,n,r){r&&r.enumerable?t[e]=n:Jf(t,e,n)},Ud=yf.Symbol,Bd=Ad("wks"),Zd=function(t){return Bd[t]||(Bd[t]=kd&&Ud[t]||(kd?Ud:Cd)("Symbol."+t))},Xd={f:Zd},qd=qf.f,Jd=function(t){var e=Uf.Symbol||(Uf.Symbol={});Ef(e,t)||qd(e,t,{value:Xd.f(t)})},$d=Zd("toStringTag"),Qd="Arguments"==xf(function(){return arguments}()),Kd=function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),$d))?n:Qd?xf(e):"Object"==(r=xf(e))&&"function"==typeof e.callee?"Arguments":r},tp={};tp[Zd("toStringTag")]="z";var ep,np,rp,ip="[object z]"!==String(tp)?function(){return"[object "+Kd(this)+"]"}:tp.toString,op=qf.f,ap=Zd("toStringTag"),sp=ip!=={}.toString,up=function(t,e,n,r){if(t){var i=n?t:t.prototype;Ef(i,ap)||op(i,ap,{configurable:!0,value:e}),r&&sp&&Jf(i,"toString",ip)}},cp=Ad("native-function-to-string",Function.toString),lp=yf.WeakMap,hp="function"==typeof lp&&/native code/.test(cp.call(lp)),fp=yf.WeakMap;if(hp){var dp=new fp,pp=dp.get,yp=dp.has,vp=dp.set;ep=function(t,e){return vp.call(dp,t,e),e},np=function(t){return pp.call(dp,t)||{}},rp=function(t){return yp.call(dp,t)}}else{var mp=jd("state");ld[mp]=!0,ep=function(t,e){return Jf(t,mp,e),e},np=function(t){return Ef(t,mp)?t[mp]:{}},rp=function(t){return Ef(t,mp)}}var gp={set:ep,get:np,has:rp,enforce:function(t){return rp(t)?np(t):ep(t,{})},getterFor:function(t){return function(e){var n;if(!Tf(e)||(n=np(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},_p=Zd("species"),wp=function(t,e){var n;return Md(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!Md(n.prototype)?Tf(n)&&null===(n=n[_p])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},bp=[].push,Sp=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=5==t||o;return function(s,u,c,l){for(var h,f,d=Dd(s),p=kf(d),y=Bf(u,c,3),v=id(p.length),m=0,g=l||wp,_=e?g(s,v):n?g(s,0):void 0;v>m;m++)if((a||m in p)&&(f=y(h=p[m],m,d),t))if(e)_[m]=f;else if(f)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:bp.call(_,h)}else if(i)return!1;return o?-1:r||i?i:_}},xp={forEach:Sp(0),map:Sp(1),filter:Sp(2),some:Sp(3),every:Sp(4),find:Sp(5),findIndex:Sp(6)},Op=xp.forEach,kp=jd("hidden"),Mp=Zd("toPrimitive"),Dp=gp.set,Tp=gp.getterFor("Symbol"),Pp=Object.prototype,Ap=yf.Symbol,Ep=md("JSON","stringify"),Lp=If.f,Cp=qf.f,Yp=Vd.f,jp=wf.f,Rp=Ad("symbols"),Ip=Ad("op-symbols"),Np=Ad("string-to-symbol-registry"),Fp=Ad("symbol-to-string-registry"),Wp=Ad("wks"),zp=yf.QObject,Gp=!zp||!zp.prototype||!zp.prototype.findChild,Vp=mf&&vf((function(){return 7!=Fd(Cp({},"a",{get:function(){return Cp(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=Lp(Pp,e);r&&delete Pp[e],Cp(t,e,n),r&&t!==Pp&&Cp(Pp,e,r)}:Cp,Hp=function(t,e){var n=Rp[t]=Fd(Ap.prototype);return Dp(n,{type:"Symbol",tag:t,description:e}),mf||(n.description=e),n},Up=kd&&"symbol"==typeof Ap.iterator?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ap},Bp=function(t,e,n){t===Pp&&Bp(Ip,e,n),Zf(t);var r=Pf(e,!0);return Zf(n),Ef(Rp,r)?(n.enumerable?(Ef(t,kp)&&t[kp][r]&&(t[kp][r]=!1),n=Fd(n,{enumerable:bf(0,!1)})):(Ef(t,kp)||Cp(t,kp,bf(1,{})),t[kp][r]=!0),Vp(t,r,n)):Cp(t,r,n)},Zp=function(t,e){Zf(t);var n=Df(e),r=pd(n).concat($p(n));return Op(r,(function(e){mf&&!Xp.call(n,e)||Bp(t,e,n[e])})),t},Xp=function(t){var e=Pf(t,!0),n=jp.call(this,e);return!(this===Pp&&Ef(Rp,e)&&!Ef(Ip,e))&&(!(n||!Ef(this,e)||!Ef(Rp,e)||Ef(this,kp)&&this[kp][e])||n)},qp=function(t,e){var n=Df(t),r=Pf(e,!0);if(n!==Pp||!Ef(Rp,r)||Ef(Ip,r)){var i=Lp(n,r);return!i||!Ef(Rp,r)||Ef(n,kp)&&n[kp][r]||(i.enumerable=!0),i}},Jp=function(t){var e=Yp(Df(t)),n=[];return Op(e,(function(t){Ef(Rp,t)||Ef(ld,t)||n.push(t)})),n},$p=function(t){var e=t===Pp,n=Yp(e?Ip:Df(t)),r=[];return Op(n,(function(t){!Ef(Rp,t)||e&&!Ef(Pp,t)||r.push(Rp[t])})),r};if(kd||(Hd((Ap=function(){if(this instanceof Ap)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Cd(t),n=function(t){this===Pp&&n.call(Ip,t),Ef(this,kp)&&Ef(this[kp],e)&&(this[kp][e]=!1),Vp(this,e,bf(1,t))};return mf&&Gp&&Vp(Pp,e,{configurable:!0,set:n}),Hp(e,t)}).prototype,"toString",(function(){return Tp(this).tag})),wf.f=Xp,qf.f=Bp,If.f=qp,_d.f=Vd.f=Jp,wd.f=$p,mf&&Cp(Ap.prototype,"description",{configurable:!0,get:function(){return Tp(this).description}}),Xd.f=function(t){return Hp(Zd(t),t)}),Kf({global:!0,wrap:!0,forced:!kd,sham:!kd},{Symbol:Ap}),Op(pd(Wp),(function(t){Jd(t)})),Kf({target:"Symbol",stat:!0,forced:!kd},{for:function(t){var e=String(t);if(Ef(Np,e))return Np[e];var n=Ap(e);return Np[e]=n,Fp[n]=e,n},keyFor:function(t){if(!Up(t))throw TypeError(t+" is not a symbol");if(Ef(Fp,t))return Fp[t]},useSetter:function(){Gp=!0},useSimple:function(){Gp=!1}}),Kf({target:"Object",stat:!0,forced:!kd,sham:!mf},{create:function(t,e){return void 0===e?Fd(t):Zp(Fd(t),e)},defineProperty:Bp,defineProperties:Zp,getOwnPropertyDescriptor:qp}),Kf({target:"Object",stat:!0,forced:!kd},{getOwnPropertyNames:Jp,getOwnPropertySymbols:$p}),Kf({target:"Object",stat:!0,forced:vf((function(){wd.f(1)}))},{getOwnPropertySymbols:function(t){return wd.f(Dd(t))}}),Ep){var Qp=!kd||vf((function(){var t=Ap();return"[null]"!=Ep([t])||"{}"!=Ep({a:t})||"{}"!=Ep(Object(t))}));Kf({target:"JSON",stat:!0,forced:Qp},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(Tf(e)||void 0!==t)&&!Up(t))return Md(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Up(e))return e}),i[1]=e,Ep.apply(null,i)}})}Ap.prototype[Mp]||Jf(Ap.prototype,Mp,Ap.prototype.valueOf),up(Ap,"Symbol"),ld[kp]=!0;Uf.Object.getOwnPropertySymbols;var Kp,ty,ey,ny={},ry=!vf((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),iy=jd("IE_PROTO"),oy=Object.prototype,ay=ry?Object.getPrototypeOf:function(t){return t=Dd(t),Ef(t,iy)?t[iy]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?oy:null},sy=(Zd("iterator"),!1);[].keys&&("next"in(ey=[].keys())?(ty=ay(ay(ey)))!==Object.prototype&&(Kp=ty):sy=!0),null==Kp&&(Kp={});var uy={IteratorPrototype:Kp,BUGGY_SAFARI_ITERATORS:sy},cy=uy.IteratorPrototype,ly=function(){return this},hy=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}}(),uy.IteratorPrototype),fy=uy.BUGGY_SAFARI_ITERATORS,dy=Zd("iterator"),py=function(){return this},yy=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Fd(cy,{next:bf(1,n)}),up(t,r,!1,!0),ny[r]=ly}(n,e,r);var s,u,c,l=function(t){if(t===i&&y)return y;if(!fy&&t in d)return d[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},h=e+" Iterator",f=!1,d=t.prototype,p=d[dy]||d["@@iterator"]||i&&d[i],y=!fy&&p||l(i),v="Array"==e&&d.entries||p;if(v&&(s=ay(v.call(new t)),hy!==Object.prototype&&s.next&&(up(s,h,!0,!0),ny[h]=py)),"values"==i&&p&&"values"!==p.name&&(f=!0,y=function(){return p.call(this)}),a&&d[dy]!==y&&Jf(d,dy,y),ny[e]=y,i)if(u={values:l("values"),keys:o?y:l("keys"),entries:l("entries")},a)for(c in u)!fy&&!f&&c in d||Hd(d,c,u[c]);else Kf({target:e,proto:!0,forced:fy||f},u);return u},vy=gp.set,my=gp.getterFor("Array Iterator");yy(Array,"Array",(function(t,e){vy(this,{type:"Array Iterator",target:Df(t),index:0,kind:e})}),(function(){var t=my(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");ny.Arguments=ny.Array;var gy=Zd("toStringTag");for(var _y in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var wy=yf[_y],by=wy&&wy.prototype;by&&!by[gy]&&Jf(by,gy,_y),ny[_y]=ny.Array}var Sy=function(t){return function(e,n){var r,i,o=String(Mf(e)),a=nd(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},xy={codeAt:Sy(!1),charAt:Sy(!0)}.charAt,Oy=gp.set,ky=gp.getterFor("String Iterator");yy(String,"String",(function(t){Oy(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=ky(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=xy(n,r),e.index+=t.length,{value:t,done:!1})}));var My=Zd("iterator"),Dy=function(t){if(null!=t)return t[My]||t["@@iterator"]||ny[Kd(t)]};Kf({target:"Object",stat:!0,sham:!mf},{create:Fd});var Ty=vf((function(){pd(1)}));Kf({target:"Object",stat:!0,forced:Ty},{keys:function(t){return pd(Dd(t))}});Uf.Object.keys;var Py="\t\n\v\f\r                　\u2028\u2029\ufeff",Ay="["+Py+"]",Ey=RegExp("^"+Ay+Ay+"*"),Ly=RegExp(Ay+Ay+"*$"),Cy=function(t){return function(e){var n=String(Mf(e));return 1&t&&(n=n.replace(Ey,"")),2&t&&(n=n.replace(Ly,"")),n}},Yy={start:Cy(1),end:Cy(2),trim:Cy(3)},jy=Yy.trim;Kf({target:"String",proto:!0,forced:function(t){return vf((function(){return!!Py[t]()||"​᠎"!="​᠎"[t]()||Py[t].name!==t}))}("trim")},{trim:function(){return jy(this)}});var Ry=function(t){return Uf[t+"Prototype"]},Iy=(Ry("String").trim,function(t,e){var n=[][t];return!n||!vf((function(){n.call(null,e||function(){throw 1},1)}))}),Ny=xp.forEach,Fy=Iy("forEach")?function(t){return Ny(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;Kf({target:"Array",proto:!0,forced:[].forEach!=Fy},{forEach:Fy});Ry("Array").forEach;var Wy,zy,Gy=md("navigator","userAgent")||"",Vy=yf.process,Hy=Vy&&Vy.versions,Uy=Hy&&Hy.v8;Uy?zy=(Wy=Uy.split("."))[0]+Wy[1]:Gy&&(!(Wy=Gy.match(/Edge\/(\d+)/))||Wy[1]>=74)&&(Wy=Gy.match(/Chrome\/(\d+)/))&&(zy=Wy[1]);var By=zy&&+zy,Zy=Zd("species"),Xy=function(t){return By>=51||!vf((function(){var e=[];return(e.constructor={})[Zy]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},qy=xp.map;Kf({target:"Array",proto:!0,forced:!Xy("map")},{map:function(t){return qy(this,t,arguments.length>1?arguments[1]:void 0)}});Ry("Array").map;var Jy=Yy.trim,$y=yf.parseInt,Qy=/^[+-]?0[Xx]/,Ky=8!==$y(Py+"08")||22!==$y(Py+"0x16")?function(t,e){var n=Jy(String(t));return $y(n,e>>>0||(Qy.test(n)?16:10))}:$y;Kf({global:!0,forced:parseInt!=Ky},{parseInt:Ky});var tv=wf.f,ev=function(t){return function(e){for(var n,r=Df(e),i=pd(r),o=i.length,a=0,s=[];o>a;)n=i[a++],mf&&!tv.call(r,n)||s.push(t?[n,r[n]]:r[n]);return s}},nv={entries:ev(!0),values:ev(!1)}.values;Kf({target:"Object",stat:!0},{values:function(t){return nv(t)}});Uf.Object.values;var rv=xp.filter;Kf({target:"Array",proto:!0,forced:!Xy("filter")},{filter:function(t){return rv(this,t,arguments.length>1?arguments[1]:void 0)}});Ry("Array").filter;var iv=Zd("isConcatSpreadable"),ov=By>=51||!vf((function(){var t=[];return t[iv]=!1,t.concat()[0]!==t})),av=Xy("concat"),sv=function(t){if(!Tf(t))return!1;var e=t[iv];return void 0!==e?!!e:Md(t)};Kf({target:"Array",proto:!0,forced:!ov||!av},{concat:function(t){var e,n,r,i,o,a=Dd(this),s=wp(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],sv(o)){if(u+(i=id(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,u++)n in o&&Sd(s,u,o[n])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Sd(s,u++,o)}return s.length=u,s}});Ry("Array").concat;Kf({target:"Array",stat:!0},{isArray:Md});var uv=Uf.Array.isArray,cv=function(t,e,n,r){try{return r?e(Zf(n)[0],n[1]):e(n)}catch(e){var i=t.return;throw void 0!==i&&Zf(i.call(t)),e}},lv=Zd("iterator"),hv=Array.prototype,fv=function(t){return void 0!==t&&(ny.Array===t||hv[lv]===t)},dv=Zd("iterator"),pv=!1;try{var yv=0,vv={next:function(){return{done:!!yv++}},return:function(){pv=!0}};vv[dv]=function(){return this},Array.from(vv,(function(){throw 2}))}catch(t){}var mv=!function(t,e){if(!e&&!pv)return!1;var n=!1;try{var r={};r[dv]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));Kf({target:"Array",stat:!0,forced:mv},{from:function(t){var e,n,r,i,o,a=Dd(t),s="function"==typeof this?this:Array,u=arguments.length,c=u>1?arguments[1]:void 0,l=void 0!==c,h=0,f=Dy(a);if(l&&(c=Bf(c,u>2?arguments[2]:void 0,2)),null==f||s==Array&&fv(f))for(n=new s(e=id(a.length));e>h;h++)Sd(n,h,l?c(a[h],h):a[h]);else for(o=(i=f.call(a)).next,n=new s;!(r=o.call(i)).done;h++)Sd(n,h,l?cv(i,c,[r.value,h],!0):r.value);return n.length=h,n}});Uf.Array.from,Zd("iterator");var gv=Zd("species"),_v=[].slice,wv=Math.max;Kf({target:"Array",proto:!0,forced:!Xy("slice")},{slice:function(t,e){var n,r,i,o=Df(this),a=id(o.length),s=sd(t,a),u=sd(void 0===e?a:e,a);if(Md(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!Md(n.prototype)?Tf(n)&&null===(n=n[gv])&&(n=void 0):n=void 0,n===Array||void 0===n))return _v.call(o,s,u);for(r=new(void 0===n?Array:n)(wv(u-s,0)),i=0;s<u;s++,i++)s in o&&Sd(r,i,o[s]);return r.length=i,r}});var bv=Ry("Array").slice,Sv=Array.prototype,xv=function(t){var e=t.slice;return t===Sv||t instanceof Array&&e===Sv.slice?bv:e},Ov=vf((function(){ay(1)}));Kf({target:"Object",stat:!0,forced:Ov,sham:!ry},{getPrototypeOf:function(t){return ay(Dd(t))}});var kv=Uf.Object.getPrototypeOf,Mv=cd.indexOf,Dv=[].indexOf,Tv=!!Dv&&1/[1].indexOf(1,-0)<0,Pv=Iy("indexOf");Kf({target:"Array",proto:!0,forced:Tv||Pv},{indexOf:function(t){return Tv?Dv.apply(this,arguments)||0:Mv(this,t,arguments.length>1?arguments[1]:void 0)}});Ry("Array").indexOf;var Av=uv,Ev=Object.assign,Lv=!Ev||vf((function(){var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=Ev({},t)[n]||"abcdefghijklmnopqrst"!=pd(Ev({},e)).join("")}))?function(t,e){for(var n=Dd(t),r=arguments.length,i=1,o=wd.f,a=wf.f;r>i;)for(var s,u=kf(arguments[i++]),c=o?pd(u).concat(o(u)):pd(u),l=c.length,h=0;l>h;)s=c[h++],mf&&!a.call(u,s)||(n[s]=u[s]);return n}:Ev;Kf({target:"Object",stat:!0,forced:Object.assign!==Lv},{assign:Lv});Uf.Object.assign;Jd("iterator");var Cv=Xd.f("iterator");Jd("asyncIterator"),Jd("hasInstance"),Jd("isConcatSpreadable"),Jd("match"),Jd("matchAll"),Jd("replace"),Jd("search"),Jd("species"),Jd("split"),Jd("toPrimitive"),Jd("toStringTag"),Jd("unscopables"),up(Math,"Math",!0),up(yf.JSON,"JSON",!0);var Yv=Uf.Symbol;Jd("asyncDispose"),Jd("dispose"),Jd("observable"),Jd("patternMatch"),Jd("replaceAll");for(var jv=Yv,Rv=df((function(t){function e(t){return(e="function"==typeof jv&&"symbol"==typeof Cv?function(t){return typeof t}:function(t){return t&&"function"==typeof jv&&t.constructor===jv&&t!==jv.prototype?"symbol":typeof t})(t)}function n(r){return"function"==typeof jv&&"symbol"===e(Cv)?t.exports=n=function(t){return e(t)}:t.exports=n=function(t){return t&&"function"==typeof jv&&t.constructor===jv&&t!==jv.prototype?"symbol":e(t)},n(r)}t.exports=n})),Iv=[],Nv=0;Nv<256;Nv++)Iv[Nv]=(Nv+256).toString(16).substr(1);for(var Fv=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var e=new Array(16);return function(){for(var t,n=0;n<16;n++)0==(3&n)&&(t=4294967296*Math.random()),e[n]=t>>>((3&n)<<3)&255;return e}}(),Wv=[],zv=0;zv<256;zv++)Wv[zv]=(zv+256).toString(16).substr(1);var Gv=Fv();Gv[0],Gv[1],Gv[2],Gv[3],Gv[4],Gv[5],Gv[6],Gv[7];function Vv(t){return t instanceof Number||"number"==typeof t}function Hv(t){return t instanceof String||"string"==typeof t}function Uv(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}function Bv(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===n)if("object"===Rv(e[i])&&null!==e[i]&&kv(e[i])===Object.prototype)void 0===t[i]?t[i]=Bv({},e[i],n):"object"===Rv(t[i])&&null!==t[i]&&kv(t[i])===Object.prototype?Bv(t[i],e[i],n):Uv(t,e,i,r);else if(Av(e[i])){var o;t[i]=xv(o=e[i]).call(o)}else Uv(t,e,i,r);return t}function Zv(t){var e=Rv(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Av(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}var Xv=qo((function(t,e){t.exports=function(){var e,n;function r(){return e.apply(null,arguments)}function i(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function a(t){return void 0===t}function s(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function u(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function c(t,e){var n,r=[];for(n=0;n<t.length;++n)r.push(e(t[n],n));return r}function l(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t,e){for(var n in e)l(e,n)&&(t[n]=e[n]);return l(e,"toString")&&(t.toString=e.toString),l(e,"valueOf")&&(t.valueOf=e.valueOf),t}function f(t,e,n,r){return Le(t,e,n,r,!0).utc()}function d(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function p(t){if(null==t._isValid){var e=d(t),r=n.call(e.parsedDateParts,(function(t){return null!=t})),i=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&r);if(t._strict&&(i=i&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return i;t._isValid=i}return t._isValid}function y(t){var e=f(NaN);return null!=t?h(d(e),t):d(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),n=e.length>>>0,r=0;r<n;r++)if(r in e&&t.call(this,e[r],r,e))return!0;return!1};var v=r.momentProperties=[];function m(t,e){var n,r,i;if(a(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),a(e._i)||(t._i=e._i),a(e._f)||(t._f=e._f),a(e._l)||(t._l=e._l),a(e._strict)||(t._strict=e._strict),a(e._tzm)||(t._tzm=e._tzm),a(e._isUTC)||(t._isUTC=e._isUTC),a(e._offset)||(t._offset=e._offset),a(e._pf)||(t._pf=d(e)),a(e._locale)||(t._locale=e._locale),v.length>0)for(n=0;n<v.length;n++)a(i=e[r=v[n]])||(t[r]=i);return t}var g=!1;function _(t){m(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===g&&(g=!0,r.updateOffset(this),g=!1)}function w(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function b(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function S(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=b(e)),n}function x(t,e,n){var r,i=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(r=0;r<i;r++)(n&&t[r]!==e[r]||!n&&S(t[r])!==S(e[r]))&&a++;return a+o}function O(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function k(t,e){var n=!0;return h((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),n){for(var i,o=[],a=0;a<arguments.length;a++){if(i="","object"==typeof arguments[a]){for(var s in i+="\n["+a+"] ",arguments[0])i+=s+": "+arguments[0][s]+", ";i=i.slice(0,-2)}else i=arguments[a];o.push(i)}O(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),n=!1}return e.apply(this,arguments)}),e)}var M,D={};function T(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),D[t]||(O(e),D[t]=!0)}function P(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function A(t,e){var n,r=h({},t);for(n in e)l(e,n)&&(o(t[n])&&o(e[n])?(r[n]={},h(r[n],t[n]),h(r[n],e[n])):null!=e[n]?r[n]=e[n]:delete r[n]);for(n in t)l(t,n)&&!l(e,n)&&o(t[n])&&(r[n]=h({},r[n]));return r}function E(t){null!=t&&this.set(t)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,M=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)l(t,e)&&n.push(e);return n};var L={};function C(t,e){var n=t.toLowerCase();L[n]=L[n+"s"]=L[e]=t}function Y(t){return"string"==typeof t?L[t]||L[t.toLowerCase()]:void 0}function j(t){var e,n,r={};for(n in t)l(t,n)&&(e=Y(n))&&(r[e]=t[n]);return r}var R={};function I(t,e){R[t]=e}function N(t,e,n){var r=""+Math.abs(t),i=e-r.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+r}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,W=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,z={},G={};function V(t,e,n,r){var i=r;"string"==typeof r&&(i=function(){return this[r]()}),t&&(G[t]=i),e&&(G[e[0]]=function(){return N(i.apply(this,arguments),e[1],e[2])}),n&&(G[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function H(t,e){return t.isValid()?(e=U(e,t.localeData()),z[e]=z[e]||function(t){var e,n,r,i=t.match(F);for(e=0,n=i.length;e<n;e++)G[i[e]]?i[e]=G[i[e]]:i[e]=(r=i[e]).match(/\[[\s\S]/)?r.replace(/^\[|\]$/g,""):r.replace(/\\/g,"");return function(e){var r,o="";for(r=0;r<n;r++)o+=P(i[r])?i[r].call(e,t):i[r];return o}}(e),z[e](t)):t.localeData().invalidDate()}function U(t,e){var n=5;function r(t){return e.longDateFormat(t)||t}for(W.lastIndex=0;n>=0&&W.test(t);)t=t.replace(W,r),W.lastIndex=0,n-=1;return t}var B=/\d/,Z=/\d\d/,X=/\d{3}/,q=/\d{4}/,J=/[+-]?\d{6}/,$=/\d\d?/,Q=/\d\d\d\d?/,K=/\d\d\d\d\d\d?/,tt=/\d{1,3}/,et=/\d{1,4}/,nt=/[+-]?\d{1,6}/,rt=/\d+/,it=/[+-]?\d+/,ot=/Z|[+-]\d\d:?\d\d/gi,at=/Z|[+-]\d\d(?::?\d\d)?/gi,st=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,ut={};function ct(t,e,n){ut[t]=P(e)?e:function(t,r){return t&&n?n:e}}function lt(t,e){return l(ut,t)?ut[t](e._strict,e._locale):new RegExp(ht(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,r,i){return e||n||r||i}))))}function ht(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ft={};function dt(t,e){var n,r=e;for("string"==typeof t&&(t=[t]),s(e)&&(r=function(t,n){n[e]=S(t)}),n=0;n<t.length;n++)ft[t[n]]=r}function pt(t,e){dt(t,(function(t,n,r,i){r._w=r._w||{},e(t,r._w,r,i)}))}function yt(t,e,n){null!=e&&l(ft,t)&&ft[t](e,n._a,n,t)}var vt=0,mt=1,gt=2,_t=3,wt=4,bt=5,St=6,xt=7,Ot=8;function kt(t){return Mt(t)?366:365}function Mt(t){return t%4==0&&t%100!=0||t%400==0}V("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),V(0,["YY",2],0,(function(){return this.year()%100})),V(0,["YYYY",4],0,"year"),V(0,["YYYYY",5],0,"year"),V(0,["YYYYYY",6,!0],0,"year"),C("year","y"),I("year",1),ct("Y",it),ct("YY",$,Z),ct("YYYY",et,q),ct("YYYYY",nt,J),ct("YYYYYY",nt,J),dt(["YYYYY","YYYYYY"],vt),dt("YYYY",(function(t,e){e[vt]=2===t.length?r.parseTwoDigitYear(t):S(t)})),dt("YY",(function(t,e){e[vt]=r.parseTwoDigitYear(t)})),dt("Y",(function(t,e){e[vt]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return S(t)+(S(t)>68?1900:2e3)};var Dt,Tt=Pt("FullYear",!0);function Pt(t,e){return function(n){return null!=n?(Et(this,t,n),r.updateOffset(this,e),this):At(this,t)}}function At(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Et(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&Mt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),Lt(n,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](n))}function Lt(t,e){if(isNaN(t)||isNaN(e))return NaN;var n,r=(e%(n=12)+n)%n;return t+=(e-r)/12,1===r?Mt(t)?29:28:31-r%7%2}Dt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},V("M",["MM",2],"Mo",(function(){return this.month()+1})),V("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),V("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),C("month","M"),I("month",8),ct("M",$),ct("MM",$,Z),ct("MMM",(function(t,e){return e.monthsShortRegex(t)})),ct("MMMM",(function(t,e){return e.monthsRegex(t)})),dt(["M","MM"],(function(t,e){e[mt]=S(t)-1})),dt(["MMM","MMMM"],(function(t,e,n,r){var i=n._locale.monthsParse(t,r,n._strict);null!=i?e[mt]=i:d(n).invalidMonth=t}));var Ct=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Yt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),jt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Rt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],r=0;r<12;++r)o=f([2e3,r]),this._shortMonthsParse[r]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[r]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(i=Dt.call(this._shortMonthsParse,a))?i:null:-1!==(i=Dt.call(this._longMonthsParse,a))?i:null:"MMM"===e?-1!==(i=Dt.call(this._shortMonthsParse,a))?i:-1!==(i=Dt.call(this._longMonthsParse,a))?i:null:-1!==(i=Dt.call(this._longMonthsParse,a))?i:-1!==(i=Dt.call(this._shortMonthsParse,a))?i:null}function It(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=S(e);else if(!s(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),Lt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function Nt(t){return null!=t?(It(this,t),r.updateOffset(this,!0),this):At(this,"Month")}var Ft=st,Wt=st;function zt(){function t(t,e){return e.length-t.length}var e,n,r=[],i=[],o=[];for(e=0;e<12;e++)n=f([2e3,e]),r.push(this.monthsShort(n,"")),i.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(r.sort(t),i.sort(t),o.sort(t),e=0;e<12;e++)r[e]=ht(r[e]),i[e]=ht(i[e]);for(e=0;e<24;e++)o[e]=ht(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+r.join("|")+")","i")}function Gt(t,e,n,r,i,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,r,i,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,r,i,o,a),s}function Vt(t){var e;if(t<100&&t>=0){var n=Array.prototype.slice.call(arguments);n[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function Ht(t,e,n){var r=7+e-n;return-(7+Vt(t,0,r).getUTCDay()-e)%7+r-1}function Ut(t,e,n,r,i){var o,a,s=1+7*(e-1)+(7+n-r)%7+Ht(t,r,i);return s<=0?a=kt(o=t-1)+s:s>kt(t)?(o=t+1,a=s-kt(t)):(o=t,a=s),{year:o,dayOfYear:a}}function Bt(t,e,n){var r,i,o=Ht(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?r=a+Zt(i=t.year()-1,e,n):a>Zt(t.year(),e,n)?(r=a-Zt(t.year(),e,n),i=t.year()+1):(i=t.year(),r=a),{week:r,year:i}}function Zt(t,e,n){var r=Ht(t,e,n),i=Ht(t+1,e,n);return(kt(t)-r+i)/7}function Xt(t,e){return t.slice(e,7).concat(t.slice(0,e))}V("w",["ww",2],"wo","week"),V("W",["WW",2],"Wo","isoWeek"),C("week","w"),C("isoWeek","W"),I("week",5),I("isoWeek",5),ct("w",$),ct("ww",$,Z),ct("W",$),ct("WW",$,Z),pt(["w","ww","W","WW"],(function(t,e,n,r){e[r.substr(0,1)]=S(t)})),V("d",0,"do","day"),V("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),V("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),V("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),V("e",0,0,"weekday"),V("E",0,0,"isoWeekday"),C("day","d"),C("weekday","e"),C("isoWeekday","E"),I("day",11),I("weekday",11),I("isoWeekday",11),ct("d",$),ct("e",$),ct("E",$),ct("dd",(function(t,e){return e.weekdaysMinRegex(t)})),ct("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),ct("dddd",(function(t,e){return e.weekdaysRegex(t)})),pt(["dd","ddd","dddd"],(function(t,e,n,r){var i=n._locale.weekdaysParse(t,r,n._strict);null!=i?e.d=i:d(n).invalidWeekday=t})),pt(["d","e","E"],(function(t,e,n,r){e[r]=S(t)}));var qt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Jt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),$t="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Qt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],r=0;r<7;++r)o=f([2e3,1]).day(r),this._minWeekdaysParse[r]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[r]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[r]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(i=Dt.call(this._weekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:"dddd"===e?-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:null}var Kt=st,te=st,ee=st;function ne(){function t(t,e){return e.length-t.length}var e,n,r,i,o,a=[],s=[],u=[],c=[];for(e=0;e<7;e++)n=f([2e3,1]).day(e),r=this.weekdaysMin(n,""),i=this.weekdaysShort(n,""),o=this.weekdays(n,""),a.push(r),s.push(i),u.push(o),c.push(r),c.push(i),c.push(o);for(a.sort(t),s.sort(t),u.sort(t),c.sort(t),e=0;e<7;e++)s[e]=ht(s[e]),u[e]=ht(u[e]),c[e]=ht(c[e]);this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function re(){return this.hours()%12||12}function ie(t,e){V(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function oe(t,e){return e._meridiemParse}V("H",["HH",2],0,"hour"),V("h",["hh",2],0,re),V("k",["kk",2],0,(function(){return this.hours()||24})),V("hmm",0,0,(function(){return""+re.apply(this)+N(this.minutes(),2)})),V("hmmss",0,0,(function(){return""+re.apply(this)+N(this.minutes(),2)+N(this.seconds(),2)})),V("Hmm",0,0,(function(){return""+this.hours()+N(this.minutes(),2)})),V("Hmmss",0,0,(function(){return""+this.hours()+N(this.minutes(),2)+N(this.seconds(),2)})),ie("a",!0),ie("A",!1),C("hour","h"),I("hour",13),ct("a",oe),ct("A",oe),ct("H",$),ct("h",$),ct("k",$),ct("HH",$,Z),ct("hh",$,Z),ct("kk",$,Z),ct("hmm",Q),ct("hmmss",K),ct("Hmm",Q),ct("Hmmss",K),dt(["H","HH"],_t),dt(["k","kk"],(function(t,e,n){var r=S(t);e[_t]=24===r?0:r})),dt(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),dt(["h","hh"],(function(t,e,n){e[_t]=S(t),d(n).bigHour=!0})),dt("hmm",(function(t,e,n){var r=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r)),d(n).bigHour=!0})),dt("hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r,2)),e[bt]=S(t.substr(i)),d(n).bigHour=!0})),dt("Hmm",(function(t,e,n){var r=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r))})),dt("Hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r,2)),e[bt]=S(t.substr(i))}));var ae,se=Pt("Hours",!0),ue={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Yt,monthsShort:jt,week:{dow:0,doy:6},weekdays:qt,weekdaysMin:$t,weekdaysShort:Jt,meridiemParse:/[ap]\.?m?\.?/i},ce={},le={};function he(t){return t?t.toLowerCase().replace("_","-"):t}function fe(e){var n=null;if(!ce[e]&&t&&t.exports)try{n=ae._abbr,Xo(),de(n)}catch(t){}return ce[e]}function de(t,e){var n;return t&&((n=a(e)?ye(t):pe(t,e))?ae=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),ae._abbr}function pe(t,e){if(null!==e){var n,r=ue;if(e.abbr=t,null!=ce[t])T("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),r=ce[t]._config;else if(null!=e.parentLocale)if(null!=ce[e.parentLocale])r=ce[e.parentLocale]._config;else{if(null==(n=fe(e.parentLocale)))return le[e.parentLocale]||(le[e.parentLocale]=[]),le[e.parentLocale].push({name:t,config:e}),null;r=n._config}return ce[t]=new E(A(r,e)),le[t]&&le[t].forEach((function(t){pe(t.name,t.config)})),de(t),ce[t]}return delete ce[t],null}function ye(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return ae;if(!i(t)){if(e=fe(t))return e;t=[t]}return function(t){for(var e,n,r,i,o=0;o<t.length;){for(e=(i=he(t[o]).split("-")).length,n=(n=he(t[o+1]))?n.split("-"):null;e>0;){if(r=fe(i.slice(0,e).join("-")))return r;if(n&&n.length>=e&&x(i,n,!0)>=e-1)break;e--}o++}return ae}(t)}function ve(t){var e,n=t._a;return n&&-2===d(t).overflow&&(e=n[mt]<0||n[mt]>11?mt:n[gt]<1||n[gt]>Lt(n[vt],n[mt])?gt:n[_t]<0||n[_t]>24||24===n[_t]&&(0!==n[wt]||0!==n[bt]||0!==n[St])?_t:n[wt]<0||n[wt]>59?wt:n[bt]<0||n[bt]>59?bt:n[St]<0||n[St]>999?St:-1,d(t)._overflowDayOfYear&&(e<vt||e>gt)&&(e=gt),d(t)._overflowWeeks&&-1===e&&(e=xt),d(t)._overflowWeekday&&-1===e&&(e=Ot),d(t).overflow=e),t}function me(t,e,n){return null!=t?t:null!=e?e:n}function ge(t){var e,n,i,o,a,s=[];if(!t._d){for(i=function(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[gt]&&null==t._a[mt]&&function(t){var e,n,r,i,o,a,s,u;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,a=4,n=me(e.GG,t._a[vt],Bt(Ce(),1,4).year),r=me(e.W,1),((i=me(e.E,1))<1||i>7)&&(u=!0);else{o=t._locale._week.dow,a=t._locale._week.doy;var c=Bt(Ce(),o,a);n=me(e.gg,t._a[vt],c.year),r=me(e.w,c.week),null!=e.d?((i=e.d)<0||i>6)&&(u=!0):null!=e.e?(i=e.e+o,(e.e<0||e.e>6)&&(u=!0)):i=o}r<1||r>Zt(n,o,a)?d(t)._overflowWeeks=!0:null!=u?d(t)._overflowWeekday=!0:(s=Ut(n,r,i,o,a),t._a[vt]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(a=me(t._a[vt],i[vt]),(t._dayOfYear>kt(a)||0===t._dayOfYear)&&(d(t)._overflowDayOfYear=!0),n=Vt(a,0,t._dayOfYear),t._a[mt]=n.getUTCMonth(),t._a[gt]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=i[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[_t]&&0===t._a[wt]&&0===t._a[bt]&&0===t._a[St]&&(t._nextDay=!0,t._a[_t]=0),t._d=(t._useUTC?Vt:Gt).apply(null,s),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[_t]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(d(t).weekdayMismatch=!0)}}var _e=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,be=/Z|[+-]\d\d(?::?\d\d)?/,Se=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],xe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Oe=/^\/?Date\((\-?\d+)/i;function ke(t){var e,n,r,i,o,a,s=t._i,u=_e.exec(s)||we.exec(s);if(u){for(d(t).iso=!0,e=0,n=Se.length;e<n;e++)if(Se[e][1].exec(u[1])){i=Se[e][0],r=!1!==Se[e][2];break}if(null==i)return void(t._isValid=!1);if(u[3]){for(e=0,n=xe.length;e<n;e++)if(xe[e][1].exec(u[3])){o=(u[2]||" ")+xe[e][0];break}if(null==o)return void(t._isValid=!1)}if(!r&&null!=o)return void(t._isValid=!1);if(u[4]){if(!be.exec(u[4]))return void(t._isValid=!1);a="Z"}t._f=i+(o||"")+(a||""),Ae(t)}else t._isValid=!1}var Me=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function De(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}var Te={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Pe(t){var e,n,r,i,o,a,s,u=Me.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(u){var c=(e=u[4],n=u[3],r=u[2],i=u[5],o=u[6],a=u[7],s=[De(e),jt.indexOf(n),parseInt(r,10),parseInt(i,10),parseInt(o,10)],a&&s.push(parseInt(a,10)),s);if(!function(t,e,n){return!t||Jt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(d(n).weekdayMismatch=!0,n._isValid=!1,!1)}(u[1],c,t))return;t._a=c,t._tzm=function(t,e,n){if(t)return Te[t];if(e)return 0;var r=parseInt(n,10),i=r%100;return(r-i)/100*60+i}(u[8],u[9],u[10]),t._d=Vt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),d(t).rfc2822=!0}else t._isValid=!1}function Ae(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],d(t).empty=!0;var e,n,i,o,a,s=""+t._i,u=s.length,c=0;for(i=U(t._f,t._locale).match(F)||[],e=0;e<i.length;e++)o=i[e],(n=(s.match(lt(o,t))||[])[0])&&((a=s.substr(0,s.indexOf(n))).length>0&&d(t).unusedInput.push(a),s=s.slice(s.indexOf(n)+n.length),c+=n.length),G[o]?(n?d(t).empty=!1:d(t).unusedTokens.push(o),yt(o,n,t)):t._strict&&!n&&d(t).unusedTokens.push(o);d(t).charsLeftOver=u-c,s.length>0&&d(t).unusedInput.push(s),t._a[_t]<=12&&!0===d(t).bigHour&&t._a[_t]>0&&(d(t).bigHour=void 0),d(t).parsedDateParts=t._a.slice(0),d(t).meridiem=t._meridiem,t._a[_t]=function(t,e,n){var r;return null==n?e:null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((r=t.isPM(n))&&e<12&&(e+=12),r||12!==e||(e=0),e):e}(t._locale,t._a[_t],t._meridiem),ge(t),ve(t)}else Pe(t);else ke(t)}function Ee(t){var e=t._i,n=t._f;return t._locale=t._locale||ye(t._l),null===e||void 0===n&&""===e?y({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),w(e)?new _(ve(e)):(u(e)?t._d=e:i(n)?function(t){var e,n,r,i,o;if(0===t._f.length)return d(t).invalidFormat=!0,void(t._d=new Date(NaN));for(i=0;i<t._f.length;i++)o=0,e=m({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],Ae(e),p(e)&&(o+=d(e).charsLeftOver,o+=10*d(e).unusedTokens.length,d(e).score=o,(null==r||o<r)&&(r=o,n=e));h(t,n||e)}(t):n?Ae(t):function(t){var e=t._i;a(e)?t._d=new Date(r.now()):u(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=Oe.exec(t._i);null===e?(ke(t),!1===t._isValid&&(delete t._isValid,Pe(t),!1===t._isValid&&(delete t._isValid,r.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):i(e)?(t._a=c(e.slice(0),(function(t){return parseInt(t,10)})),ge(t)):o(e)?function(t){if(!t._d){var e=j(t._i);t._a=c([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),ge(t)}}(t):s(e)?t._d=new Date(e):r.createFromInputFallback(t)}(t),p(t)||(t._d=null),t))}function Le(t,e,n,r,a){var s,u={};return!0!==n&&!1!==n||(r=n,n=void 0),(o(t)&&function(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}(t)||i(t)&&0===t.length)&&(t=void 0),u._isAMomentObject=!0,u._useUTC=u._isUTC=a,u._l=n,u._i=t,u._f=e,u._strict=r,(s=new _(ve(Ee(u))))._nextDay&&(s.add(1,"d"),s._nextDay=void 0),s}function Ce(t,e,n,r){return Le(t,e,n,r,!1)}r.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Ye=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ce.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:y()})),je=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ce.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:y()}));function Re(t,e){var n,r;if(1===e.length&&i(e[0])&&(e=e[0]),!e.length)return Ce();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Ie=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Ne(t){var e=j(t),n=e.year||0,r=e.quarter||0,i=e.month||0,o=e.week||e.isoWeek||0,a=e.day||0,s=e.hour||0,u=e.minute||0,c=e.second||0,l=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Dt.call(Ie,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var n=!1,r=0;r<Ie.length;++r)if(t[Ie[r]]){if(n)return!1;parseFloat(t[Ie[r]])!==S(t[Ie[r]])&&(n=!0)}return!0}(e),this._milliseconds=+l+1e3*c+6e4*u+1e3*s*60*60,this._days=+a+7*o,this._months=+i+3*r+12*n,this._data={},this._locale=ye(),this._bubble()}function Fe(t){return t instanceof Ne}function We(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function ze(t,e){V(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+N(~~(t/60),2)+e+N(~~t%60,2)}))}ze("Z",":"),ze("ZZ",""),ct("Z",at),ct("ZZ",at),dt(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=Ve(at,t)}));var Ge=/([\+\-]|\d\d)/gi;function Ve(t,e){var n=(e||"").match(t);if(null===n)return null;var r=((n[n.length-1]||[])+"").match(Ge)||["-",0,0],i=60*r[1]+S(r[2]);return 0===i?0:"+"===r[0]?i:-i}function He(t,e){var n,i;return e._isUTC?(n=e.clone(),i=(w(t)||u(t)?t.valueOf():Ce(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Ce(t).local()}function Ue(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function Be(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var Ze=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Xe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function qe(t,e){var n,r,i,o,a,u,c=t,h=null;return Fe(t)?c={ms:t._milliseconds,d:t._days,M:t._months}:s(t)?(c={},e?c[e]=t:c.milliseconds=t):(h=Ze.exec(t))?(n="-"===h[1]?-1:1,c={y:0,d:S(h[gt])*n,h:S(h[_t])*n,m:S(h[wt])*n,s:S(h[bt])*n,ms:S(We(1e3*h[St]))*n}):(h=Xe.exec(t))?(n="-"===h[1]?-1:1,c={y:Je(h[2],n),M:Je(h[3],n),w:Je(h[4],n),d:Je(h[5],n),h:Je(h[6],n),m:Je(h[7],n),s:Je(h[8],n)}):null==c?c={}:"object"==typeof c&&("from"in c||"to"in c)&&(o=Ce(c.from),a=Ce(c.to),i=o.isValid()&&a.isValid()?(a=He(a,o),o.isBefore(a)?u=$e(o,a):((u=$e(a,o)).milliseconds=-u.milliseconds,u.months=-u.months),u):{milliseconds:0,months:0},(c={}).ms=i.milliseconds,c.M=i.months),r=new Ne(c),Fe(t)&&l(t,"_locale")&&(r._locale=t._locale),r}function Je(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function $e(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Qe(t,e){return function(n,r){var i;return null===r||isNaN(+r)||(T(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),i=n,n=r,r=i),Ke(this,qe(n="string"==typeof n?+n:n,r),t),this}}function Ke(t,e,n,i){var o=e._milliseconds,a=We(e._days),s=We(e._months);t.isValid()&&(i=null==i||i,s&&It(t,At(t,"Month")+s*n),a&&Et(t,"Date",At(t,"Date")+a*n),o&&t._d.setTime(t._d.valueOf()+o*n),i&&r.updateOffset(t,a||s))}qe.fn=Ne.prototype,qe.invalid=function(){return qe(NaN)};var tn=Qe(1,"add"),en=Qe(-1,"subtract");function nn(t,e){var n=12*(e.year()-t.year())+(e.month()-t.month()),r=t.clone().add(n,"months");return-(n+(e-r<0?(e-r)/(r-t.clone().add(n-1,"months")):(e-r)/(t.clone().add(n+1,"months")-r)))||0}function rn(t){var e;return void 0===t?this._locale._abbr:(null!=(e=ye(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var on=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function an(){return this._locale}var sn=1e3,un=60*sn,cn=60*un,ln=3506328*cn;function hn(t,e){return(t%e+e)%e}function fn(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-ln:new Date(t,e,n).valueOf()}function dn(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-ln:Date.UTC(t,e,n)}function pn(t,e){V(0,[t,t.length],0,e)}function yn(t,e,n,r,i){var o;return null==t?Bt(this,r,i).year:(e>(o=Zt(t,r,i))&&(e=o),vn.call(this,t,e,n,r,i))}function vn(t,e,n,r,i){var o=Ut(t,e,n,r,i),a=Vt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}V(0,["gg",2],0,(function(){return this.weekYear()%100})),V(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),pn("gggg","weekYear"),pn("ggggg","weekYear"),pn("GGGG","isoWeekYear"),pn("GGGGG","isoWeekYear"),C("weekYear","gg"),C("isoWeekYear","GG"),I("weekYear",1),I("isoWeekYear",1),ct("G",it),ct("g",it),ct("GG",$,Z),ct("gg",$,Z),ct("GGGG",et,q),ct("gggg",et,q),ct("GGGGG",nt,J),ct("ggggg",nt,J),pt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,r){e[r.substr(0,2)]=S(t)})),pt(["gg","GG"],(function(t,e,n,i){e[i]=r.parseTwoDigitYear(t)})),V("Q",0,"Qo","quarter"),C("quarter","Q"),I("quarter",7),ct("Q",B),dt("Q",(function(t,e){e[mt]=3*(S(t)-1)})),V("D",["DD",2],"Do","date"),C("date","D"),I("date",9),ct("D",$),ct("DD",$,Z),ct("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),dt(["D","DD"],gt),dt("Do",(function(t,e){e[gt]=S(t.match($)[0])}));var mn=Pt("Date",!0);V("DDD",["DDDD",3],"DDDo","dayOfYear"),C("dayOfYear","DDD"),I("dayOfYear",4),ct("DDD",tt),ct("DDDD",X),dt(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=S(t)})),V("m",["mm",2],0,"minute"),C("minute","m"),I("minute",14),ct("m",$),ct("mm",$,Z),dt(["m","mm"],wt);var gn=Pt("Minutes",!1);V("s",["ss",2],0,"second"),C("second","s"),I("second",15),ct("s",$),ct("ss",$,Z),dt(["s","ss"],bt);var _n,wn=Pt("Seconds",!1);for(V("S",0,0,(function(){return~~(this.millisecond()/100)})),V(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),V(0,["SSS",3],0,"millisecond"),V(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),V(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),V(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),V(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),V(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),V(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),C("millisecond","ms"),I("millisecond",16),ct("S",tt,B),ct("SS",tt,Z),ct("SSS",tt,X),_n="SSSS";_n.length<=9;_n+="S")ct(_n,rt);function bn(t,e){e[St]=S(1e3*("0."+t))}for(_n="S";_n.length<=9;_n+="S")dt(_n,bn);var Sn=Pt("Milliseconds",!1);V("z",0,0,"zoneAbbr"),V("zz",0,0,"zoneName");var xn=_.prototype;function On(t){return t}xn.add=tn,xn.calendar=function(t,e){var n=t||Ce(),i=He(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=e&&(P(e[o])?e[o].call(this,n):e[o]);return this.format(a||this.localeData().calendar(o,this,Ce(n)))},xn.clone=function(){return new _(this)},xn.diff=function(t,e,n){var r,i,o;if(!this.isValid())return NaN;if(!(r=He(t,this)).isValid())return NaN;switch(i=6e4*(r.utcOffset()-this.utcOffset()),e=Y(e)){case"year":o=nn(this,r)/12;break;case"month":o=nn(this,r);break;case"quarter":o=nn(this,r)/3;break;case"second":o=(this-r)/1e3;break;case"minute":o=(this-r)/6e4;break;case"hour":o=(this-r)/36e5;break;case"day":o=(this-r-i)/864e5;break;case"week":o=(this-r-i)/6048e5;break;default:o=this-r}return n?o:b(o)},xn.endOf=function(t){var e;if(void 0===(t=Y(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?dn:fn;switch(t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=cn-hn(e+(this._isUTC?0:this.utcOffset()*un),cn)-1;break;case"minute":e=this._d.valueOf(),e+=un-hn(e,un)-1;break;case"second":e=this._d.valueOf(),e+=sn-hn(e,sn)-1}return this._d.setTime(e),r.updateOffset(this,!0),this},xn.format=function(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=H(this,t);return this.localeData().postformat(e)},xn.from=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ce(t).isValid())?qe({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},xn.fromNow=function(t){return this.from(Ce(),t)},xn.to=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ce(t).isValid())?qe({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},xn.toNow=function(t){return this.to(Ce(),t)},xn.get=function(t){return P(this[t=Y(t)])?this[t]():this},xn.invalidAt=function(){return d(this).overflow},xn.isAfter=function(t,e){var n=w(t)?t:Ce(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())},xn.isBefore=function(t,e){var n=w(t)?t:Ce(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())},xn.isBetween=function(t,e,n,r){var i=w(t)?t:Ce(t),o=w(e)?e:Ce(e);return!!(this.isValid()&&i.isValid()&&o.isValid())&&("("===(r=r||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===r[1]?this.isBefore(o,n):!this.isAfter(o,n))},xn.isSame=function(t,e){var n,r=w(t)?t:Ce(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()===r.valueOf():(n=r.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))},xn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},xn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},xn.isValid=function(){return p(this)},xn.lang=on,xn.locale=rn,xn.localeData=an,xn.max=je,xn.min=Ye,xn.parsingFlags=function(){return h({},d(this))},xn.set=function(t,e){if("object"==typeof t)for(var n=function(t){var e=[];for(var n in t)e.push({unit:n,priority:R[n]});return e.sort((function(t,e){return t.priority-e.priority})),e}(t=j(t)),r=0;r<n.length;r++)this[n[r].unit](t[n[r].unit]);else if(P(this[t=Y(t)]))return this[t](e);return this},xn.startOf=function(t){var e;if(void 0===(t=Y(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?dn:fn;switch(t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=hn(e+(this._isUTC?0:this.utcOffset()*un),cn);break;case"minute":e=this._d.valueOf(),e-=hn(e,un);break;case"second":e=this._d.valueOf(),e-=hn(e,sn)}return this._d.setTime(e),r.updateOffset(this,!0),this},xn.subtract=en,xn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},xn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},xn.toDate=function(){return new Date(this.valueOf())},xn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?H(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):P(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",H(n,"Z")):H(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},xn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var n="["+t+'("]',r=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i=e+'[")]';return this.format(n+r+"-MM-DD[T]HH:mm:ss.SSS"+i)},xn.toJSON=function(){return this.isValid()?this.toISOString():null},xn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},xn.unix=function(){return Math.floor(this.valueOf()/1e3)},xn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},xn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},xn.year=Tt,xn.isLeapYear=function(){return Mt(this.year())},xn.weekYear=function(t){return yn.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},xn.isoWeekYear=function(t){return yn.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},xn.quarter=xn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},xn.month=Nt,xn.daysInMonth=function(){return Lt(this.year(),this.month())},xn.week=xn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},xn.isoWeek=xn.isoWeeks=function(t){var e=Bt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},xn.weeksInYear=function(){var t=this.localeData()._week;return Zt(this.year(),t.dow,t.doy)},xn.isoWeeksInYear=function(){return Zt(this.year(),1,4)},xn.date=mn,xn.day=xn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},xn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},xn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},xn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},xn.hour=xn.hours=se,xn.minute=xn.minutes=gn,xn.second=xn.seconds=wn,xn.millisecond=xn.milliseconds=Sn,xn.utcOffset=function(t,e,n){var i,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ve(at,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(i=Ue(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==t&&(!e||this._changeInProgress?Ke(this,qe(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Ue(this)},xn.utc=function(t){return this.utcOffset(0,t)},xn.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Ue(this),"m")),this},xn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ve(ot,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},xn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ce(t).utcOffset():0,(this.utcOffset()-t)%60==0)},xn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},xn.isLocal=function(){return!!this.isValid()&&!this._isUTC},xn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},xn.isUtc=Be,xn.isUTC=Be,xn.zoneAbbr=function(){return this._isUTC?"UTC":""},xn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},xn.dates=k("dates accessor is deprecated. Use date instead.",mn),xn.months=k("months accessor is deprecated. Use month instead",Nt),xn.years=k("years accessor is deprecated. Use year instead",Tt),xn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),xn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!a(this._isDSTShifted))return this._isDSTShifted;var t={};if(m(t,this),(t=Ee(t))._a){var e=t._isUTC?f(t._a):Ce(t._a);this._isDSTShifted=this.isValid()&&x(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var kn=E.prototype;function Mn(t,e,n,r){var i=ye(),o=f().set(r,e);return i[n](o,t)}function Dn(t,e,n){if(s(t)&&(e=t,t=void 0),t=t||"",null!=e)return Mn(t,e,n,"month");var r,i=[];for(r=0;r<12;r++)i[r]=Mn(t,r,n,"month");return i}function Tn(t,e,n,r){"boolean"==typeof t?(s(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,s(e)&&(n=e,e=void 0),e=e||"");var i,o=ye(),a=t?o._week.dow:0;if(null!=n)return Mn(e,(n+a)%7,r,"day");var u=[];for(i=0;i<7;i++)u[i]=Mn(e,(i+a)%7,r,"day");return u}kn.calendar=function(t,e,n){var r=this._calendar[t]||this._calendar.sameElse;return P(r)?r.call(e,n):r},kn.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])},kn.invalidDate=function(){return this._invalidDate},kn.ordinal=function(t){return this._ordinal.replace("%d",t)},kn.preparse=On,kn.postformat=On,kn.relativeTime=function(t,e,n,r){var i=this._relativeTime[n];return P(i)?i(t,e,n,r):i.replace(/%d/i,t)},kn.pastFuture=function(t,e){var n=this._relativeTime[t>0?"future":"past"];return P(n)?n(e):n.replace(/%s/i,e)},kn.set=function(t){var e,n;for(n in t)P(e=t[n])?this[n]=e:this["_"+n]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},kn.months=function(t,e){return t?i(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||Ct).test(e)?"format":"standalone"][t.month()]:i(this._months)?this._months:this._months.standalone},kn.monthsShort=function(t,e){return t?i(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[Ct.test(e)?"format":"standalone"][t.month()]:i(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},kn.monthsParse=function(t,e,n){var r,i,o;if(this._monthsParseExact)return Rt.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),r=0;r<12;r++){if(i=f([2e3,r]),n&&!this._longMonthsParse[r]&&(this._longMonthsParse[r]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[r]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[r]||(o="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[r]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[r].test(t))return r;if(n&&"MMM"===e&&this._shortMonthsParse[r].test(t))return r;if(!n&&this._monthsParse[r].test(t))return r}},kn.monthsRegex=function(t){return this._monthsParseExact?(l(this,"_monthsRegex")||zt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=Wt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},kn.monthsShortRegex=function(t){return this._monthsParseExact?(l(this,"_monthsRegex")||zt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=Ft),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},kn.week=function(t){return Bt(t,this._week.dow,this._week.doy).week},kn.firstDayOfYear=function(){return this._week.doy},kn.firstDayOfWeek=function(){return this._week.dow},kn.weekdays=function(t,e){var n=i(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Xt(n,this._week.dow):t?n[t.day()]:n},kn.weekdaysMin=function(t){return!0===t?Xt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},kn.weekdaysShort=function(t){return!0===t?Xt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},kn.weekdaysParse=function(t,e,n){var r,i,o;if(this._weekdaysParseExact)return Qt.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),r=0;r<7;r++){if(i=f([2e3,1]).day(r),n&&!this._fullWeekdaysParse[r]&&(this._fullWeekdaysParse[r]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[r]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[r]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[r]||(o="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[r]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[r].test(t))return r;if(n&&"ddd"===e&&this._shortWeekdaysParse[r].test(t))return r;if(n&&"dd"===e&&this._minWeekdaysParse[r].test(t))return r;if(!n&&this._weekdaysParse[r].test(t))return r}},kn.weekdaysRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Kt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},kn.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=te),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},kn.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ee),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},kn.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},kn.meridiem=function(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"},de("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===S(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=k("moment.lang is deprecated. Use moment.locale instead.",de),r.langData=k("moment.langData is deprecated. Use moment.localeData instead.",ye);var Pn=Math.abs;function An(t,e,n,r){var i=qe(e,n);return t._milliseconds+=r*i._milliseconds,t._days+=r*i._days,t._months+=r*i._months,t._bubble()}function En(t){return t<0?Math.floor(t):Math.ceil(t)}function Ln(t){return 4800*t/146097}function Cn(t){return 146097*t/4800}function Yn(t){return function(){return this.as(t)}}var jn=Yn("ms"),Rn=Yn("s"),In=Yn("m"),Nn=Yn("h"),Fn=Yn("d"),Wn=Yn("w"),zn=Yn("M"),Gn=Yn("Q"),Vn=Yn("y");function Hn(t){return function(){return this.isValid()?this._data[t]:NaN}}var Un=Hn("milliseconds"),Bn=Hn("seconds"),Zn=Hn("minutes"),Xn=Hn("hours"),qn=Hn("days"),Jn=Hn("months"),$n=Hn("years"),Qn=Math.round,Kn={ss:44,s:45,m:45,h:22,d:26,M:11};function tr(t,e,n,r,i){return i.relativeTime(e||1,!!n,t,r)}var er=Math.abs;function nr(t){return(t>0)-(t<0)||+t}function rr(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n=er(this._milliseconds)/1e3,r=er(this._days),i=er(this._months);t=b(n/60),e=b(t/60),n%=60,t%=60;var o=b(i/12),a=i%=12,s=r,u=e,c=t,l=n?n.toFixed(3).replace(/\.?0+$/,""):"",h=this.asSeconds();if(!h)return"P0D";var f=h<0?"-":"",d=nr(this._months)!==nr(h)?"-":"",p=nr(this._days)!==nr(h)?"-":"",y=nr(this._milliseconds)!==nr(h)?"-":"";return f+"P"+(o?d+o+"Y":"")+(a?d+a+"M":"")+(s?p+s+"D":"")+(u||c||l?"T":"")+(u?y+u+"H":"")+(c?y+c+"M":"")+(l?y+l+"S":"")}var ir=Ne.prototype;return ir.isValid=function(){return this._isValid},ir.abs=function(){var t=this._data;return this._milliseconds=Pn(this._milliseconds),this._days=Pn(this._days),this._months=Pn(this._months),t.milliseconds=Pn(t.milliseconds),t.seconds=Pn(t.seconds),t.minutes=Pn(t.minutes),t.hours=Pn(t.hours),t.months=Pn(t.months),t.years=Pn(t.years),this},ir.add=function(t,e){return An(this,t,e,1)},ir.subtract=function(t,e){return An(this,t,e,-1)},ir.as=function(t){if(!this.isValid())return NaN;var e,n,r=this._milliseconds;if("month"===(t=Y(t))||"quarter"===t||"year"===t)switch(e=this._days+r/864e5,n=this._months+Ln(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(Cn(this._months)),t){case"week":return e/7+r/6048e5;case"day":return e+r/864e5;case"hour":return 24*e+r/36e5;case"minute":return 1440*e+r/6e4;case"second":return 86400*e+r/1e3;case"millisecond":return Math.floor(864e5*e)+r;default:throw new Error("Unknown unit "+t)}},ir.asMilliseconds=jn,ir.asSeconds=Rn,ir.asMinutes=In,ir.asHours=Nn,ir.asDays=Fn,ir.asWeeks=Wn,ir.asMonths=zn,ir.asQuarters=Gn,ir.asYears=Vn,ir.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*S(this._months/12):NaN},ir._bubble=function(){var t,e,n,r,i,o=this._milliseconds,a=this._days,s=this._months,u=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*En(Cn(s)+a),a=0,s=0),u.milliseconds=o%1e3,t=b(o/1e3),u.seconds=t%60,e=b(t/60),u.minutes=e%60,n=b(e/60),u.hours=n%24,a+=b(n/24),i=b(Ln(a)),s+=i,a-=En(Cn(i)),r=b(s/12),s%=12,u.days=a,u.months=s,u.years=r,this},ir.clone=function(){return qe(this)},ir.get=function(t){return t=Y(t),this.isValid()?this[t+"s"]():NaN},ir.milliseconds=Un,ir.seconds=Bn,ir.minutes=Zn,ir.hours=Xn,ir.days=qn,ir.weeks=function(){return b(this.days()/7)},ir.months=Jn,ir.years=$n,ir.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),n=function(t,e,n){var r=qe(t).abs(),i=Qn(r.as("s")),o=Qn(r.as("m")),a=Qn(r.as("h")),s=Qn(r.as("d")),u=Qn(r.as("M")),c=Qn(r.as("y")),l=i<=Kn.ss&&["s",i]||i<Kn.s&&["ss",i]||o<=1&&["m"]||o<Kn.m&&["mm",o]||a<=1&&["h"]||a<Kn.h&&["hh",a]||s<=1&&["d"]||s<Kn.d&&["dd",s]||u<=1&&["M"]||u<Kn.M&&["MM",u]||c<=1&&["y"]||["yy",c];return l[2]=e,l[3]=+t>0,l[4]=n,tr.apply(null,l)}(this,!t,e);return t&&(n=e.pastFuture(+this,n)),e.postformat(n)},ir.toISOString=rr,ir.toString=rr,ir.toJSON=rr,ir.locale=rn,ir.localeData=an,ir.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",rr),ir.lang=on,V("X",0,0,"unix"),V("x",0,0,"valueOf"),ct("x",it),ct("X",/[+-]?\d+(\.\d{1,3})?/),dt("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t,10))})),dt("x",(function(t,e,n){n._d=new Date(S(t))})),r.version="2.24.0",e=Ce,r.fn=xn,r.min=function(){return Re("isBefore",[].slice.call(arguments,0))},r.max=function(){return Re("isAfter",[].slice.call(arguments,0))},r.now=function(){return Date.now?Date.now():+new Date},r.utc=f,r.unix=function(t){return Ce(1e3*t)},r.months=function(t,e){return Dn(t,e,"months")},r.isDate=u,r.locale=de,r.invalid=y,r.duration=qe,r.isMoment=w,r.weekdays=function(t,e,n){return Tn(t,e,n,"weekdays")},r.parseZone=function(){return Ce.apply(null,arguments).parseZone()},r.localeData=ye,r.isDuration=Fe,r.monthsShort=function(t,e){return Dn(t,e,"monthsShort")},r.weekdaysMin=function(t,e,n){return Tn(t,e,n,"weekdaysMin")},r.defineLocale=pe,r.updateLocale=function(t,e){if(null!=e){var n,r,i=ue;null!=(r=fe(t))&&(i=r._config),e=A(i,e),(n=new E(e)).parentLocale=ce[t],ce[t]=n,de(t)}else null!=ce[t]&&(null!=ce[t].parentLocale?ce[t]=ce[t].parentLocale:null!=ce[t]&&delete ce[t]);return ce[t]},r.locales=function(){return M(ce)},r.weekdaysShort=function(t,e,n){return Tn(t,e,n,"weekdaysShort")},r.normalizeUnits=Y,r.relativeTimeRounding=function(t){return void 0===t?Qn:"function"==typeof t&&(Qn=t,!0)},r.relativeTimeThreshold=function(t,e){return void 0!==Kn[t]&&(void 0===e?Kn[t]:(Kn[t]=e,"s"===t&&(Kn.ss=e-1),!0))},r.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},r.prototype=xn,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()})),qv=/^\/?Date\((-?\d+)/i;function Jv(t){return Xv.isMoment(t)}function $v(t,e){var n;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Hv(t)&&!isNaN(Date.parse(t))?Xv(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(Vv(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(Jv(t))return new Date(t.valueOf());if(Hv(t))return(n=qv.exec(t))?new Date(Number(n[1])):Xv(new Date(t)).toDate();throw new Error("Cannot convert object of type "+Zv(t)+" to type Date");case"Moment":if(Vv(t))return Xv(t);if(t instanceof Date)return Xv(t.valueOf());if(Jv(t))return Xv(t);if(Hv(t))return n=qv.exec(t),Xv(n?Number(n[1]):t);throw new Error("Cannot convert object of type "+Zv(t)+" to type Date");case"ISODate":if(Vv(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(Jv(t))return t.toDate().toISOString();if(Hv(t))return(n=qv.exec(t))?new Date(Number(n[1])).toISOString():Xv(t).format();throw new Error("Cannot convert object of type "+Zv(t)+" to type ISODate");case"ASPDate":if(Vv(t))return"/Date("+t+")/";if(t instanceof Date||Jv(t))return"/Date("+t.valueOf()+")/";if(Hv(t))return"/Date("+((n=qv.exec(t))?new Date(Number(n[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+Zv(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function Qv(t){return"string"==typeof t||"number"==typeof t}var Kv=Math.max,tm=Math.min;Ra({target:"Array",proto:!0,forced:!Bl("splice")},{splice:function(t,e){var n,r,i,o,a,s,u=js(this),c=Va(u.length),l=Ba(t,c),h=arguments.length;if(0===h?n=r=0:1===h?(n=0,r=c-l):(n=h-2,r=tm(Kv(za(e),0),c-l)),c+n-r>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=ku(u,r),o=0;o<r;o++)(a=l+o)in u&&us(i,o,u[a]);if(i.length=r,n<r){for(o=l;o<c-r;o++)s=o+n,(a=o+r)in u?u[s]=u[a]:delete u[s];for(o=c;o>c-r+n;o--)delete u[o-1]}else if(n>r)for(o=c-r;o>l;o--)s=o+n-1,(a=o+r-1)in u?u[s]=u[a]:delete u[s];for(o=0;o<n;o++)u[o+l]=arguments[o+2];return u.length=c-r+n,i}});var em=Lu("Array").splice,nm=Array.prototype,rm=function(t){var e=t.splice;return t===nm||t instanceof Array&&e===nm.splice?em:e},im=[].slice,om=/MSIE .\./.test(Wl),am=function(t){return function(e,n){var r=arguments.length>2,i=r?im.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,n)}};Ra({global:!0,bind:!0,forced:om},{setTimeout:am($o.setTimeout),setInterval:am($o.setInterval)});var sm=Da.setTimeout,um=function(){function t(e){Hh(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return Bh(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,n=0;n<e.length;n++){var r=e[n];r.original?t[r.name]=r.original:delete t[r.name]}this._extended=null}}},{key:"replace",value:function(t,e){var n=this,r=t[e];if(!r)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];n.queue({args:e,fn:r,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=sm((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Ru(t=rm(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,n){var r=new t(n);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){r.flush()};var i=[{name:"flush",original:void 0}];if(n&&n.replace)for(var o=0;o<n.replace.length;o++){var a=n.replace[o];i.push({name:a,original:e[a]}),r.replace(e,a)}return r._extended={object:e,methods:i},r}}]),t}(),cm=function(){function t(){Hh(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Bh(t,[{key:"_trigger",value:function(t,e,n){var r,i;if("*"===t)throw new Error("Cannot trigger event *");Ru(r=oh(i=[]).call(i,Fl(this._subscribers[t]),Fl(this._subscribers["*"]))).call(r,(function(r){r(t,e,null!=n?n:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var n;this._subscribers[t]=Ql(n=this._subscribers[t]).call(n,(function(t){return t!==e}))}}]),t}(),lm=(Yh("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),zh),Da.Set),hm=tf;var fm=function(t){if(bl(t))return t};var dm=function(t,e){if(Yl(Object(t))||"[object Arguments]"===Object.prototype.toString.call(t)){var n=[],r=!0,i=!1,o=void 0;try{for(var a,s=nl(t);!(r=(a=s.next()).done)&&(n.push(a.value),!e||n.length!==e);r=!0);}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return n}};var pm=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")};var ym=function(t,e){return fm(t)||dm(t,e)||pm()},vm=function(){function t(e){Hh(this,t),this._pairs=e}return Bh(t,[{key:Wc,value:Yc.mark((function t(){var e,n,r,i,o,a,s,u;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=!0,n=!1,r=void 0,t.prev=3,i=nl(this._pairs);case 5:if(e=(o=i.next()).done){t.next=12;break}return a=ym(o.value,2),s=a[0],u=a[1],t.next=9,[s,u];case 9:e=!0,t.next=5;break;case 12:t.next=18;break;case 14:t.prev=14,t.t0=t.catch(3),n=!0,r=t.t0;case 18:t.prev=18,t.prev=19,e||null==i.return||i.return();case 21:if(t.prev=21,!n){t.next=24;break}throw r;case 24:return t.finish(21);case 25:return t.finish(18);case 26:case"end":return t.stop()}}),t,this,[[3,14,18,26],[19,,21,25]])}))},{key:"entries",value:Yc.mark((function t(){var e,n,r,i,o,a,s,u;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=!0,n=!1,r=void 0,t.prev=3,i=nl(this._pairs);case 5:if(e=(o=i.next()).done){t.next=12;break}return a=ym(o.value,2),s=a[0],u=a[1],t.next=9,[s,u];case 9:e=!0,t.next=5;break;case 12:t.next=18;break;case 14:t.prev=14,t.t0=t.catch(3),n=!0,r=t.t0;case 18:t.prev=18,t.prev=19,e||null==i.return||i.return();case 21:if(t.prev=21,!n){t.next=24;break}throw r;case 24:return t.finish(21);case 25:return t.finish(18);case 26:case"end":return t.stop()}}),t,this,[[3,14,18,26],[19,,21,25]])}))},{key:"keys",value:Yc.mark((function t(){var e,n,r,i,o,a,s;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=!0,n=!1,r=void 0,t.prev=3,i=nl(this._pairs);case 5:if(e=(o=i.next()).done){t.next=12;break}return a=ym(o.value,1),s=a[0],t.next=9,s;case 9:e=!0,t.next=5;break;case 12:t.next=18;break;case 14:t.prev=14,t.t0=t.catch(3),n=!0,r=t.t0;case 18:t.prev=18,t.prev=19,e||null==i.return||i.return();case 21:if(t.prev=21,!n){t.next=24;break}throw r;case 24:return t.finish(21);case 25:return t.finish(18);case 26:case"end":return t.stop()}}),t,this,[[3,14,18,26],[19,,21,25]])}))},{key:"values",value:Yc.mark((function t(){var e,n,r,i,o,a,s;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=!0,n=!1,r=void 0,t.prev=3,i=nl(this._pairs);case 5:if(e=(o=i.next()).done){t.next=12;break}return a=ym(o.value,2),s=a[1],t.next=9,s;case 9:e=!0,t.next=5;break;case 12:t.next=18;break;case 14:t.prev=14,t.t0=t.catch(3),n=!0,r=t.t0;case 18:t.prev=18,t.prev=19,e||null==i.return||i.return();case 21:if(t.prev=21,!n){t.next=24;break}throw r;case 24:return t.finish(21);case 25:return t.finish(18);case 26:case"end":return t.stop()}}),t,this,[[3,14,18,26],[19,,21,25]])}))},{key:"toIdArray",value:function(){var t;return _h(t=Fl(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return _h(t=Fl(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Fl(this._pairs)}},{key:"toObjectMap",value:function(){var t=hm(null),e=!0,n=!1,r=void 0;try{for(var i,o=nl(this._pairs);!(e=(i=o.next()).done);e=!0){var a=ym(i.value,2),s=a[0],u=a[1];t[s]=u}}catch(t){n=!0,r=t}finally{try{e||null==o.return||o.return()}finally{if(n)throw r}}return t}},{key:"toMap",value:function(){return new Gh(this._pairs)}},{key:"toIdSet",value:function(){return new lm(this.toIdArray())}},{key:"toItemSet",value:function(){return new lm(this.toItemArray())}},{key:"cache",value:function(){return new t(Fl(this._pairs))}},{key:"distinct",value:function(t){var e=new lm,n=!0,r=!1,i=void 0;try{for(var o,a=nl(this._pairs);!(n=(o=a.next()).done);n=!0){var s=ym(o.value,2),u=s[0],c=s[1];e.add(t(c,u))}}catch(t){r=!0,i=t}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return e}},{key:"filter",value:function(e){var n=this._pairs;return new t(qc({},Wc,Yc.mark((function t(){var r,i,o,a,s,u,c,l;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=!0,i=!1,o=void 0,t.prev=3,a=nl(n);case 5:if(r=(s=a.next()).done){t.next=13;break}if(u=ym(s.value,2),c=u[0],l=u[1],!e(l,c)){t.next=10;break}return t.next=10,[c,l];case 10:r=!0,t.next=5;break;case 13:t.next=19;break;case 15:t.prev=15,t.t0=t.catch(3),i=!0,o=t.t0;case 19:t.prev=19,t.prev=20,r||null==a.return||a.return();case 22:if(t.prev=22,!i){t.next=25;break}throw o;case 25:return t.finish(22);case 26:return t.finish(19);case 27:case"end":return t.stop()}}),t,null,[[3,15,19,27],[20,,22,26]])}))))}},{key:"forEach",value:function(t){var e=!0,n=!1,r=void 0;try{for(var i,o=nl(this._pairs);!(e=(i=o.next()).done);e=!0){var a=ym(i.value,2),s=a[0];t(a[1],s)}}catch(t){n=!0,r=t}finally{try{e||null==o.return||o.return()}finally{if(n)throw r}}}},{key:"map",value:function(e){var n=this._pairs;return new t(qc({},Wc,Yc.mark((function t(){var r,i,o,a,s,u,c,l;return Yc.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=!0,i=!1,o=void 0,t.prev=3,a=nl(n);case 5:if(r=(s=a.next()).done){t.next=12;break}return u=ym(s.value,2),c=u[0],l=u[1],t.next=9,[c,e(l,c)];case 9:r=!0,t.next=5;break;case 12:t.next=18;break;case 14:t.prev=14,t.t0=t.catch(3),i=!0,o=t.t0;case 18:t.prev=18,t.prev=19,r||null==a.return||a.return();case 21:if(t.prev=21,!i){t.next=24;break}throw o;case 24:return t.finish(21);case 25:return t.finish(18);case 26:case"end":return t.stop()}}),t,null,[[3,14,18,26],[19,,21,25]])}))))}},{key:"max",value:function(t){var e=nl(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=ym(n.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,r=s)}return r}},{key:"min",value:function(t){var e=nl(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=ym(n.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,r=s)}return r}},{key:"reduce",value:function(t,e){var n=!0,r=!1,i=void 0;try{for(var o,a=nl(this._pairs);!(n=(o=a.next()).done);n=!0){var s=ym(o.value,2),u=s[0];e=t(e,s[1],u)}}catch(t){r=!0,i=t}finally{try{n||null==a.return||a.return()}finally{if(r)throw i}}return e}},{key:"sort",value:function(e){var n=this;return new t(qc({},Wc,(function(){var t;return nl(ll(t=Fl(n._pairs)).call(t,(function(t,n){var r=ym(t,2),i=r[0],o=r[1],a=ym(n,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}();function mm(t,e){var n=kh(t);if(Sc){var r=Sc(t);e&&(r=Ql(r).call(r,(function(e){return Fu(t,e).enumerable}))),n.push.apply(n,r)}return n}var gm=function(){console.warn("Type coercion has been deprecated. Please, use data pipes instead. See https://visjs.github.io/vis-data/data/datapipe.html#TypeCoercion for more details with working migration example."),console.trace()},_m=function(t){function e(t,n){var r;if(Hh(this,e),r=Xh(this,Qh(e).call(this)),t&&!Vh(t)&&(n=t,t=[]),r._options=n||{},r._data=new Gh,r.length=0,r._idProp=r._options.fieldId||"id",r._type={},r._options.type){gm();for(var i=kh(r._options.type),o=0,a=i.length;o<a;o++){var s=i[o],u=r._options.type[s];r._type[s]="Date"==u||"ISODate"==u||"ASPDate"==u?"Date":u}}return t&&t.length&&r.add(t),r.setOptions(n),r}return rf(e,t),Bh(e,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=um.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===xh(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var n,r=this,i=[];if(Vh(t)){var o=_h(t).call(t,(function(t){return t[r._idProp]}));if(dh(o).call(o,(function(t){return r._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)n=this._addItem(t[a]),i.push(n)}else{if(!t||"object"!==xh(t))throw new Error("Unknown dataType");n=this._addItem(t),i.push(n)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var n=this,r=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&n._data.has(e)){var u=t,c=ch({},n._data.get(e)),l=n._updateItem(u);i.push(l),a.push(u),o.push(c)}else{var h=n._addItem(t);r.push(h)}};if(Vh(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===xh(t[c])?u(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==xh(t))throw new Error("Unknown dataType");u(t)}if(r.length&&this._trigger("add",{items:r},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return oh(r).call(r,i)}},{key:"updateOnly",value:function(t,e){var n,r=this;Vh(t)||(t=[t]);var i=_h(n=_h(t).call(t,(function(t){var e=r._data.get(t[r._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(n,(function(t){var e=t.oldData,n=t.update,i=e[r._idProp],o=Bv(Bv({},e),n);return r._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:_h(i).call(i,(function(t){return t.id})),oldData:_h(i).call(i,(function(t){return t.oldData})),data:_h(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var n=void 0,r=void 0,i=void 0;Qv(t)?(n=t,i=e):Vh(t)?(r=t,i=e):i=t;var o=i&&"Object"===i.returnType?"Object":"Array",a=i&&i.type||this._options.type,s=i&&Ql(i),u=[],c=null,l=null,h=null;if(null!=n)(c=this._getItem(n,a))&&s&&!s(c)&&(c=null);else if(null!=r)for(var f=0,d=r.length;f<d;f++)null==(c=this._getItem(r[f],a))||s&&!s(c)||u.push(c);else for(var p,y=0,v=(l=Fl(_l(p=this._data).call(p))).length;y<v;y++)h=l[y],null==(c=this._getItem(h,a))||s&&!s(c)||u.push(c);if(i&&i.order&&null==n&&this._sort(u,i.order),i&&i.fields){var m=i.fields;if(null!=n&&null!=c)c=this._filterFields(c,m);else for(var g=0,_=u.length;g<_;g++)u[g]=this._filterFields(u[g],m)}if("Object"==o){for(var w={},b=0,S=u.length;b<S;b++){var x=u[b];w[x[this._idProp]]=x}return w}return null!=n?c:u}},{key:"getIds",value:function(t){var e,n,r=this._data,i=t&&Ql(t),o=t&&t.order,a=t&&t.type||this._options.type,s=Fl(_l(r).call(r)),u=[];if(i)if(o){n=[];for(var c=0,l=s.length;c<l;c++){var h=s[c];i(e=this._getItem(h,a))&&n.push(e)}this._sort(n,o);for(var f=0,d=n.length;f<d;f++)u.push(n[f][this._idProp])}else for(var p=0,y=s.length;p<y;p++){var v=s[p];i(e=this._getItem(v,a))&&u.push(e[this._idProp])}else if(o){n=[];for(var m=0,g=s.length;m<g;m++){var _=s[m];n.push(r.get(_))}this._sort(n,o);for(var w=0,b=n.length;w<b;w++)u.push(n[w][this._idProp])}else for(var S=0,x=s.length;S<x;S++){var O=s[S];e=r.get(O),u.push(e[this._idProp])}return u}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var n=e&&Ql(e),r=e&&e.type||this._options.type,i=this._data,o=Fl(_l(i).call(i));if(e&&e.order)for(var a=this.get(e),s=0,u=a.length;s<u;s++){var c=a[s];t(c,c[this._idProp])}else for(var l=0,h=o.length;l<h;l++){var f=o[l],d=this._getItem(f,r);n&&!n(d)||t(d,f)}}},{key:"map",value:function(t,e){for(var n=e&&Ql(e),r=e&&e.type||this._options.type,i=[],o=this._data,a=Fl(_l(o).call(o)),s=0,u=a.length;s<u;s++){var c=a[s],l=this._getItem(c,r);n&&!n(l)||i.push(t(l,c))}return e&&e.order&&this._sort(i,e.order),i}},{key:"_filterFields",value:function(t,e){var n;return t?yl(n=Vh(e)?e:kh(e)).call(n,(function(e,n){return e[n]=t[n],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var n=e;ll(t).call(t,(function(t,e){var r=t[n],i=e[n];return r>i?1:r<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ll(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var n=[],r=[],i=Vh(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(n.push(u),r.push(s))}}return n.length&&this._trigger("remove",{items:n,oldData:r},e),n}},{key:"_remove",value:function(t){var e;if(Qv(t)?e=t:t&&"object"===xh(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var n=this._data.get(e)||null;return this._data.delete(e),--this.length,n}return null}},{key:"clear",value:function(t){for(var e,n=Fl(_l(e=this._data).call(e)),r=[],i=0,o=n.length;i<o;i++)r.push(this._data.get(n[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:n,oldData:r},t),n}},{key:"max",value:function(t){var e=null,n=null,r=!0,i=!1,o=void 0;try{for(var a,s=nl(Kc(u=this._data).call(u));!(r=(a=s.next()).done);r=!0){var u,c=a.value,l=c[t];"number"==typeof l&&(null==n||l>n)&&(e=c,n=l)}}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return e||null}},{key:"min",value:function(t){var e=null,n=null,r=!0,i=!1,o=void 0;try{for(var a,s=nl(Kc(u=this._data).call(u));!(r=(a=s.next()).done);r=!0){var u,c=a.value,l=c[t];"number"==typeof l&&(null==n||l<n)&&(e=c,n=l)}}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return e||null}},{key:"distinct",value:function(t){for(var e=this._data,n=Fl(_l(e).call(e)),r=[],i=this._options.type&&this._options.type[t]||null,o=0,a=0,s=n.length;a<s;a++){for(var u=n[a],c=e.get(u)[t],l=!1,h=0;h<o;h++)if(r[h]==c){l=!0;break}l||void 0===c||(r[o]=c,o++)}if(i){gm();for(var f=0,d=r.length;f<d;f++)r[f]=$v(r[f],i)}return r}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data.has(e))throw new Error("Cannot add item: item with id "+e+" already exists")}else e=hf(),t[this._idProp]=e;for(var n={},r=kh(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];null!=s&&gm(),n[a]=$v(t[a],s)}return this._data.set(e,n),++this.length,e}},{key:"_getItem",value:function(t,e){var n,r=this._data.get(t);if(!r)return null;var i=kh(r);if(e){gm(),n={};for(var o=0,a=i.length;o<a;o++){var s=i[o],u=r[s];n[s]=$v(u,e[s])}}else n=function(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)Ru(n=mm(Object(r),!0)).call(n,(function(e){qc(t,e,r[e])}));else if(fs)es(t,fs(r));else{var i;Ru(i=mm(Object(r))).call(i,(function(e){Na(t,e,Fu(r,e))}))}}return t}({},r);return null==n[this._idProp]&&(n[this._idProp]=r.id),n}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Zc(t)+")");var n=this._data.get(e);if(!n)throw new Error("Cannot update item: no item with id "+e+" found");for(var r=kh(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];null!=s&&gm(),n[a]=$v(t[a],s)}return e}},{key:"stream",value:function(t){if(t){var e=this._data;return new vm(qc({},Wc,Yc.mark((function n(){var r,i,o,a,s,u,c;return Yc.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:r=!0,i=!1,o=void 0,n.prev=3,a=nl(t);case 5:if(r=(s=a.next()).done){n.next=14;break}if(u=s.value,null==(c=e.get(u))){n.next=11;break}return n.next=11,[u,c];case 11:r=!0,n.next=5;break;case 14:n.next=20;break;case 16:n.prev=16,n.t0=n.catch(3),i=!0,o=n.t0;case 20:n.prev=20,n.prev=21,r||null==a.return||a.return();case 23:if(n.prev=23,!i){n.next=26;break}throw o;case 26:return n.finish(23);case 27:return n.finish(20);case 28:case"end":return n.stop()}}),n,null,[[3,16,20,28],[21,,23,27]])}))))}var n;return new vm(qc({},Wc,Cc(n=Mc(this._data)).call(n,this._data)))}}]),e}(cm),wm=function(t){function e(t,n){var r,i;return Hh(this,e),(i=Xh(this,Qh(e).call(this))).length=0,i._ids=new lm,i._options=n||{},i._listener=Cc(r=i._onEvent).call(r,Zh(i)),i.setData(t),i}return rf(e,t),Bh(e,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Ql(this._options)}),n=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:n})}if(null!=t){this._data=t;for(var r=this._data.getIds({filter:Ql(this._options)}),i=0,o=r.length;i<o;i++){var a=r[i];this._ids.add(a)}this.length=r.length,this._trigger("add",{items:r})}else this._data=new _m;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Ql(this._options)}),e=Fl(this._ids),n={},r=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];n[u]=!0,this._ids.has(u)||(r.push(u),this._ids.add(u))}for(var c=0,l=e.length;c<l;c++){var h=e[c],f=this._data.get(h);null==f?console.error("If you see this, report it please."):n[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=r.length-i.length,r.length&&this._trigger("add",{items:r}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var n,r=null;Qv(t)||Vh(t)?(r=t,n=e):n=t;var i=ch({},this._options,n),o=Ql(this._options),a=n&&Ql(n);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==r?this._data.get(i):this._data.get(r,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,n=Ql(this._options),r=null!=t?Ql(t):null;return e=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var n,r,i=Ql(this._options),o=e&&Ql(e);r=o?i?function(t){return i(t)&&o(t)}:o:i,Ru(n=this._data).call(n,t,{filter:r,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var n,r,i=Ql(this._options),o=e&&Ql(e);return r=o?i?function(t){return i(t)&&o(t)}:o:i,_h(n=this._data).call(n,t,{filter:r,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||qc({},Wc,Cc(e=_l(this._ids)).call(e,this._ids)))}},{key:"_onEvent",value:function(t,e,n){if(e&&e.items&&this._data){var r=e.items,i=[],o=[],a=[],s=[],u=[],c=[];switch(t){case"add":for(var l=0,h=r.length;l<h;l++){var f=r[l];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=r.length;d<p;d++){var y=r[d];this.get(y)?this._ids.has(y)?(o.push(y),u.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(y),i.push(y)):this._ids.has(y)&&(this._ids.delete(y),a.push(y),c.push(e.oldData[d]))}break;case"remove":for(var v=0,m=r.length;v<m;v++){var g=r[v];this._ids.has(g)&&(this._ids.delete(g),a.push(g),c.push(e.oldData[v]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},n),o.length&&this._trigger("update",{items:o,oldData:s,data:u},n),a.length&&this._trigger("remove",{items:a,oldData:c},n)}}}]),e}(cm),bm={DataSet:_m,DataView:wm,Queue:um},Sm=Object.freeze({default:bm,DataSet:_m,DataStream:vm,DataView:wm,Queue:um}),xm=function(t){return t&&t.Math==Math&&t},Om=xm("object"==typeof globalThis&&globalThis)||xm("object"==typeof window&&window)||xm("object"==typeof self&&self)||xm("object"==typeof Go&&Go)||Function("return this")(),km=function(t){try{return!!t()}catch(t){return!0}},Mm=!km((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),Dm={}.propertyIsEnumerable,Tm=Object.getOwnPropertyDescriptor,Pm={f:Tm&&!Dm.call({1:2},1)?function(t){var e=Tm(this,t);return!!e&&e.enumerable}:Dm},Am=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},Em={}.toString,Lm=function(t){return Em.call(t).slice(8,-1)},Cm="".split,Ym=km((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==Lm(t)?Cm.call(t,""):Object(t)}:Object,jm=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},Rm=function(t){return Ym(jm(t))},Im=function(t){return"object"==typeof t?null!==t:"function"==typeof t},Nm=function(t,e){if(!Im(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!Im(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!Im(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!Im(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},Fm={}.hasOwnProperty,Wm=function(t,e){return Fm.call(t,e)},zm=Om.document,Gm=Im(zm)&&Im(zm.createElement),Vm=function(t){return Gm?zm.createElement(t):{}},Hm=!Mm&&!km((function(){return 7!=Object.defineProperty(Vm("div"),"a",{get:function(){return 7}}).a})),Um=Object.getOwnPropertyDescriptor,Bm={f:Mm?Um:function(t,e){if(t=Rm(t),e=Nm(e,!0),Hm)try{return Um(t,e)}catch(t){}if(Wm(t,e))return Am(!Pm.f.call(t,e),t[e])}},Zm=/#|\.prototype\./,Xm=function(t,e){var n=Jm[qm(t)];return n==Qm||n!=$m&&("function"==typeof e?km(e):!!e)},qm=Xm.normalize=function(t){return String(t).replace(Zm,".").toLowerCase()},Jm=Xm.data={},$m=Xm.NATIVE="N",Qm=Xm.POLYFILL="P",Km=Xm,tg={},eg=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},ng=function(t,e,n){if(eg(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},rg=function(t){if(!Im(t))throw TypeError(String(t)+" is not an object");return t},ig=Object.defineProperty,og={f:Mm?ig:function(t,e,n){if(rg(t),e=Nm(e,!0),rg(n),Hm)try{return ig(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},ag=Mm?function(t,e,n){return og.f(t,e,Am(1,n))}:function(t,e,n){return t[e]=n,t},sg=Bm.f,ug=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},cg=function(t,e){var n,r,i,o,a,s,u,c,l=t.target,h=t.global,f=t.stat,d=t.proto,p=h?Om:f?Om[l]:(Om[l]||{}).prototype,y=h?tg:tg[l]||(tg[l]={}),v=y.prototype;for(i in e)n=!Km(h?i:l+(f?".":"#")+i,t.forced)&&p&&Wm(p,i),a=y[i],n&&(s=t.noTargetGet?(c=sg(p,i))&&c.value:p[i]),o=n&&s?s:e[i],n&&typeof a==typeof o||(u=t.bind&&n?ng(o,Om):t.wrap&&n?ug(o):d&&"function"==typeof o?ng(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&ag(u,"sham",!0),y[i]=u,d&&(Wm(tg,r=l+"Prototype")||ag(tg,r,{}),tg[r][i]=o,t.real&&v&&!v[i]&&ag(v,i,o)))},lg=Math.ceil,hg=Math.floor,fg=function(t){return isNaN(t=+t)?0:(t>0?hg:lg)(t)},dg=Math.min,pg=function(t){return t>0?dg(fg(t),9007199254740991):0},yg=Math.max,vg=Math.min,mg=function(t,e){var n=fg(t);return n<0?yg(n+e,0):vg(n,e)},gg=function(t){return function(e,n,r){var i,o=Rm(e),a=pg(o.length),s=mg(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},_g={includes:gg(!0),indexOf:gg(!1)},wg={},bg=_g.indexOf,Sg=function(t,e){var n,r=Rm(t),i=0,o=[];for(n in r)!Wm(wg,n)&&Wm(r,n)&&o.push(n);for(;e.length>i;)Wm(r,n=e[i++])&&(~bg(o,n)||o.push(n));return o},xg=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Og=Object.keys||function(t){return Sg(t,xg)},kg={f:Object.getOwnPropertySymbols},Mg=function(t){return Object(jm(t))},Dg=Object.assign,Tg=Object.defineProperty,Pg=!Dg||km((function(){if(Mm&&1!==Dg({b:1},Dg(Tg({},"a",{enumerable:!0,get:function(){Tg(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=Dg({},t)[n]||"abcdefghijklmnopqrst"!=Og(Dg({},e)).join("")}))?function(t,e){for(var n=Mg(t),r=arguments.length,i=1,o=kg.f,a=Pm.f;r>i;)for(var s,u=Ym(arguments[i++]),c=o?Og(u).concat(o(u)):Og(u),l=c.length,h=0;l>h;)s=c[h++],Mm&&!a.call(u,s)||(n[s]=u[s]);return n}:Dg;cg({target:"Object",stat:!0,forced:Object.assign!==Pg},{assign:Pg});var Ag=tg.Object.assign,Eg=function(t){return"function"==typeof t?t:void 0},Lg=function(t,e){return arguments.length<2?Eg(tg[t])||Eg(Om[t]):tg[t]&&tg[t][e]||Om[t]&&Om[t][e]},Cg=Lg("navigator","userAgent")||"",Yg=[].slice,jg=/MSIE .\./.test(Cg),Rg=function(t){return function(e,n){var r=arguments.length>2,i=r?Yg.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,n)}};cg({global:!0,bind:!0,forced:jg},{setTimeout:Rg(Om.setTimeout),setInterval:Rg(Om.setInterval)});var Ig,Ng,Fg=tg.setTimeout,Wg=Array.isArray||function(t){return"Array"==Lm(t)},zg=function(t,e,n){var r=Nm(e);r in t?og.f(t,r,Am(0,n)):t[r]=n},Gg=Om["__core-js_shared__"]||function(t,e){try{ag(Om,t,e)}catch(n){Om[t]=e}return e}("__core-js_shared__",{}),Vg=Ho((function(t){(t.exports=function(t,e){return Gg[t]||(Gg[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.1",mode:"pure",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),Hg=0,Ug=Math.random(),Bg=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Hg+Ug).toString(36)},Zg=!!Object.getOwnPropertySymbols&&!km((function(){return!String(Symbol())})),Xg=Zg&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,qg=Vg("wks"),Jg=Om.Symbol,$g=Xg?Jg:Jg&&Jg.withoutSetter||Bg,Qg=function(t){return Wm(qg,t)||(Zg&&Wm(Jg,t)?qg[t]=Jg[t]:qg[t]=$g("Symbol."+t)),qg[t]},Kg=Qg("species"),t_=function(t,e){var n;return Wg(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!Wg(n.prototype)?Im(n)&&null===(n=n[Kg])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},e_=Om.process,n_=e_&&e_.versions,r_=n_&&n_.v8;r_?Ng=(Ig=r_.split("."))[0]+Ig[1]:Cg&&(!(Ig=Cg.match(/Edge\/(\d+)/))||Ig[1]>=74)&&(Ig=Cg.match(/Chrome\/(\d+)/))&&(Ng=Ig[1]);var i_=Ng&&+Ng,o_=Qg("species"),a_=function(t){return i_>=51||!km((function(){var e=[];return(e.constructor={})[o_]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},s_=Qg("isConcatSpreadable"),u_=i_>=51||!km((function(){var t=[];return t[s_]=!1,t.concat()[0]!==t})),c_=a_("concat"),l_=function(t){if(!Im(t))return!1;var e=t[s_];return void 0!==e?!!e:Wg(t)};cg({target:"Array",proto:!0,forced:!u_||!c_},{concat:function(t){var e,n,r,i,o,a=Mg(this),s=t_(a,0),u=0;for(e=-1,r=arguments.length;e<r;e++)if(o=-1===e?a:arguments[e],l_(o)){if(u+(i=pg(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,u++)n in o&&zg(s,u,o[n])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");zg(s,u++,o)}return s.length=u,s}});var h_=function(t){return tg[t+"Prototype"]},f_=h_("Array").concat,d_=Array.prototype,p_=function(t){var e=t.concat;return t===d_||t instanceof Array&&e===d_.concat?f_:e},y_={f:Qg},v_=og.f,m_=function(t){var e=tg.Symbol||(tg.Symbol={});Wm(e,t)||v_(e,t,{value:y_.f(t)})};m_("iterator");var g_=function(t){return function(e,n){var r,i,o=String(jm(e)),a=fg(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},__={codeAt:g_(!1),charAt:g_(!0)},w_=Function.toString;"function"!=typeof Gg.inspectSource&&(Gg.inspectSource=function(t){return w_.call(t)});var b_,S_,x_,O_=Gg.inspectSource,k_=Om.WeakMap,M_="function"==typeof k_&&/native code/.test(O_(k_)),D_=Vg("keys"),T_=function(t){return D_[t]||(D_[t]=Bg(t))},P_=Om.WeakMap;if(M_){var A_=new P_,E_=A_.get,L_=A_.has,C_=A_.set;b_=function(t,e){return C_.call(A_,t,e),e},S_=function(t){return E_.call(A_,t)||{}},x_=function(t){return L_.call(A_,t)}}else{var Y_=T_("state");wg[Y_]=!0,b_=function(t,e){return ag(t,Y_,e),e},S_=function(t){return Wm(t,Y_)?t[Y_]:{}},x_=function(t){return Wm(t,Y_)}}var j_,R_,I_,N_={set:b_,get:S_,has:x_,enforce:function(t){return x_(t)?S_(t):b_(t,{})},getterFor:function(t){return function(e){var n;if(!Im(e)||(n=S_(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},F_=!km((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),W_=T_("IE_PROTO"),z_=Object.prototype,G_=F_?Object.getPrototypeOf:function(t){return t=Mg(t),Wm(t,W_)?t[W_]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?z_:null},V_=(Qg("iterator"),!1);[].keys&&("next"in(I_=[].keys())?(R_=G_(G_(I_)))!==Object.prototype&&(j_=R_):V_=!0),null==j_&&(j_={});var H_,U_={IteratorPrototype:j_,BUGGY_SAFARI_ITERATORS:V_},B_=Mm?Object.defineProperties:function(t,e){rg(t);for(var n,r=Og(e),i=r.length,o=0;i>o;)og.f(t,n=r[o++],e[n]);return t},Z_=Lg("document","documentElement"),X_=T_("IE_PROTO"),q_=function(){},J_=function(t){return"<script>"+t+"<\/script>"},$_=function(){try{H_=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;$_=H_?function(t){t.write(J_("")),t.close();var e=t.parentWindow.Object;return t=null,e}(H_):((e=Vm("iframe")).style.display="none",Z_.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(J_("document.F=Object")),t.close(),t.F);for(var n=xg.length;n--;)delete $_.prototype[xg[n]];return $_()};wg[X_]=!0;var Q_=Object.create||function(t,e){var n;return null!==t?(q_.prototype=rg(t),n=new q_,q_.prototype=null,n[X_]=t):n=$_(),void 0===e?n:B_(n,e)},K_={};K_[Qg("toStringTag")]="z";var tw="[object z]"===String(K_),ew=Qg("toStringTag"),nw="Arguments"==Lm(function(){return arguments}()),rw=tw?Lm:function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),ew))?n:nw?Lm(e):"Object"==(r=Lm(e))&&"function"==typeof e.callee?"Arguments":r},iw=tw?{}.toString:function(){return"[object "+rw(this)+"]"},ow=og.f,aw=Qg("toStringTag"),sw=function(t,e,n,r){if(t){var i=n?t:t.prototype;Wm(i,aw)||ow(i,aw,{configurable:!0,value:e}),r&&!tw&&ag(i,"toString",iw)}},uw=U_.IteratorPrototype,cw=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}}(),function(t,e,n,r){r&&r.enumerable?t[e]=n:ag(t,e,n)}),lw=U_.IteratorPrototype,hw=U_.BUGGY_SAFARI_ITERATORS,fw=Qg("iterator"),dw=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Q_(uw,{next:Am(1,n)}),sw(t,r,!1,!0)}(n,e,r);var s,u,c,l=function(t){if(t===i&&y)return y;if(!hw&&t in d)return d[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},h=e+" Iterator",f=!1,d=t.prototype,p=d[fw]||d["@@iterator"]||i&&d[i],y=!hw&&p||l(i),v="Array"==e&&d.entries||p;if(v&&(s=G_(v.call(new t)),lw!==Object.prototype&&s.next&&sw(s,h,!0,!0)),"values"==i&&p&&"values"!==p.name&&(f=!0,y=function(){return p.call(this)}),a&&d[fw]!==y&&ag(d,fw,y),i)if(u={values:l("values"),keys:o?y:l("keys"),entries:l("entries")},a)for(c in u)!hw&&!f&&c in d||cw(d,c,u[c]);else cg({target:e,proto:!0,forced:hw||f},u);return u},pw=__.charAt,yw=N_.set,vw=N_.getterFor("String Iterator");dw(String,"String",(function(t){yw(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=vw(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=pw(n,r),e.index+=t.length,{value:t,done:!1})}));var mw=N_.set,gw=N_.getterFor("Array Iterator"),_w=(dw(Array,"Array",(function(t,e){mw(this,{type:"Array Iterator",target:Rm(t),index:0,kind:e})}),(function(){var t=gw(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values"),Qg("toStringTag"));for(var ww in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var bw=Om[ww],Sw=bw&&bw.prototype;Sw&&rw(Sw)!==_w&&ag(Sw,_w,ww)}var xw=y_.f("iterator"),Ow=Object.freeze({}),kw=xg.concat("length","prototype"),Mw={f:Object.getOwnPropertyNames||function(t){return Sg(t,kw)}},Dw=Mw.f,Tw={}.toString,Pw="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Aw={f:function(t){return Pw&&"[object Window]"==Tw.call(t)?function(t){try{return Dw(t)}catch(t){return Pw.slice()}}(t):Dw(Rm(t))}},Ew=[].push,Lw=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=5==t||o;return function(s,u,c,l){for(var h,f,d=Mg(s),p=Ym(d),y=ng(u,c,3),v=pg(p.length),m=0,g=l||t_,_=e?g(s,v):n?g(s,0):void 0;v>m;m++)if((a||m in p)&&(f=y(h=p[m],m,d),t))if(e)_[m]=f;else if(f)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:Ew.call(_,h)}else if(i)return!1;return o?-1:r||i?i:_}},Cw={forEach:Lw(0),map:Lw(1),filter:Lw(2),some:Lw(3),every:Lw(4),find:Lw(5),findIndex:Lw(6)},Yw=Cw.forEach,jw=T_("hidden"),Rw=Qg("toPrimitive"),Iw=N_.set,Nw=N_.getterFor("Symbol"),Fw=Object.prototype,Ww=Om.Symbol,zw=Lg("JSON","stringify"),Gw=Bm.f,Vw=og.f,Hw=Aw.f,Uw=Pm.f,Bw=Vg("symbols"),Zw=Vg("op-symbols"),Xw=Vg("string-to-symbol-registry"),qw=Vg("symbol-to-string-registry"),Jw=Vg("wks"),$w=Om.QObject,Qw=!$w||!$w.prototype||!$w.prototype.findChild,Kw=Mm&&km((function(){return 7!=Q_(Vw({},"a",{get:function(){return Vw(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=Gw(Fw,e);r&&delete Fw[e],Vw(t,e,n),r&&t!==Fw&&Vw(Fw,e,r)}:Vw,tb=function(t,e){var n=Bw[t]=Q_(Ww.prototype);return Iw(n,{type:"Symbol",tag:t,description:e}),Mm||(n.description=e),n},eb=Xg?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ww},nb=function(t,e,n){t===Fw&&nb(Zw,e,n),rg(t);var r=Nm(e,!0);return rg(n),Wm(Bw,r)?(n.enumerable?(Wm(t,jw)&&t[jw][r]&&(t[jw][r]=!1),n=Q_(n,{enumerable:Am(0,!1)})):(Wm(t,jw)||Vw(t,jw,Am(1,{})),t[jw][r]=!0),Kw(t,r,n)):Vw(t,r,n)},rb=function(t,e){rg(t);var n=Rm(e),r=Og(n).concat(sb(n));return Yw(r,(function(e){Mm&&!ib.call(n,e)||nb(t,e,n[e])})),t},ib=function(t){var e=Nm(t,!0),n=Uw.call(this,e);return!(this===Fw&&Wm(Bw,e)&&!Wm(Zw,e))&&(!(n||!Wm(this,e)||!Wm(Bw,e)||Wm(this,jw)&&this[jw][e])||n)},ob=function(t,e){var n=Rm(t),r=Nm(e,!0);if(n!==Fw||!Wm(Bw,r)||Wm(Zw,r)){var i=Gw(n,r);return!i||!Wm(Bw,r)||Wm(n,jw)&&n[jw][r]||(i.enumerable=!0),i}},ab=function(t){var e=Hw(Rm(t)),n=[];return Yw(e,(function(t){Wm(Bw,t)||Wm(wg,t)||n.push(t)})),n},sb=function(t){var e=t===Fw,n=Hw(e?Zw:Rm(t)),r=[];return Yw(n,(function(t){!Wm(Bw,t)||e&&!Wm(Fw,t)||r.push(Bw[t])})),r};if(Zg||(cw((Ww=function(){if(this instanceof Ww)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Bg(t),n=function(t){this===Fw&&n.call(Zw,t),Wm(this,jw)&&Wm(this[jw],e)&&(this[jw][e]=!1),Kw(this,e,Am(1,t))};return Mm&&Qw&&Kw(Fw,e,{configurable:!0,set:n}),tb(e,t)}).prototype,"toString",(function(){return Nw(this).tag})),cw(Ww,"withoutSetter",(function(t){return tb(Bg(t),t)})),Pm.f=ib,og.f=nb,Bm.f=ob,Mw.f=Aw.f=ab,kg.f=sb,y_.f=function(t){return tb(Qg(t),t)},Mm&&Vw(Ww.prototype,"description",{configurable:!0,get:function(){return Nw(this).description}})),cg({global:!0,wrap:!0,forced:!Zg,sham:!Zg},{Symbol:Ww}),Yw(Og(Jw),(function(t){m_(t)})),cg({target:"Symbol",stat:!0,forced:!Zg},{for:function(t){var e=String(t);if(Wm(Xw,e))return Xw[e];var n=Ww(e);return Xw[e]=n,qw[n]=e,n},keyFor:function(t){if(!eb(t))throw TypeError(t+" is not a symbol");if(Wm(qw,t))return qw[t]},useSetter:function(){Qw=!0},useSimple:function(){Qw=!1}}),cg({target:"Object",stat:!0,forced:!Zg,sham:!Mm},{create:function(t,e){return void 0===e?Q_(t):rb(Q_(t),e)},defineProperty:nb,defineProperties:rb,getOwnPropertyDescriptor:ob}),cg({target:"Object",stat:!0,forced:!Zg},{getOwnPropertyNames:ab,getOwnPropertySymbols:sb}),cg({target:"Object",stat:!0,forced:km((function(){kg.f(1)}))},{getOwnPropertySymbols:function(t){return kg.f(Mg(t))}}),zw){var ub=!Zg||km((function(){var t=Ww();return"[null]"!=zw([t])||"{}"!=zw({a:t})||"{}"!=zw(Object(t))}));cg({target:"JSON",stat:!0,forced:ub},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(Im(e)||void 0!==t)&&!eb(t))return Wg(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!eb(e))return e}),i[1]=e,zw.apply(null,i)}})}Ww.prototype[Rw]||ag(Ww.prototype,Rw,Ww.prototype.valueOf),sw(Ww,"Symbol"),wg[jw]=!0,m_("asyncIterator");var cb=Object.freeze({});m_("hasInstance"),m_("isConcatSpreadable"),m_("match"),m_("matchAll"),m_("replace"),m_("search"),m_("species"),m_("split"),m_("toPrimitive"),m_("toStringTag"),m_("unscopables"),sw(Math,"Math",!0),sw(Om.JSON,"JSON",!0),Uo(Ow),Uo(cb);var lb=tg.Symbol;m_("asyncDispose"),m_("dispose"),m_("observable"),m_("patternMatch"),m_("replaceAll");var hb=lb,fb=Ho((function(t){function e(n){return t.exports=e="function"==typeof hb&&"symbol"==typeof xw?function(t){return typeof t}:function(t){return t&&"function"==typeof hb&&t.constructor===hb&&t!==hb.prototype?"symbol":typeof t},e(n)}t.exports=e})),db=function(t,e){var n=[][t];return!n||!km((function(){n.call(null,e||function(){throw 1},1)}))},pb=Cw.forEach,yb=db("forEach")?function(t){return pb(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;cg({target:"Array",proto:!0,forced:[].forEach!=yb},{forEach:yb});var vb=h_("Array").forEach,mb=Array.prototype,gb={DOMTokenList:!0,NodeList:!0},_b=function(t){var e=t.forEach;return t===mb||t instanceof Array&&e===mb.forEach||gb.hasOwnProperty(rw(t))?vb:e},wb="\t\n\v\f\r                　\u2028\u2029\ufeff",bb="["+wb+"]",Sb=RegExp("^"+bb+bb+"*"),xb=RegExp(bb+bb+"*$"),Ob=function(t){return function(e){var n=String(jm(e));return 1&t&&(n=n.replace(Sb,"")),2&t&&(n=n.replace(xb,"")),n}},kb={start:Ob(1),end:Ob(2),trim:Ob(3)},Mb=kb.trim,Db=Om.parseInt,Tb=/^[+-]?0[Xx]/,Pb=8!==Db(wb+"08")||22!==Db(wb+"0x16")?function(t,e){var n=Mb(String(t));return Db(n,e>>>0||(Tb.test(n)?16:10))}:Db;cg({global:!0,forced:parseInt!=Pb},{parseInt:Pb});var Ab=tg.parseInt,Eb=h_("Array").values,Lb=Array.prototype,Cb={DOMTokenList:!0,NodeList:!0},Yb=function(t){var e=t.values;return t===Lb||t instanceof Array&&e===Lb.values||Cb.hasOwnProperty(rw(t))?Eb:e};cg({target:"Array",proto:!0},{fill:function(t){for(var e=Mg(this),n=pg(e.length),r=arguments.length,i=mg(r>1?arguments[1]:void 0,n),o=r>2?arguments[2]:void 0,a=void 0===o?n:mg(o,n);a>i;)e[i++]=t;return e}});var jb=h_("Array").fill,Rb=Array.prototype,Ib=function(t){var e=t.fill;return t===Rb||t instanceof Array&&e===Rb.fill?jb:e},Nb=kb.trim,Fb=Om.parseFloat,Wb=1/Fb(wb+"-0")!=-1/0?function(t){var e=Nb(String(t)),n=Fb(e);return 0===n&&"-"==e.charAt(0)?-0:n}:Fb;cg({global:!0,forced:parseFloat!=Wb},{parseFloat:Wb});var zb=tg.parseFloat,Gb=Cw.filter,Vb=a_("filter"),Hb=Vb&&!km((function(){[].filter.call({length:-1,0:1},(function(t){throw t}))}));cg({target:"Array",proto:!0,forced:!Vb||!Hb},{filter:function(t){return Gb(this,t,arguments.length>1?arguments[1]:void 0)}});var Ub=h_("Array").filter,Bb=Array.prototype,Zb=function(t){var e=t.filter;return t===Bb||t instanceof Array&&e===Bb.filter?Ub:e},Xb=_g.indexOf,qb=[].indexOf,Jb=!!qb&&1/[1].indexOf(1,-0)<0,$b=db("indexOf");cg({target:"Array",proto:!0,forced:Jb||$b},{indexOf:function(t){return Jb?qb.apply(this,arguments)||0:Xb(this,t,arguments.length>1?arguments[1]:void 0)}});var Qb=h_("Array").indexOf,Kb=Array.prototype,tS=function(t){var e=t.indexOf;return t===Kb||t instanceof Array&&e===Kb.indexOf?Qb:e},eS=[],nS=eS.sort,rS=km((function(){eS.sort(void 0)})),iS=km((function(){eS.sort(null)})),oS=db("sort");cg({target:"Array",proto:!0,forced:rS||!iS||oS},{sort:function(t){return void 0===t?nS.call(Mg(this)):nS.call(Mg(this),eg(t))}});var aS=h_("Array").sort,sS=Array.prototype,uS=function(t){var e=t.sort;return t===sS||t instanceof Array&&e===sS.sort?aS:e},cS=lS;function lS(t){if(t)return function(t){for(var e in lS.prototype)t[e]=lS.prototype[e];return t}(t)}function hS(t,e,n){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==n?n:0}lS.prototype.on=lS.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks[t]=this._callbacks[t]||[]).push(e),this},lS.prototype.once=function(t,e){var n=this;function r(){n.off(t,r),e.apply(this,arguments)}return this._callbacks=this._callbacks||{},r.fn=e,this.on(t,r),this},lS.prototype.off=lS.prototype.removeListener=lS.prototype.removeAllListeners=lS.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var n,r=this._callbacks[t];if(!r)return this;if(1==arguments.length)return delete this._callbacks[t],this;for(var i=0;i<r.length;i++)if((n=r[i])===e||n.fn===e){r.splice(i,1);break}return this},lS.prototype.emit=function(t){this._callbacks=this._callbacks||{};var e=[].slice.call(arguments,1),n=this._callbacks[t];if(n)for(var r=0,i=(n=n.slice(0)).length;r<i;++r)n[r].apply(this,e);return this},lS.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks[t]||[]},lS.prototype.hasListeners=function(t){return!!this.listeners(t).length},hS.subtract=function(t,e){var n=new hS;return n.x=t.x-e.x,n.y=t.y-e.y,n.z=t.z-e.z,n},hS.add=function(t,e){var n=new hS;return n.x=t.x+e.x,n.y=t.y+e.y,n.z=t.z+e.z,n},hS.avg=function(t,e){return new hS((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},hS.crossProduct=function(t,e){var n=new hS;return n.x=t.y*e.z-t.z*e.y,n.y=t.z*e.x-t.x*e.z,n.z=t.x*e.y-t.y*e.x,n},hS.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)};var fS=hS;var dS=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0},pS=Uo(zo);function yS(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var n=this;this.frame.slide.onmousedown=function(t){n._onMouseDown(t)},this.frame.prev.onclick=function(t){n.prev(t)},this.frame.play.onclick=function(t){n.togglePlay(t)},this.frame.next.onclick=function(t){n.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}yS.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},yS.prototype.next=function(){var t=this.getIndex();t<Yb(this).length-1&&(t++,this.setIndex(t))},yS.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Yb(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var n=new Date-t,r=Math.max(this.playInterval-n,0),i=this;this.playTimeout=Fg((function(){i.playNext()}),r)},yS.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},yS.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},yS.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},yS.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},yS.prototype.setPlayInterval=function(t){this.playInterval=t},yS.prototype.getPlayInterval=function(){return this.playInterval},yS.prototype.setPlayLoop=function(t){this.playLoop=t},yS.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},yS.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},yS.prototype.setValues=function(t){this.values=t,Yb(this).length>0?this.setIndex(0):this.index=void 0},yS.prototype.setIndex=function(t){if(!(t<Yb(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},yS.prototype.getIndex=function(){return this.index},yS.prototype.get=function(){return Yb(this)[this.index]},yS.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=zb(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},pS.addEventListener(document,"mousemove",this.onmousemove),pS.addEventListener(document,"mouseup",this.onmouseup),pS.preventDefault(t)}},yS.prototype.leftToIndex=function(t){var e=zb(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,n=t-3,r=Math.round(n/e*(Yb(this).length-1));return r<0&&(r=0),r>Yb(this).length-1&&(r=Yb(this).length-1),r},yS.prototype.indexToLeft=function(t){var e=zb(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Yb(this).length-1)*e+3},yS.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,n=this.startSlideX+e,r=this.leftToIndex(n);this.setIndex(r),pS.preventDefault()},yS.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",pS.removeEventListener(document,"mousemove",this.onmousemove),pS.removeEventListener(document,"mouseup",this.onmouseup),pS.preventDefault()};var vS=yS;function mS(t,e,n,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,n,r)}mS.prototype.isNumeric=function(t){return!isNaN(zb(t))&&isFinite(t)},mS.prototype.setRange=function(t,e,n,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(n))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(n,r)},mS.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=mS.calculatePrettyStep(t):this._step=t)},mS.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},n=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=n;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},mS.prototype.getCurrent=function(){return zb(this._current.toPrecision(this.precision))},mS.prototype.getStep=function(){return this._step},mS.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},mS.prototype.next=function(){this._current+=this._step},mS.prototype.end=function(){return this._current>this._end};var gS=mS,_S=[].reverse,wS=[1,2];cg({target:"Array",proto:!0,forced:String(wS)===String(wS.reverse())},{reverse:function(){return Wg(this)&&(this.length=this.length),_S.call(this)}});var bS=h_("Array").reverse,SS=Array.prototype,xS=function(t){var e=t.reverse;return t===SS||t instanceof Array&&e===SS.reverse?bS:e},OS=Cw.map,kS=a_("map"),MS=kS&&!km((function(){[].map.call({length:-1,0:1},(function(t){throw t}))}));cg({target:"Array",proto:!0,forced:!kS||!MS},{map:function(t){return OS(this,t,arguments.length>1?arguments[1]:void 0)}});var DS=h_("Array").map,TS=Array.prototype,PS=function(t){var e=t.map;return t===TS||t instanceof Array&&e===TS.map?DS:e};cg({target:"Array",stat:!0},{isArray:Wg});var AS=tg.Array.isArray,ES=Qg("species"),LS=[].slice,CS=Math.max;cg({target:"Array",proto:!0,forced:!a_("slice")},{slice:function(t,e){var n,r,i,o=Rm(this),a=pg(o.length),s=mg(t,a),u=mg(void 0===e?a:e,a);if(Wg(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!Wg(n.prototype)?Im(n)&&null===(n=n[ES])&&(n=void 0):n=void 0,n===Array||void 0===n))return LS.call(o,s,u);for(r=new(void 0===n?Array:n)(CS(u-s,0)),i=0;s<u;s++,i++)s in o&&zg(r,i,o[s]);return r.length=i,r}});var YS=h_("Array").slice,jS=Array.prototype,RS=function(t){var e=t.slice;return t===jS||t instanceof Array&&e===jS.slice?YS:e},IS=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};cg({target:"Math",stat:!0},{sign:IS});var NS=tg.Math.sign;function FS(){this.armLocation=new fS,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new fS,this.offsetMultiplier=.6,this.cameraLocation=new fS,this.cameraRotation=new fS(.5*Math.PI,0,0),this.calculateCameraOrientation()}FS.prototype.setOffset=function(t,e){var n=Math.abs,r=NS,i=this.offsetMultiplier,o=this.armLength*i;n(t)>o&&(t=r(t)*o),n(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},FS.prototype.getOffset=function(){return this.cameraOffset},FS.prototype.setArmLocation=function(t,e,n){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=n,this.calculateCameraOrientation()},FS.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},FS.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},FS.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},FS.prototype.getArmLength=function(){return this.armLength},FS.prototype.getCameraLocation=function(){return this.cameraLocation},FS.prototype.getCameraRotation=function(){return this.cameraRotation},FS.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,n=this.cameraOffset.x,r=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+n*o(e)+r*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+n*i(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*i(t)};var WS=FS,zS={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},GS={dot:zS.DOT,"dot-line":zS.DOTLINE,"dot-color":zS.DOTCOLOR,"dot-size":zS.DOTSIZE,line:zS.LINE,grid:zS.GRID,surface:zS.SURFACE,bar:zS.BAR,"bar-color":zS.BARCOLOR,"bar-size":zS.BARSIZE},VS=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrid","showPerspective","showShadow","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","surfaceColors","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],HS=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],US=void 0;function BS(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function ZS(t,e){return void 0===t||""===t?e:t+(void 0===(n=e)||""===n||"string"!=typeof n?n:n.charAt(0).toUpperCase()+RS(n).call(n,1));var n}function XS(t,e,n,r){for(var i,o=0;o<n.length;++o)e[ZS(r,i=n[o])]=t[i]}function qS(t,e,n,r){for(var i,o=0;o<n.length;++o)void 0!==t[i=n[o]]&&(e[ZS(r,i)]=t[i])}function JS(t,e){void 0!==t.backgroundColor&&function(t,e){var n="white",r="gray",i=1;if("string"==typeof t)n=t,r="none",i=0;else{if("object"!==fb(t))throw new Error("Unsupported type of backgroundColor");void 0!==Ib(t)&&(n=Ib(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=n,e.frame.style.borderColor=r,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(Ib(t)&&(e.dataColor.fill=Ib(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;void 0===e.surfaceColors&&(e.surfaceColors={});var n=[];if(AS(t)){if(t.length<2)throw new Error("Surface colors array length must be 2 or above.");n=PS(t).call(t,(function(t){if(!pS.isValidHex(t))throw new Error("Invalid hex color code supplied to surfaceColors.");return pS.hexToRGB(t)}))}else{if("object"!==fb(t))throw new Error("Unsupported type of surfaceColors");if(void 0===t.hue)throw new Error("Unsupported type of surfaceColors");if(t.hue.saturation<0||t.hue.saturation>100)throw new Error("Surface colors saturation is out of bounds. Expected range is 0-100.");if(t.hue.brightness<0||t.hue.brightness>100)throw new Error("Surface colors brightness is out of bounds. Expected range is 0-100.");if(t.hue.colorStops<2)throw new Error("Surface colors colorStops is out of bounds. Expected 2 or above.");for(var r=Math.min(t.hue.start,t.hue.end),i=Math.max(t.hue.start,t.hue.end),o=t.hue.saturation,a=t.hue.brightness,s=t.hue.colorStops,u=(i-r)/s,c=r;c<i;){var l=c%360;l<0&&(l=360+l),n.push(pS.HSVToRGB(l/360,o/100,a/100)),c+=u}t.hue.start>t.hue.end&&xS(n).call(n)}e.surfaceColors=n}(t.surfaceColors,e),function(t,e){if(void 0===t)return;var n;if("string"==typeof t){if(-1===(n=function(t){var e=GS[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var n in zS)if(zS[n]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");n=t}e.style=n}(t.style,e),function(t,e){if(void 0===t){if(void 0===US.showLegend){var n=e.style===zS.DOTCOLOR||e.style===zS.DOTSIZE;e.showLegend=n}}else e.showLegend=t}(t.showLegend,e),$S(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick),void 0!==t.tooltipStyle&&pS.selectiveDeepExtend(["tooltipStyle"],e,t)}function $S(t,e){var n=t;void 0!==n&&(void 0===e.camera&&(e.camera=new WS),e.camera.setArmRotation(n.horizontal,n.vertical),e.camera.setArmLength(n.distance))}var QS={STYLE:zS,setDefaults:function(t,e){if(void 0===t||BS(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");US=t,XS(t,e,VS),XS(t,e,HS,"default"),JS(t,e),e.margin=10,e.showGrayBottom=!1,e.showTooltip=!1,e.onclick_callback=null,e.eye=new fS(0,0,-1)},setOptions:function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===US||BS(US))throw new Error("DEFAULTS not set for module Settings");qS(t,e,VS),qS(t,e,HS,"default"),JS(t,e)}},setCameraPosition:$S},KS=Lg("JSON","stringify"),tx=/[\uD800-\uDFFF]/g,ex=/^[\uD800-\uDBFF]$/,nx=/^[\uDC00-\uDFFF]$/,rx=function(t,e,n){var r=n.charAt(e-1),i=n.charAt(e+1);return ex.test(t)&&!nx.test(i)||nx.test(t)&&!ex.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},ix=km((function(){return'"\\udf06\\ud834"'!==KS("\udf06\ud834")||'"\\udead"'!==KS("\udead")}));KS&&cg({target:"JSON",stat:!0,forced:ix},{stringify:function(t,e,n){var r=KS.apply(null,arguments);return"string"==typeof r?r.replace(tx,rx):r}}),tg.JSON||(tg.JSON={stringify:JSON.stringify});var ox=function(t,e,n){return tg.JSON.stringify.apply(null,arguments)},ax=km((function(){Og(1)}));cg({target:"Object",stat:!0,forced:ax},{keys:function(t){return Og(Mg(t))}});var sx=tg.Object.keys;var ux=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};cg({target:"Object",stat:!0,forced:!Mm,sham:!Mm},{defineProperty:og.f});var cx=Ho((function(t){var e=tg.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)}));function lx(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),cx(t,r.key,r)}}var hx,fx=function(t,e,n){return e&&lx(t.prototype,e),n&&lx(t,n),t},dx=!1,px="background: #FFeeee; color: #dd0000",yx=function(){function t(){ux(this,t)}return fx(t,null,[{key:"validate",value:function(e,n,r){dx=!1,hx=n;var i=n;return void 0!==r&&(i=n[r]),t.parse(e,i,[]),dx}},{key:"parse",value:function(e,n,r){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,n,r)}},{key:"check",value:function(e,n,r,i){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(n[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,n,r,o,s,i)}else t.getSuggestion(e,r,i)}},{key:"checkFields",value:function(e,n,r,i,o,a){var s=function(n){console.log("%c"+n+t.printLocation(a,e),px)},u=t.getType(n[e]),c=o[u];void 0!==c?"array"===t.getType(c)&&-1===tS(c).call(c,n[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(c)+' not "'+n[e]+'". '),dx=!0):"object"===u&&"__any__"!==i&&(a=Wo.copyAndExtendArray(a,e),t.parse(n[e],r[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(sx(o))+". Received ["+u+'] "'+n[e]+'"'),dx=!0)}},{key:"getType",value:function(t){var e=fb(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":AS(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,n,r){var i,o=t.findInOptions(e,n,r,!1),a=t.findInOptions(e,hx,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(sx(n))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+i,px),dx=!0}},{key:"findInOptions",value:function(e,n,r){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],u=e.toLowerCase(),c=void 0;for(var l in n){var h=void 0;if(void 0!==n[l].__type__&&!0===i){var f=t.findInOptions(e,n[l],Wo.copyAndExtendArray(r,l));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,c=f.indexMatch)}else{var d;-1!==tS(d=l.toLowerCase()).call(d,u)&&(c=l),o>(h=t.levenshteinDistance(e,l))&&(a=l,s=Wo.copyArray(r),o=h)}}return{closestMatch:a,path:s,distance:o,indexMatch:c}}},{key:"printLocation",value:function(t,e){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+n+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)r+="  ";r+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var u=0;u<t.length-s;u++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return ox(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var n,r,i=[];for(n=0;n<=e.length;n++)i[n]=[n];for(r=0;r<=t.length;r++)i[0][r]=r;for(n=1;n<=e.length;n++)for(r=1;r<=t.length;r++)e.charAt(n-1)==t.charAt(r-1)?i[n][r]=i[n-1][r-1]:i[n][r]=Math.min(i[n-1][r-1]+1,Math.min(i[n][r-1]+1,i[n-1][r]+1));return i[e.length][t.length]}}]),t}(),vx=Object.freeze({Validator:yx,printStyle:px}),mx="string",gx="boolean",_x="number",wx="object",bx={fill:{string:mx},stroke:{string:mx},strokeWidth:{number:_x},__type__:{string:mx,object:wx,undefined:"undefined"}},Sx={animationAutoStart:{boolean:gx,undefined:"undefined"},animationInterval:{number:_x},animationPreload:{boolean:gx},axisColor:{string:mx},axisFontSize:{number:_x},axisFontType:{string:mx},backgroundColor:bx,xBarWidth:{number:_x,undefined:"undefined"},yBarWidth:{number:_x,undefined:"undefined"},cameraPosition:{distance:{number:_x},horizontal:{number:_x},vertical:{number:_x},__type__:{object:wx}},zoomable:{boolean:gx},ctrlToZoom:{boolean:gx},xCenter:{string:mx},yCenter:{string:mx},dataColor:bx,dotSizeMinFraction:{number:_x},dotSizeMaxFraction:{number:_x},dotSizeRatio:{number:_x},filterLabel:{string:mx},gridColor:{string:mx},onclick:{function:"function"},keepAspectRatio:{boolean:gx},xLabel:{string:mx},yLabel:{string:mx},zLabel:{string:mx},legendLabel:{string:mx},xMin:{number:_x,undefined:"undefined"},yMin:{number:_x,undefined:"undefined"},zMin:{number:_x,undefined:"undefined"},xMax:{number:_x,undefined:"undefined"},yMax:{number:_x,undefined:"undefined"},zMax:{number:_x,undefined:"undefined"},showAnimationControls:{boolean:gx,undefined:"undefined"},showGrid:{boolean:gx},showLegend:{boolean:gx,undefined:"undefined"},showPerspective:{boolean:gx},showShadow:{boolean:gx},showXAxis:{boolean:gx},showYAxis:{boolean:gx},showZAxis:{boolean:gx},rotateAxisLabels:{boolean:gx},surfaceColors:{hue:{start:{number:_x},end:{number:_x},saturation:{number:_x},brightness:{number:_x},colorStops:{number:_x},__type__:{object:wx}},__type__:{array:"array",object:wx}},xStep:{number:_x,undefined:"undefined"},yStep:{number:_x,undefined:"undefined"},zStep:{number:_x,undefined:"undefined"},style:{number:_x,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:gx,function:"function"},tooltipDelay:{number:_x},tooltipStyle:{content:{color:{string:mx},background:{string:mx},border:{string:mx},borderRadius:{string:mx},boxShadow:{string:mx},padding:{string:mx},__type__:{object:wx}},line:{borderLeft:{string:mx},height:{string:mx},width:{string:mx},pointerEvents:{string:mx},__type__:{object:wx}},dot:{border:{string:mx},borderRadius:{string:mx},height:{string:mx},width:{string:mx},pointerEvents:{string:mx},__type__:{object:wx}},__type__:{object:wx}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:_x,undefined:"undefined"},valueMin:{number:_x,undefined:"undefined"},verticalRatio:{number:_x},height:{string:mx},width:{string:mx},__type__:{object:wx}},xx=Object.freeze({allOptions:Sx});function Ox(){this.min=void 0,this.max=void 0}Ox.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},Ox.prototype.combine=function(t){this.add(t.min),this.add(t.max)},Ox.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,n=this.max+t;if(e>n)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=n}},Ox.prototype.range=function(){return this.max-this.min},Ox.prototype.center=function(){return(this.min+this.max)/2};var kx=Ox,Mx=Uo(Sm),Dx=Mx.DataView;function Tx(t,e,n){this.dataGroup=t,this.column=e,this.graph=n,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Yb(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,n.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}Tx.prototype.isLoaded=function(){return this.loaded},Tx.prototype.getLoadedProgress=function(){for(var t=Yb(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},Tx.prototype.getLabel=function(){return this.graph.filterLabel},Tx.prototype.getColumn=function(){return this.column},Tx.prototype.getSelectedValue=function(){if(void 0!==this.index)return Yb(this)[this.index]},Tx.prototype.getValues=function(){return Yb(this)},Tx.prototype.getValue=function(t){if(t>=Yb(this).length)throw new Error("Index out of range");return Yb(this)[t]},Tx.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var n={};n.column=this.column,n.value=Yb(this)[t];var r=new Dx(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();e=this.dataGroup._getDataPoints(r),this.dataPoints[t]=e}return e},Tx.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},Tx.prototype.selectValue=function(t){if(t>=Yb(this).length)throw new Error("Index out of range");this.index=t,this.value=Yb(this)[t]},Tx.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Yb(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var n=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+n+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;Fg((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()};var Px=Tx,Ax=Mx.DataSet,Ex=Mx.DataView;function Lx(){this.dataTable=null}Lx.prototype.initializeData=function(t,e,n){if(void 0!==e){var r;if(AS(e)&&(e=new Ax(e)),!(e instanceof Ax||e instanceof Ex))throw new Error("Array, DataSet, or DataView expected");if(0!=(r=e.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=r;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(n);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(r,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(r,this.colY)||1),this._initializeRange(r,this.colX,t,o),this._initializeRange(r,this.colY,t,o),this._initializeRange(r,this.colZ,t,!1),r[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(r,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new Px(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},Lx.prototype._collectRangeSettings=function(t,e){var n;if(-1==tS(n=["x","y","z"]).call(n,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},Lx.prototype._initializeRange=function(t,e,n,r){var i=this._collectRangeSettings(e,n),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},Lx.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var n=[],r=0;r<e.length;r++){var i=e[r][t]||0;-1===tS(n).call(n,i)&&n.push(i)}return uS(n).call(n,(function(t,e){return t-e}))},Lx.prototype.getSmallestDifference=function(t,e){for(var n=this.getDistinctValues(t,e),r=null,i=1;i<n.length;i++){var o=n[i]-n[i-1];(null==r||r>o)&&(r=o)}return r},Lx.prototype.getColumnRange=function(t,e){for(var n=new kx,r=0;r<t.length;r++){var i=t[r][e];n.adjust(i)}return n},Lx.prototype.getNumberOfRows=function(){return this.dataTable.length},Lx.prototype._setRangeDefaults=function(t,e,n){void 0!==e&&(t.min=e),void 0!==n&&(t.max=n),t.max<=t.min&&(t.max=t.min+1)},Lx.prototype.getDataTable=function(){return this.dataTable},Lx.prototype.getDataSet=function(){return this.dataSet},Lx.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new fS;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],void 0!==this.colValue&&(r.value=t[n][this.colValue]||0);var i={};i.point=r,i.bottom=new fS(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Lx.prototype.initDataAsMatrix=function(t){var e,n,r,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(r=0;r<s.length;r++){i=s[r];var c=tS(o).call(o,i.point.x),l=tS(a).call(a,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0);return s},Lx.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},Lx.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},Lx.prototype._getDataPoints=function(t){var e=[];if(this.style===QS.STYLE.GRID||this.style===QS.STYLE.SURFACE)e=this.initDataAsMatrix(t);else if(this._checkValueField(t),e=this.getDataPoints(t),this.style===QS.STYLE.LINE)for(var n=0;n<e.length;n++)n>0&&(e[n-1].pointNext=e[n]);return e},Lx.prototype._checkValueField=function(t){if(this.style===QS.STYLE.BARCOLOR||this.style===QS.STYLE.BARSIZE||this.style===QS.STYLE.DOTCOLOR||this.style===QS.STYLE.DOTSIZE){if(void 0===this.colValue)throw new Error("Expected data to have  field 'style'  for graph style '"+this.style+"'");if(void 0===t[0][this.colValue])throw new Error("Expected data to have  field '"+this.colValue+"'  for graph style '"+this.style+"'")}};var Cx=Lx,Yx=Uo(vx),jx=Uo(xx),Rx=Yx.Validator,Ix=Yx.printStyle,Nx=jx.allOptions;Fx.STYLE=QS.STYLE;function Fx(t,e,n){if(!(this instanceof Fx))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new Cx,this.dataPoints=null,this.create(),QS.setDefaults(Fx.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(n),this.setData(e)}function Wx(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function zx(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}Fx.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrid:!0,showPerspective:!0,showShadow:!1,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:void 0,animationInterval:1e3,animationPreload:!1,animationAutoStart:void 0,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:Fx.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:["#FF0000","#FFF000","#00FF00","#68E8FB","#000FFF"],cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:void 0,backgroundColor:void 0,xBarWidth:void 0,yBarWidth:void 0,valueMin:void 0,valueMax:void 0,xMin:void 0,xMax:void 0,xStep:void 0,yMin:void 0,yMax:void 0,yStep:void 0,zMin:void 0,zMax:void 0,zStep:void 0},cS(Fx.prototype),Fx.prototype._setScale=function(){this.scale=new fS(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,n=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,n)},Fx.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},Fx.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),n=this.camera.getCameraRotation(),r=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,c=Math.sin(n.x),l=Math.cos(n.x),h=Math.sin(n.y),f=Math.cos(n.y),d=Math.sin(n.z),p=Math.cos(n.z);return new fS(f*(d*(i-s)+p*(r-a))-h*(o-u),c*(f*(o-u)+h*(d*(i-s)+p*(r-a)))+l*(p*(i-s)-d*(r-a)),l*(f*(o-u)+h*(d*(i-s)+p*(r-a)))-c*(p*(i-s)-d*(r-a)))},Fx.prototype._convertTranslationToScreen=function(t){var e,n,r=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-r),n=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),n=s*(-o/this.camera.getArmLength())),new dS(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-n*this.frame.canvas.clientWidth)},Fx.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var n=t[e];n.trans=this._convertPointToTranslation(n.point),n.screen=this._convertTranslationToScreen(n.trans);var r=this._convertPointToTranslation(n.bottom);n.dist=this.showPerspective?r.length():-r.z}uS(t).call(t,(function(t,e){return e.dist-t.dist}))},Fx.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},Fx.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new fS;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],void 0!==this.colValue&&(r.value=t[n][this.colValue]||0);var i={};i.point=r,i.bottom=new fS(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Fx.prototype._getDataPoints=function(t){var e,n,r,i,o=[];if(this.style===Fx.STYLE.GRID||this.style===Fx.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(r=0;r<o.length;r++){i=o[r];var c=tS(a).call(a,i.point.x),l=tS(s).call(s,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(n=0;n<u[e].length;n++)u[e][n]&&(u[e][n].pointRight=e<u.length-1?u[e+1][n]:void 0,u[e][n].pointTop=n<u[e].length-1?u[e][n+1]:void 0,u[e][n].pointCross=e<u.length-1&&n<u[e].length-1?u[e+1][n+1]:void 0)}else if(this._checkValueField(t),o=this.getDataPoints(t),this.style===Fx.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},Fx.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Zb(this.frame).style.position="absolute",Zb(this.frame).style.bottom="0px",Zb(this.frame).style.left="0px",Zb(this.frame).style.width="100%",this.frame.appendChild(Zb(this.frame));var e=this;pS.addEventListener(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),pS.addEventListener(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),pS.addEventListener(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),pS.addEventListener(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),pS.addEventListener(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},Fx.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},Fx.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Zb(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},Fx.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Zb(this.frame)||!Zb(this.frame).slider)throw new Error("No animation available");Zb(this.frame).slider.play()}},Fx.prototype.animationStop=function(){Zb(this.frame)&&Zb(this.frame).slider&&Zb(this.frame).slider.stop()},Fx.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=zb(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=zb(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=zb(this.yCenter)/100*(this.frame.canvas.clientHeight-Zb(this.frame).clientHeight):this.currentYCenter=zb(this.yCenter)},Fx.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},Fx.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},Fx.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},Fx.prototype.setOptions=function(t){void 0!==t&&(!0===Rx.validate(t,Nx)&&console.log("%cErrors have been found in the supplied options object.",Ix),this.animationStop(),QS.setOptions(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},Fx.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case Fx.STYLE.BAR:t=Fx.prototype._redrawBarGraphPoint;break;case Fx.STYLE.BARCOLOR:t=Fx.prototype._redrawBarColorGraphPoint;break;case Fx.STYLE.BARSIZE:t=Fx.prototype._redrawBarSizeGraphPoint;break;case Fx.STYLE.DOT:t=Fx.prototype._redrawDotGraphPoint;break;case Fx.STYLE.DOTLINE:t=Fx.prototype._redrawDotLineGraphPoint;break;case Fx.STYLE.DOTCOLOR:t=Fx.prototype._redrawDotColorGraphPoint;break;case Fx.STYLE.DOTSIZE:t=Fx.prototype._redrawDotSizeGraphPoint;break;case Fx.STYLE.SURFACE:t=Fx.prototype._redrawSurfaceGraphPoint;break;case Fx.STYLE.GRID:t=Fx.prototype._redrawGridGraphPoint;break;case Fx.STYLE.LINE:t=Fx.prototype._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},Fx.prototype.setAxisLabelMethod=function(){var t,e,n;t=e=n=void 0,1==this.rotateAxisLabels?(t=Fx.prototype.drawAxisLabelXRotate,e=Fx.prototype.drawAxisLabelYRotate,n=Fx.prototype.drawAxisLabelZRotate):(t=Fx.prototype.drawAxisLabelX,e=Fx.prototype.drawAxisLabelY,n=Fx.prototype.drawAxisLabelZ),this._drawAxisLabelX=t,this._drawAxisLabelY=e,this._drawAxisLabelZ=n},Fx.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},Fx.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},Fx.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},Fx.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},Fx.prototype._getLegendWidth=function(){var t;this.style===Fx.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===Fx.STYLE.BARSIZE?this.xBarWidth:20;return t},Fx.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==Fx.STYLE.LINE&&this.style!==Fx.STYLE.BARSIZE){var t=this.style===Fx.STYLE.BARSIZE||this.style===Fx.STYLE.DOTSIZE,e=this.style===Fx.STYLE.DOTSIZE||this.style===Fx.STYLE.DOTCOLOR||this.style===Fx.STYLE.BARCOLOR,n=Math.max(.25*this.frame.clientHeight,100),r=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=r+n,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var c,l=n;for(c=0;c<l;c++){var h=240*((c-0)/(l-0)),f=this._hsv2rgb(h,1,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,r+c),u.lineTo(o,r+c),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,r,i,n)}else{var d;this.style===Fx.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,Fx.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=Ib(this.dataColor),u.beginPath(),u.moveTo(a,r),u.lineTo(o,r),u.lineTo(a+d,s),u.lineTo(a,s),u.closePath(),Ib(u).call(u),u.stroke()}var p,y,v=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new gS(v,m,(m-v)/5,!0);for(g.start(!0);!g.end();)c=s-(g.getCurrent()-v)/(m-v)*n,p=new dS(a-5,c),y=new dS(a,c),this._line(u,p,y),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(g.getCurrent(),a-10,c),g.next();u.textAlign="right",u.textBaseline="top";var _=this.legendLabel;u.fillText(_,o,s+this.margin)}},Fx.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Zb(this.frame);if(e.innerHTML="",t){var n={visible:this.showAnimationControls},r=new vS(e,n);e.slider=r,e.style.padding="10px",r.setValues(Yb(t)),r.setPlayInterval(this.animationInterval);var i=this;r.setOnChangeCallback((function(){var t=i.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),i.dataPoints=t._getDataPoints(),i.redraw()}))}else e.slider=void 0},Fx.prototype._redrawSlider=function(){void 0!==Zb(this.frame).slider&&Zb(this.frame).slider.redraw()},Fx.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var n=this.margin,r=this.margin;e.fillText(t,n,r)}},Fx.prototype._line=function(t,e,n,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(n.x,n.y),t.stroke()},Fx.prototype.drawAxisLabelX=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Fx.prototype.drawAxisLabelY=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Fx.prototype.drawAxisLabelZ=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Fx.prototype.drawAxisLabelXRotate=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.get,t.translate(o.x,o.y),t.rotate(Math.PI/2),t.fillText(n,o.x/100,o.y/100),t.textAlign="center",t.textBaseline="top",o.y+=i,t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Fx.prototype.drawAxisLabelYRotate=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0&&Math.sin(2*r)<0?(t.save(),t.get,t.translate(o.x,o.y),t.rotate(Math.PI/2*-1),t.fillText(n,o.x/100,o.y/100),t.textAlign="center",t.textBaseline="top",o.y+=i,t.restore()):Math.cos(2*r)<0?(t.save(),t.get,t.translate(o.x,o.y),t.rotate(Math.PI/2),t.fillText(n,o.x/100,o.y/100),t.textAlign="center",t.textBaseline="top",o.y+=i,t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Fx.prototype.drawAxisLabelZRotate=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Fx.prototype._line3d=function(t,e,n,r){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(n);this._line(t,i,o,r)},Fx.prototype._redrawAxis=function(){var t,e,n,r,i,o,a,s,u,c,l=this._getContext();l.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,d,p=.025/this.scale.x,y=.025/this.scale.y,v=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new dS(Math.cos(m),Math.sin(m)),_=this.xRange,w=this.yRange,b=this.zRange;for(l.lineWidth=1,r=void 0===this.defaultXStep,(n=new gS(_.min,_.max,this.xStep,r)).start(!0);!n.end();){var S=n.getCurrent();if(this.showGrid?(t=new fS(S,w.min,b.min),e=new fS(S,w.max,b.min),this._line3d(l,t,e,this.gridColor)):this.showXAxis&&(t=new fS(S,w.min,b.min),e=new fS(S,w.min+p,b.min),this._line3d(l,t,e,this.axisColor),t=new fS(S,w.max,b.min),e=new fS(S,w.max-p,b.min),this._line3d(l,t,e,this.axisColor)),this.showXAxis){a=g.x>0?w.min:w.max,h=new fS(S,a,b.min);var x="  "+this.xValueLabel(S)+"  ";this._drawAxisLabelX.call(this,l,h,x,m,v)}n.next()}for(l.lineWidth=1,r=void 0===this.defaultYStep,(n=new gS(w.min,w.max,this.yStep,r)).start(!0);!n.end();){var O=n.getCurrent();if(this.showGrid?(t=new fS(_.min,O,b.min),e=new fS(_.max,O,b.min),this._line3d(l,t,e,this.gridColor)):this.showYAxis&&(t=new fS(_.min,O,b.min),e=new fS(_.min+y,O,b.min),this._line3d(l,t,e,this.axisColor),t=new fS(_.max,O,b.min),e=new fS(_.max-y,O,b.min),this._line3d(l,t,e,this.axisColor)),this.showYAxis){o=g.y>0?_.min:_.max,h=new fS(o,O,b.min);var k="  "+this.yValueLabel(O)+"  ";this._drawAxisLabelY.call(this,l,h,k,m,v)}n.next()}if(this.showZAxis){for(l.lineWidth=1,r=void 0===this.defaultZStep,(n=new gS(b.min,b.max,this.zStep,r)).start(!0),o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max;!n.end();){var M=n.getCurrent(),D=new fS(o,a,M),T=this._convert3Dto2D(D);e=new dS(T.x-v,T.y),this._line(l,T,e,this.axisColor);var P=this.zValueLabel(M)+" ";this._drawAxisLabelZ.call(this,l,D,P,5),n.next()}l.lineWidth=1,t=new fS(o,a,b.min),e=new fS(o,a,b.max),this._line3d(l,t,e,this.axisColor)}this.showXAxis&&(l.lineWidth=1,f=new fS(_.min,w.min,b.min),d=new fS(_.max,w.min,b.min),this._line3d(l,f,d,this.axisColor),f=new fS(_.min,w.max,b.min),d=new fS(_.max,w.max,b.min),this._line3d(l,f,d,this.axisColor));this.showYAxis&&(l.lineWidth=1,t=new fS(_.min,w.min,b.min),e=new fS(_.min,w.max,b.min),this._line3d(l,t,e,this.axisColor),t=new fS(_.max,w.min,b.min),e=new fS(_.max,w.max,b.min),this._line3d(l,t,e,this.axisColor));var A=this.xLabel;A.length>0&&this.showXAxis&&(c=.1/this.scale.y,o=(_.max+3*_.min)/4,a=g.x>0?w.min-c:w.max+c,i=new fS(o,a,b.min),this.drawAxisLabelX(l,i,A,m));var E=this.yLabel;E.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=g.y>0?_.min-u:_.max+u,a=(w.max+3*w.min)/4,i=new fS(o,a,b.min),this.drawAxisLabelY(l,i,E,m));var L=this.zLabel;L.length>0&&this.showZAxis&&(30,o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max,s=(b.max+3*b.min)/4,i=new fS(o,a,s),this.drawAxisLabelZ(l,i,L,30))},Fx.prototype._hsv2rgb=function(t,e,n){var r,i,o,a,s,u;switch(a=n*e,s=Math.floor(t/60),u=a*(1-Math.abs(t/60%2-1)),s){case 0:r=a,i=u,o=0;break;case 1:r=u,i=a,o=0;break;case 2:r=0,i=a,o=u;break;case 3:r=0,i=u,o=a;break;case 4:r=u,i=0,o=a;break;case 5:r=a,i=0,o=u;break;default:r=0,i=0,o=0}return"RGB("+Ab(255*r)+","+Ab(255*i)+","+Ab(255*o)+")"},Fx.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},Fx.prototype._redrawBar=function(t,e,n,r,i,o){var a,s=this,u=e.point,c=this.zRange.min,l=[{point:new fS(u.x-n,u.y-r,u.z)},{point:new fS(u.x+n,u.y-r,u.z)},{point:new fS(u.x+n,u.y+r,u.z)},{point:new fS(u.x-n,u.y+r,u.z)}],h=[{point:new fS(u.x-n,u.y-r,c)},{point:new fS(u.x+n,u.y-r,c)},{point:new fS(u.x+n,u.y+r,c)},{point:new fS(u.x-n,u.y+r,c)}];_b(l).call(l,(function(t){t.screen=s._convert3Dto2D(t.point)})),_b(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:l,center:fS.avg(h[0].point,h[2].point)},{corners:[l[0],l[1],h[1],h[0]],center:fS.avg(h[1].point,h[0].point)},{corners:[l[1],l[2],h[2],h[1]],center:fS.avg(h[2].point,h[1].point)},{corners:[l[2],l[3],h[3],h[2]],center:fS.avg(h[3].point,h[2].point)},{corners:[l[3],l[0],h[0],h[3]],center:fS.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}uS(f).call(f,(function(t,e){var n=e.dist-t.dist;return n||(t.corners===l?1:e.corners===l?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var y=2;y<f.length;y++)a=f[y],this._polygon(t,a.corners)},Fx.prototype._polygon=function(t,e,n,r){if(!(e.length<2)){void 0!==n&&(t.fillStyle=n),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),Ib(t).call(t),t.stroke()}},Fx.prototype._drawCircle=function(t,e,n,r,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=n,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),Ib(t).call(t),t.stroke()},Fx.prototype._getColorsRegular=function(t){var e=240*(1-(t.point.z-this.zRange.min)*this.scale.z/this.verticalRatio);return{fill:this._hsv2rgb(e,1,1),border:this._hsv2rgb(e,1,.8)}},Fx.prototype._getColorsColor=function(t){var e,n,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===fb(r)&&Ib(r)&&r.stroke)return{fill:Ib(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,n=t.point.value;else{var i=240*(1-(t.point.value-this.valueRange.min)*this.scale.value);e=this._hsv2rgb(i,1,1),n=this._hsv2rgb(i,1,.8)}return{fill:e,border:n}},Fx.prototype._getColorsSize=function(){return{fill:Ib(this.dataColor),border:this.dataColor.stroke}},Fx.prototype._calcRadius=function(t,e){var n;return void 0===e&&(e=this._dotSize()),(n=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(n=0),n},Fx.prototype._redrawBarGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,n,r,Ib(i),i.border)},Fx.prototype._redrawBarColorGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,n,r,Ib(i),i.border)},Fx.prototype._redrawBarSizeGraphPoint=function(t,e){var n=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*n+.2),i=this.yBarWidth/2*(.8*n+.2),o=this._getColorsSize();this._redrawBar(t,e,r,i,Ib(o),o.border)},Fx.prototype._redrawDotGraphPoint=function(t,e){var n=this._getColorsRegular(e);this._drawCircle(t,e,Ib(n),n.border)},Fx.prototype._redrawDotLineGraphPoint=function(t,e){var n=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,n,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},Fx.prototype._redrawDotColorGraphPoint=function(t,e){var n=this._getColorsColor(e);this._drawCircle(t,e,Ib(n),n.border)},Fx.prototype._redrawDotSizeGraphPoint=function(t,e){var n=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=n*this.dotSizeMinFraction,o=i+(n*this.dotSizeMaxFraction-i)*r,a=this._getColorsSize();this._drawCircle(t,e,Ib(a),a.border,o)},Fx.prototype._redrawSurfaceGraphPoint=function(t,e){var n=e.pointRight,r=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==n&&void 0!==r&&void 0!==i){var o,a,s=!0;if(this.showGrayBottom||this.showShadow){var u=fS.subtract(i.trans,e.trans),c=fS.subtract(r.trans,n.trans),l=fS.crossProduct(u,c),h=l.length();s=l.z>0}if(s){var f=1-((e.point.z+n.point.z+r.point.z+i.point.z)/4-this.zRange.min)*this.scale.z/this.verticalRatio,d=this.surfaceColors;if(d&&0!==d.length){var p,y,v=d.length-1,m=Math.floor(f*v),g=Math.ceil(f*v),_=m/v,w=(f-_)/(g/v-_),b=d[m].r,S=b+w*(d[g].r-b),x=d[m].g,O=x+w*(d[g].g-x),k=d[m].b,M=k+w*(d[g].b-k);o=p_(p=p_(y="RGB(".concat(S,", ")).call(y,O,", ")).call(p,M,")")}else{var D=240*f,T=1;this.showShadow?(T=Math.min(1+l.x/h/2,1),a=o=this._hsv2rgb(D,1,T)):(T=1,o=this._hsv2rgb(D,1,T),a=this.axisColor)}}else o="gray",a=this.axisColor;t.lineWidth=this._getStrokeWidth(e);var P=[e,n,i,r];this._polygon(t,P,o,a)}},Fx.prototype._drawGridLine=function(t,e,n){if(void 0!==e&&void 0!==n){var r=240*(1-((e.point.z+n.point.z)/2-this.zRange.min)*this.scale.z/this.verticalRatio);t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._hsv2rgb(r,1,1),this._line(t,e.screen,n.screen)}},Fx.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},Fx.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},Fx.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var n=this.dataPoints[t];this._pointDrawingMethod.call(this,e,n)}},Fx.prototype._storeMousePosition=function(t){this.startMouseX=Wx(t),this.startMouseY=zx(t),this._startCameraOffset=this.camera.getOffset()},Fx.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},pS.addEventListener(document,"mousemove",e.onmousemove),pS.addEventListener(document,"mouseup",e.onmouseup),pS.preventDefault(t)}},Fx.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=zb(Wx(t))-this.startMouseX,n=zb(zx(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+n/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+n/200,c=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<c&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<c&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<c&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<c&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var l=this.getCameraPosition();this.emit("cameraPositionChange",l),pS.preventDefault(t)},Fx.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,pS.removeEventListener(document,"mousemove",this.onmousemove),pS.removeEventListener(document,"mouseup",this.onmouseup),pS.preventDefault(t)},Fx.prototype._onClick=function(t){if(this.onclick_callback){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),n=Wx(t)-e.left,r=zx(t)-e.top,i=this._dataPointFromXY(n,r);i&&this.onclick_callback(i.point.data)}pS.preventDefault(t)}},Fx.prototype._onTooltip=function(t){var e=this.tooltipDelay,n=this.frame.getBoundingClientRect(),r=Wx(t)-n.left,i=zx(t)-n.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=Fg((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,i);t&&a._showTooltip(t)}),e)}},Fx.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},pS.addEventListener(document,"touchmove",e.ontouchmove),pS.addEventListener(document,"touchend",e.ontouchend),this._onMouseDown(t)},Fx.prototype._onTouchMove=function(t){this._onMouseMove(t)},Fx.prototype._onTouchEnd=function(t){this.touchDown=!1,pS.removeEventListener(document,"touchmove",this.ontouchmove),pS.removeEventListener(document,"touchend",this.ontouchend),this._onMouseUp(t)},Fx.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var n=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(n),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),pS.preventDefault(t)}},Fx.prototype._insideTriangle=function(t,e){var n=e[0],r=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-n.x)*(t.y-n.y)-(r.y-n.y)*(t.x-n.x)),s=o((i.x-r.x)*(t.y-r.y)-(i.y-r.y)*(t.x-r.x)),u=o((n.x-i.x)*(t.y-i.y)-(n.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},Fx.prototype._dataPointFromXY=function(t,e){var n,r=null,i=null,o=null,a=new dS(t,e);if(this.style===Fx.STYLE.BAR||this.style===Fx.STYLE.BARCOLOR||this.style===Fx.STYLE.BARSIZE)for(n=this.dataPoints.length-1;n>=0;n--){var s=(r=this.dataPoints[n]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var c=s[u].corners,l=[c[0].screen,c[1].screen,c[2].screen],h=[c[2].screen,c[3].screen,c[0].screen];if(this._insideTriangle(a,l)||this._insideTriangle(a,h))return r}}else for(n=0;n<this.dataPoints.length;n++){var f=(r=this.dataPoints[n]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),y=Math.sqrt(d*d+p*p);(null===o||y<o)&&y<100&&(o=y,i=r)}}return i},Fx.prototype.hasBars=function(t){return t==Fx.STYLE.BAR||t==Fx.STYLE.BARCOLOR||t==Fx.STYLE.BARSIZE},Fx.prototype._showTooltip=function(t){var e,n,r;this.tooltip?(e=this.tooltip.dom.content,n=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),Ag(e.style,{},this.tooltipStyle.content),e.style.position="absolute",n=document.createElement("div"),Ag(n.style,{},this.tooltipStyle.line),n.style.position="absolute",r=document.createElement("div"),Ag(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:n,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(n),this.frame.appendChild(r);var i=e.offsetWidth,o=e.offsetHeight,a=n.offsetHeight,s=r.offsetWidth,u=r.offsetHeight,c=t.screen.x-i/2;c=Math.min(Math.max(c,10),this.frame.clientWidth-10-i),n.style.left=t.screen.x+"px",n.style.top=t.screen.y-a+"px",e.style.left=c+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-u/2+"px"},Fx.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},Fx.prototype.setCameraPosition=function(t){QS.setCameraPosition(t,this),this.redraw()},Fx.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};var Gx=Fx,Vx=Ho((function(t,e){t.exports=function(){var e,n;function r(){return e.apply(null,arguments)}function i(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function a(t){return void 0===t}function s(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function u(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function c(t,e){var n,r=[];for(n=0;n<t.length;++n)r.push(e(t[n],n));return r}function l(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t,e){for(var n in e)l(e,n)&&(t[n]=e[n]);return l(e,"toString")&&(t.toString=e.toString),l(e,"valueOf")&&(t.valueOf=e.valueOf),t}function f(t,e,n,r){return Le(t,e,n,r,!0).utc()}function d(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function p(t){if(null==t._isValid){var e=d(t),r=n.call(e.parsedDateParts,(function(t){return null!=t})),i=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&r);if(t._strict&&(i=i&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return i;t._isValid=i}return t._isValid}function y(t){var e=f(NaN);return null!=t?h(d(e),t):d(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),n=e.length>>>0,r=0;r<n;r++)if(r in e&&t.call(this,e[r],r,e))return!0;return!1};var v=r.momentProperties=[];function m(t,e){var n,r,i;if(a(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),a(e._i)||(t._i=e._i),a(e._f)||(t._f=e._f),a(e._l)||(t._l=e._l),a(e._strict)||(t._strict=e._strict),a(e._tzm)||(t._tzm=e._tzm),a(e._isUTC)||(t._isUTC=e._isUTC),a(e._offset)||(t._offset=e._offset),a(e._pf)||(t._pf=d(e)),a(e._locale)||(t._locale=e._locale),v.length>0)for(n=0;n<v.length;n++)a(i=e[r=v[n]])||(t[r]=i);return t}var g=!1;function _(t){m(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===g&&(g=!0,r.updateOffset(this),g=!1)}function w(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function b(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function S(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=b(e)),n}function x(t,e,n){var r,i=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(r=0;r<i;r++)(n&&t[r]!==e[r]||!n&&S(t[r])!==S(e[r]))&&a++;return a+o}function O(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function k(t,e){var n=!0;return h((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),n){for(var i,o=[],a=0;a<arguments.length;a++){if(i="","object"==typeof arguments[a]){for(var s in i+="\n["+a+"] ",arguments[0])i+=s+": "+arguments[0][s]+", ";i=i.slice(0,-2)}else i=arguments[a];o.push(i)}O(t+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),n=!1}return e.apply(this,arguments)}),e)}var M,D={};function T(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),D[t]||(O(e),D[t]=!0)}function P(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function A(t,e){var n,r=h({},t);for(n in e)l(e,n)&&(o(t[n])&&o(e[n])?(r[n]={},h(r[n],t[n]),h(r[n],e[n])):null!=e[n]?r[n]=e[n]:delete r[n]);for(n in t)l(t,n)&&!l(e,n)&&o(t[n])&&(r[n]=h({},r[n]));return r}function E(t){null!=t&&this.set(t)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,M=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)l(t,e)&&n.push(e);return n};var L={};function C(t,e){var n=t.toLowerCase();L[n]=L[n+"s"]=L[e]=t}function Y(t){return"string"==typeof t?L[t]||L[t.toLowerCase()]:void 0}function j(t){var e,n,r={};for(n in t)l(t,n)&&(e=Y(n))&&(r[e]=t[n]);return r}var R={};function I(t,e){R[t]=e}function N(t,e,n){var r=""+Math.abs(t),i=e-r.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+r}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,W=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,z={},G={};function V(t,e,n,r){var i=r;"string"==typeof r&&(i=function(){return this[r]()}),t&&(G[t]=i),e&&(G[e[0]]=function(){return N(i.apply(this,arguments),e[1],e[2])}),n&&(G[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function H(t,e){return t.isValid()?(e=U(e,t.localeData()),z[e]=z[e]||function(t){var e,n,r,i=t.match(F);for(e=0,n=i.length;e<n;e++)G[i[e]]?i[e]=G[i[e]]:i[e]=(r=i[e]).match(/\[[\s\S]/)?r.replace(/^\[|\]$/g,""):r.replace(/\\/g,"");return function(e){var r,o="";for(r=0;r<n;r++)o+=P(i[r])?i[r].call(e,t):i[r];return o}}(e),z[e](t)):t.localeData().invalidDate()}function U(t,e){var n=5;function r(t){return e.longDateFormat(t)||t}for(W.lastIndex=0;n>=0&&W.test(t);)t=t.replace(W,r),W.lastIndex=0,n-=1;return t}var B=/\d/,Z=/\d\d/,X=/\d{3}/,q=/\d{4}/,J=/[+-]?\d{6}/,$=/\d\d?/,Q=/\d\d\d\d?/,K=/\d\d\d\d\d\d?/,tt=/\d{1,3}/,et=/\d{1,4}/,nt=/[+-]?\d{1,6}/,rt=/\d+/,it=/[+-]?\d+/,ot=/Z|[+-]\d\d:?\d\d/gi,at=/Z|[+-]\d\d(?::?\d\d)?/gi,st=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,ut={};function ct(t,e,n){ut[t]=P(e)?e:function(t,r){return t&&n?n:e}}function lt(t,e){return l(ut,t)?ut[t](e._strict,e._locale):new RegExp(ht(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,r,i){return e||n||r||i}))))}function ht(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ft={};function dt(t,e){var n,r=e;for("string"==typeof t&&(t=[t]),s(e)&&(r=function(t,n){n[e]=S(t)}),n=0;n<t.length;n++)ft[t[n]]=r}function pt(t,e){dt(t,(function(t,n,r,i){r._w=r._w||{},e(t,r._w,r,i)}))}function yt(t,e,n){null!=e&&l(ft,t)&&ft[t](e,n._a,n,t)}var vt=0,mt=1,gt=2,_t=3,wt=4,bt=5,St=6,xt=7,Ot=8;function kt(t){return Mt(t)?366:365}function Mt(t){return t%4==0&&t%100!=0||t%400==0}V("Y",0,0,(function(){var t=this.year();return t<=9999?""+t:"+"+t})),V(0,["YY",2],0,(function(){return this.year()%100})),V(0,["YYYY",4],0,"year"),V(0,["YYYYY",5],0,"year"),V(0,["YYYYYY",6,!0],0,"year"),C("year","y"),I("year",1),ct("Y",it),ct("YY",$,Z),ct("YYYY",et,q),ct("YYYYY",nt,J),ct("YYYYYY",nt,J),dt(["YYYYY","YYYYYY"],vt),dt("YYYY",(function(t,e){e[vt]=2===t.length?r.parseTwoDigitYear(t):S(t)})),dt("YY",(function(t,e){e[vt]=r.parseTwoDigitYear(t)})),dt("Y",(function(t,e){e[vt]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return S(t)+(S(t)>68?1900:2e3)};var Dt,Tt=Pt("FullYear",!0);function Pt(t,e){return function(n){return null!=n?(Et(this,t,n),r.updateOffset(this,e),this):At(this,t)}}function At(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Et(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&Mt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),Lt(n,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](n))}function Lt(t,e){if(isNaN(t)||isNaN(e))return NaN;var n,r=(e%(n=12)+n)%n;return t+=(e-r)/12,1===r?Mt(t)?29:28:31-r%7%2}Dt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},V("M",["MM",2],"Mo",(function(){return this.month()+1})),V("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),V("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),C("month","M"),I("month",8),ct("M",$),ct("MM",$,Z),ct("MMM",(function(t,e){return e.monthsShortRegex(t)})),ct("MMMM",(function(t,e){return e.monthsRegex(t)})),dt(["M","MM"],(function(t,e){e[mt]=S(t)-1})),dt(["MMM","MMMM"],(function(t,e,n,r){var i=n._locale.monthsParse(t,r,n._strict);null!=i?e[mt]=i:d(n).invalidMonth=t}));var Ct=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Yt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),jt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Rt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],r=0;r<12;++r)o=f([2e3,r]),this._shortMonthsParse[r]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[r]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(i=Dt.call(this._shortMonthsParse,a))?i:null:-1!==(i=Dt.call(this._longMonthsParse,a))?i:null:"MMM"===e?-1!==(i=Dt.call(this._shortMonthsParse,a))?i:-1!==(i=Dt.call(this._longMonthsParse,a))?i:null:-1!==(i=Dt.call(this._longMonthsParse,a))?i:-1!==(i=Dt.call(this._shortMonthsParse,a))?i:null}function It(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=S(e);else if(!s(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),Lt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function Nt(t){return null!=t?(It(this,t),r.updateOffset(this,!0),this):At(this,"Month")}var Ft=st,Wt=st;function zt(){function t(t,e){return e.length-t.length}var e,n,r=[],i=[],o=[];for(e=0;e<12;e++)n=f([2e3,e]),r.push(this.monthsShort(n,"")),i.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(r.sort(t),i.sort(t),o.sort(t),e=0;e<12;e++)r[e]=ht(r[e]),i[e]=ht(i[e]);for(e=0;e<24;e++)o[e]=ht(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+r.join("|")+")","i")}function Gt(t,e,n,r,i,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,r,i,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,r,i,o,a),s}function Vt(t){var e;if(t<100&&t>=0){var n=Array.prototype.slice.call(arguments);n[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function Ht(t,e,n){var r=7+e-n;return-(7+Vt(t,0,r).getUTCDay()-e)%7+r-1}function Ut(t,e,n,r,i){var o,a,s=1+7*(e-1)+(7+n-r)%7+Ht(t,r,i);return s<=0?a=kt(o=t-1)+s:s>kt(t)?(o=t+1,a=s-kt(t)):(o=t,a=s),{year:o,dayOfYear:a}}function Bt(t,e,n){var r,i,o=Ht(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?r=a+Zt(i=t.year()-1,e,n):a>Zt(t.year(),e,n)?(r=a-Zt(t.year(),e,n),i=t.year()+1):(i=t.year(),r=a),{week:r,year:i}}function Zt(t,e,n){var r=Ht(t,e,n),i=Ht(t+1,e,n);return(kt(t)-r+i)/7}function Xt(t,e){return t.slice(e,7).concat(t.slice(0,e))}V("w",["ww",2],"wo","week"),V("W",["WW",2],"Wo","isoWeek"),C("week","w"),C("isoWeek","W"),I("week",5),I("isoWeek",5),ct("w",$),ct("ww",$,Z),ct("W",$),ct("WW",$,Z),pt(["w","ww","W","WW"],(function(t,e,n,r){e[r.substr(0,1)]=S(t)})),V("d",0,"do","day"),V("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),V("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),V("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),V("e",0,0,"weekday"),V("E",0,0,"isoWeekday"),C("day","d"),C("weekday","e"),C("isoWeekday","E"),I("day",11),I("weekday",11),I("isoWeekday",11),ct("d",$),ct("e",$),ct("E",$),ct("dd",(function(t,e){return e.weekdaysMinRegex(t)})),ct("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),ct("dddd",(function(t,e){return e.weekdaysRegex(t)})),pt(["dd","ddd","dddd"],(function(t,e,n,r){var i=n._locale.weekdaysParse(t,r,n._strict);null!=i?e.d=i:d(n).invalidWeekday=t})),pt(["d","e","E"],(function(t,e,n,r){e[r]=S(t)}));var qt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Jt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),$t="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Qt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],r=0;r<7;++r)o=f([2e3,1]).day(r),this._minWeekdaysParse[r]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[r]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[r]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(i=Dt.call(this._weekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:"dddd"===e?-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:null:-1!==(i=Dt.call(this._minWeekdaysParse,a))?i:-1!==(i=Dt.call(this._weekdaysParse,a))?i:-1!==(i=Dt.call(this._shortWeekdaysParse,a))?i:null}var Kt=st,te=st,ee=st;function ne(){function t(t,e){return e.length-t.length}var e,n,r,i,o,a=[],s=[],u=[],c=[];for(e=0;e<7;e++)n=f([2e3,1]).day(e),r=this.weekdaysMin(n,""),i=this.weekdaysShort(n,""),o=this.weekdays(n,""),a.push(r),s.push(i),u.push(o),c.push(r),c.push(i),c.push(o);for(a.sort(t),s.sort(t),u.sort(t),c.sort(t),e=0;e<7;e++)s[e]=ht(s[e]),u[e]=ht(u[e]),c[e]=ht(c[e]);this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function re(){return this.hours()%12||12}function ie(t,e){V(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function oe(t,e){return e._meridiemParse}V("H",["HH",2],0,"hour"),V("h",["hh",2],0,re),V("k",["kk",2],0,(function(){return this.hours()||24})),V("hmm",0,0,(function(){return""+re.apply(this)+N(this.minutes(),2)})),V("hmmss",0,0,(function(){return""+re.apply(this)+N(this.minutes(),2)+N(this.seconds(),2)})),V("Hmm",0,0,(function(){return""+this.hours()+N(this.minutes(),2)})),V("Hmmss",0,0,(function(){return""+this.hours()+N(this.minutes(),2)+N(this.seconds(),2)})),ie("a",!0),ie("A",!1),C("hour","h"),I("hour",13),ct("a",oe),ct("A",oe),ct("H",$),ct("h",$),ct("k",$),ct("HH",$,Z),ct("hh",$,Z),ct("kk",$,Z),ct("hmm",Q),ct("hmmss",K),ct("Hmm",Q),ct("Hmmss",K),dt(["H","HH"],_t),dt(["k","kk"],(function(t,e,n){var r=S(t);e[_t]=24===r?0:r})),dt(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),dt(["h","hh"],(function(t,e,n){e[_t]=S(t),d(n).bigHour=!0})),dt("hmm",(function(t,e,n){var r=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r)),d(n).bigHour=!0})),dt("hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r,2)),e[bt]=S(t.substr(i)),d(n).bigHour=!0})),dt("Hmm",(function(t,e,n){var r=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r))})),dt("Hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[_t]=S(t.substr(0,r)),e[wt]=S(t.substr(r,2)),e[bt]=S(t.substr(i))}));var ae,se=Pt("Hours",!0),ue={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Yt,monthsShort:jt,week:{dow:0,doy:6},weekdays:qt,weekdaysMin:$t,weekdaysShort:Jt,meridiemParse:/[ap]\.?m?\.?/i},ce={},le={};function he(t){return t?t.toLowerCase().replace("_","-"):t}function fe(e){var n=null;if(!ce[e]&&t&&t.exports)try{n=ae._abbr,Vo(),de(n)}catch(t){}return ce[e]}function de(t,e){var n;return t&&((n=a(e)?ye(t):pe(t,e))?ae=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),ae._abbr}function pe(t,e){if(null!==e){var n,r=ue;if(e.abbr=t,null!=ce[t])T("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),r=ce[t]._config;else if(null!=e.parentLocale)if(null!=ce[e.parentLocale])r=ce[e.parentLocale]._config;else{if(null==(n=fe(e.parentLocale)))return le[e.parentLocale]||(le[e.parentLocale]=[]),le[e.parentLocale].push({name:t,config:e}),null;r=n._config}return ce[t]=new E(A(r,e)),le[t]&&le[t].forEach((function(t){pe(t.name,t.config)})),de(t),ce[t]}return delete ce[t],null}function ye(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return ae;if(!i(t)){if(e=fe(t))return e;t=[t]}return function(t){for(var e,n,r,i,o=0;o<t.length;){for(e=(i=he(t[o]).split("-")).length,n=(n=he(t[o+1]))?n.split("-"):null;e>0;){if(r=fe(i.slice(0,e).join("-")))return r;if(n&&n.length>=e&&x(i,n,!0)>=e-1)break;e--}o++}return ae}(t)}function ve(t){var e,n=t._a;return n&&-2===d(t).overflow&&(e=n[mt]<0||n[mt]>11?mt:n[gt]<1||n[gt]>Lt(n[vt],n[mt])?gt:n[_t]<0||n[_t]>24||24===n[_t]&&(0!==n[wt]||0!==n[bt]||0!==n[St])?_t:n[wt]<0||n[wt]>59?wt:n[bt]<0||n[bt]>59?bt:n[St]<0||n[St]>999?St:-1,d(t)._overflowDayOfYear&&(e<vt||e>gt)&&(e=gt),d(t)._overflowWeeks&&-1===e&&(e=xt),d(t)._overflowWeekday&&-1===e&&(e=Ot),d(t).overflow=e),t}function me(t,e,n){return null!=t?t:null!=e?e:n}function ge(t){var e,n,i,o,a,s=[];if(!t._d){for(i=function(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[gt]&&null==t._a[mt]&&function(t){var e,n,r,i,o,a,s,u;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)o=1,a=4,n=me(e.GG,t._a[vt],Bt(Ce(),1,4).year),r=me(e.W,1),((i=me(e.E,1))<1||i>7)&&(u=!0);else{o=t._locale._week.dow,a=t._locale._week.doy;var c=Bt(Ce(),o,a);n=me(e.gg,t._a[vt],c.year),r=me(e.w,c.week),null!=e.d?((i=e.d)<0||i>6)&&(u=!0):null!=e.e?(i=e.e+o,(e.e<0||e.e>6)&&(u=!0)):i=o}r<1||r>Zt(n,o,a)?d(t)._overflowWeeks=!0:null!=u?d(t)._overflowWeekday=!0:(s=Ut(n,r,i,o,a),t._a[vt]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(a=me(t._a[vt],i[vt]),(t._dayOfYear>kt(a)||0===t._dayOfYear)&&(d(t)._overflowDayOfYear=!0),n=Vt(a,0,t._dayOfYear),t._a[mt]=n.getUTCMonth(),t._a[gt]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=i[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[_t]&&0===t._a[wt]&&0===t._a[bt]&&0===t._a[St]&&(t._nextDay=!0,t._a[_t]=0),t._d=(t._useUTC?Vt:Gt).apply(null,s),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[_t]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(d(t).weekdayMismatch=!0)}}var _e=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,be=/Z|[+-]\d\d(?::?\d\d)?/,Se=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],xe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Oe=/^\/?Date\((\-?\d+)/i;function ke(t){var e,n,r,i,o,a,s=t._i,u=_e.exec(s)||we.exec(s);if(u){for(d(t).iso=!0,e=0,n=Se.length;e<n;e++)if(Se[e][1].exec(u[1])){i=Se[e][0],r=!1!==Se[e][2];break}if(null==i)return void(t._isValid=!1);if(u[3]){for(e=0,n=xe.length;e<n;e++)if(xe[e][1].exec(u[3])){o=(u[2]||" ")+xe[e][0];break}if(null==o)return void(t._isValid=!1)}if(!r&&null!=o)return void(t._isValid=!1);if(u[4]){if(!be.exec(u[4]))return void(t._isValid=!1);a="Z"}t._f=i+(o||"")+(a||""),Ae(t)}else t._isValid=!1}var Me=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function De(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}var Te={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Pe(t){var e,n,r,i,o,a,s,u=Me.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(u){var c=(e=u[4],n=u[3],r=u[2],i=u[5],o=u[6],a=u[7],s=[De(e),jt.indexOf(n),parseInt(r,10),parseInt(i,10),parseInt(o,10)],a&&s.push(parseInt(a,10)),s);if(!function(t,e,n){return!t||Jt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(d(n).weekdayMismatch=!0,n._isValid=!1,!1)}(u[1],c,t))return;t._a=c,t._tzm=function(t,e,n){if(t)return Te[t];if(e)return 0;var r=parseInt(n,10),i=r%100;return(r-i)/100*60+i}(u[8],u[9],u[10]),t._d=Vt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),d(t).rfc2822=!0}else t._isValid=!1}function Ae(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],d(t).empty=!0;var e,n,i,o,a,s=""+t._i,u=s.length,c=0;for(i=U(t._f,t._locale).match(F)||[],e=0;e<i.length;e++)o=i[e],(n=(s.match(lt(o,t))||[])[0])&&((a=s.substr(0,s.indexOf(n))).length>0&&d(t).unusedInput.push(a),s=s.slice(s.indexOf(n)+n.length),c+=n.length),G[o]?(n?d(t).empty=!1:d(t).unusedTokens.push(o),yt(o,n,t)):t._strict&&!n&&d(t).unusedTokens.push(o);d(t).charsLeftOver=u-c,s.length>0&&d(t).unusedInput.push(s),t._a[_t]<=12&&!0===d(t).bigHour&&t._a[_t]>0&&(d(t).bigHour=void 0),d(t).parsedDateParts=t._a.slice(0),d(t).meridiem=t._meridiem,t._a[_t]=function(t,e,n){var r;return null==n?e:null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((r=t.isPM(n))&&e<12&&(e+=12),r||12!==e||(e=0),e):e}(t._locale,t._a[_t],t._meridiem),ge(t),ve(t)}else Pe(t);else ke(t)}function Ee(t){var e=t._i,n=t._f;return t._locale=t._locale||ye(t._l),null===e||void 0===n&&""===e?y({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),w(e)?new _(ve(e)):(u(e)?t._d=e:i(n)?function(t){var e,n,r,i,o;if(0===t._f.length)return d(t).invalidFormat=!0,void(t._d=new Date(NaN));for(i=0;i<t._f.length;i++)o=0,e=m({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],Ae(e),p(e)&&(o+=d(e).charsLeftOver,o+=10*d(e).unusedTokens.length,d(e).score=o,(null==r||o<r)&&(r=o,n=e));h(t,n||e)}(t):n?Ae(t):function(t){var e=t._i;a(e)?t._d=new Date(r.now()):u(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=Oe.exec(t._i);null===e?(ke(t),!1===t._isValid&&(delete t._isValid,Pe(t),!1===t._isValid&&(delete t._isValid,r.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):i(e)?(t._a=c(e.slice(0),(function(t){return parseInt(t,10)})),ge(t)):o(e)?function(t){if(!t._d){var e=j(t._i);t._a=c([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),ge(t)}}(t):s(e)?t._d=new Date(e):r.createFromInputFallback(t)}(t),p(t)||(t._d=null),t))}function Le(t,e,n,r,a){var s,u={};return!0!==n&&!1!==n||(r=n,n=void 0),(o(t)&&function(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}(t)||i(t)&&0===t.length)&&(t=void 0),u._isAMomentObject=!0,u._useUTC=u._isUTC=a,u._l=n,u._i=t,u._f=e,u._strict=r,(s=new _(ve(Ee(u))))._nextDay&&(s.add(1,"d"),s._nextDay=void 0),s}function Ce(t,e,n,r){return Le(t,e,n,r,!1)}r.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Ye=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ce.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:y()})),je=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ce.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:y()}));function Re(t,e){var n,r;if(1===e.length&&i(e[0])&&(e=e[0]),!e.length)return Ce();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Ie=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Ne(t){var e=j(t),n=e.year||0,r=e.quarter||0,i=e.month||0,o=e.week||e.isoWeek||0,a=e.day||0,s=e.hour||0,u=e.minute||0,c=e.second||0,l=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Dt.call(Ie,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var n=!1,r=0;r<Ie.length;++r)if(t[Ie[r]]){if(n)return!1;parseFloat(t[Ie[r]])!==S(t[Ie[r]])&&(n=!0)}return!0}(e),this._milliseconds=+l+1e3*c+6e4*u+1e3*s*60*60,this._days=+a+7*o,this._months=+i+3*r+12*n,this._data={},this._locale=ye(),this._bubble()}function Fe(t){return t instanceof Ne}function We(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function ze(t,e){V(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+N(~~(t/60),2)+e+N(~~t%60,2)}))}ze("Z",":"),ze("ZZ",""),ct("Z",at),ct("ZZ",at),dt(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=Ve(at,t)}));var Ge=/([\+\-]|\d\d)/gi;function Ve(t,e){var n=(e||"").match(t);if(null===n)return null;var r=((n[n.length-1]||[])+"").match(Ge)||["-",0,0],i=60*r[1]+S(r[2]);return 0===i?0:"+"===r[0]?i:-i}function He(t,e){var n,i;return e._isUTC?(n=e.clone(),i=(w(t)||u(t)?t.valueOf():Ce(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Ce(t).local()}function Ue(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function Be(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var Ze=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Xe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function qe(t,e){var n,r,i,o,a,u,c=t,h=null;return Fe(t)?c={ms:t._milliseconds,d:t._days,M:t._months}:s(t)?(c={},e?c[e]=t:c.milliseconds=t):(h=Ze.exec(t))?(n="-"===h[1]?-1:1,c={y:0,d:S(h[gt])*n,h:S(h[_t])*n,m:S(h[wt])*n,s:S(h[bt])*n,ms:S(We(1e3*h[St]))*n}):(h=Xe.exec(t))?(n="-"===h[1]?-1:1,c={y:Je(h[2],n),M:Je(h[3],n),w:Je(h[4],n),d:Je(h[5],n),h:Je(h[6],n),m:Je(h[7],n),s:Je(h[8],n)}):null==c?c={}:"object"==typeof c&&("from"in c||"to"in c)&&(o=Ce(c.from),a=Ce(c.to),i=o.isValid()&&a.isValid()?(a=He(a,o),o.isBefore(a)?u=$e(o,a):((u=$e(a,o)).milliseconds=-u.milliseconds,u.months=-u.months),u):{milliseconds:0,months:0},(c={}).ms=i.milliseconds,c.M=i.months),r=new Ne(c),Fe(t)&&l(t,"_locale")&&(r._locale=t._locale),r}function Je(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function $e(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Qe(t,e){return function(n,r){var i;return null===r||isNaN(+r)||(T(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),i=n,n=r,r=i),Ke(this,qe(n="string"==typeof n?+n:n,r),t),this}}function Ke(t,e,n,i){var o=e._milliseconds,a=We(e._days),s=We(e._months);t.isValid()&&(i=null==i||i,s&&It(t,At(t,"Month")+s*n),a&&Et(t,"Date",At(t,"Date")+a*n),o&&t._d.setTime(t._d.valueOf()+o*n),i&&r.updateOffset(t,a||s))}qe.fn=Ne.prototype,qe.invalid=function(){return qe(NaN)};var tn=Qe(1,"add"),en=Qe(-1,"subtract");function nn(t,e){var n=12*(e.year()-t.year())+(e.month()-t.month()),r=t.clone().add(n,"months");return-(n+(e-r<0?(e-r)/(r-t.clone().add(n-1,"months")):(e-r)/(t.clone().add(n+1,"months")-r)))||0}function rn(t){var e;return void 0===t?this._locale._abbr:(null!=(e=ye(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var on=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function an(){return this._locale}var sn=1e3,un=60*sn,cn=60*un,ln=3506328*cn;function hn(t,e){return(t%e+e)%e}function fn(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-ln:new Date(t,e,n).valueOf()}function dn(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-ln:Date.UTC(t,e,n)}function pn(t,e){V(0,[t,t.length],0,e)}function yn(t,e,n,r,i){var o;return null==t?Bt(this,r,i).year:(e>(o=Zt(t,r,i))&&(e=o),vn.call(this,t,e,n,r,i))}function vn(t,e,n,r,i){var o=Ut(t,e,n,r,i),a=Vt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}V(0,["gg",2],0,(function(){return this.weekYear()%100})),V(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),pn("gggg","weekYear"),pn("ggggg","weekYear"),pn("GGGG","isoWeekYear"),pn("GGGGG","isoWeekYear"),C("weekYear","gg"),C("isoWeekYear","GG"),I("weekYear",1),I("isoWeekYear",1),ct("G",it),ct("g",it),ct("GG",$,Z),ct("gg",$,Z),ct("GGGG",et,q),ct("gggg",et,q),ct("GGGGG",nt,J),ct("ggggg",nt,J),pt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,r){e[r.substr(0,2)]=S(t)})),pt(["gg","GG"],(function(t,e,n,i){e[i]=r.parseTwoDigitYear(t)})),V("Q",0,"Qo","quarter"),C("quarter","Q"),I("quarter",7),ct("Q",B),dt("Q",(function(t,e){e[mt]=3*(S(t)-1)})),V("D",["DD",2],"Do","date"),C("date","D"),I("date",9),ct("D",$),ct("DD",$,Z),ct("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),dt(["D","DD"],gt),dt("Do",(function(t,e){e[gt]=S(t.match($)[0])}));var mn=Pt("Date",!0);V("DDD",["DDDD",3],"DDDo","dayOfYear"),C("dayOfYear","DDD"),I("dayOfYear",4),ct("DDD",tt),ct("DDDD",X),dt(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=S(t)})),V("m",["mm",2],0,"minute"),C("minute","m"),I("minute",14),ct("m",$),ct("mm",$,Z),dt(["m","mm"],wt);var gn=Pt("Minutes",!1);V("s",["ss",2],0,"second"),C("second","s"),I("second",15),ct("s",$),ct("ss",$,Z),dt(["s","ss"],bt);var _n,wn=Pt("Seconds",!1);for(V("S",0,0,(function(){return~~(this.millisecond()/100)})),V(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),V(0,["SSS",3],0,"millisecond"),V(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),V(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),V(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),V(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),V(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),V(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),C("millisecond","ms"),I("millisecond",16),ct("S",tt,B),ct("SS",tt,Z),ct("SSS",tt,X),_n="SSSS";_n.length<=9;_n+="S")ct(_n,rt);function bn(t,e){e[St]=S(1e3*("0."+t))}for(_n="S";_n.length<=9;_n+="S")dt(_n,bn);var Sn=Pt("Milliseconds",!1);V("z",0,0,"zoneAbbr"),V("zz",0,0,"zoneName");var xn=_.prototype;function On(t){return t}xn.add=tn,xn.calendar=function(t,e){var n=t||Ce(),i=He(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=e&&(P(e[o])?e[o].call(this,n):e[o]);return this.format(a||this.localeData().calendar(o,this,Ce(n)))},xn.clone=function(){return new _(this)},xn.diff=function(t,e,n){var r,i,o;if(!this.isValid())return NaN;if(!(r=He(t,this)).isValid())return NaN;switch(i=6e4*(r.utcOffset()-this.utcOffset()),e=Y(e)){case"year":o=nn(this,r)/12;break;case"month":o=nn(this,r);break;case"quarter":o=nn(this,r)/3;break;case"second":o=(this-r)/1e3;break;case"minute":o=(this-r)/6e4;break;case"hour":o=(this-r)/36e5;break;case"day":o=(this-r-i)/864e5;break;case"week":o=(this-r-i)/6048e5;break;default:o=this-r}return n?o:b(o)},xn.endOf=function(t){var e;if(void 0===(t=Y(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?dn:fn;switch(t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=cn-hn(e+(this._isUTC?0:this.utcOffset()*un),cn)-1;break;case"minute":e=this._d.valueOf(),e+=un-hn(e,un)-1;break;case"second":e=this._d.valueOf(),e+=sn-hn(e,sn)-1}return this._d.setTime(e),r.updateOffset(this,!0),this},xn.format=function(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=H(this,t);return this.localeData().postformat(e)},xn.from=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ce(t).isValid())?qe({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},xn.fromNow=function(t){return this.from(Ce(),t)},xn.to=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ce(t).isValid())?qe({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},xn.toNow=function(t){return this.to(Ce(),t)},xn.get=function(t){return P(this[t=Y(t)])?this[t]():this},xn.invalidAt=function(){return d(this).overflow},xn.isAfter=function(t,e){var n=w(t)?t:Ce(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())},xn.isBefore=function(t,e){var n=w(t)?t:Ce(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())},xn.isBetween=function(t,e,n,r){var i=w(t)?t:Ce(t),o=w(e)?e:Ce(e);return!!(this.isValid()&&i.isValid()&&o.isValid())&&("("===(r=r||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===r[1]?this.isBefore(o,n):!this.isAfter(o,n))},xn.isSame=function(t,e){var n,r=w(t)?t:Ce(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=Y(e)||"millisecond")?this.valueOf()===r.valueOf():(n=r.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))},xn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},xn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},xn.isValid=function(){return p(this)},xn.lang=on,xn.locale=rn,xn.localeData=an,xn.max=je,xn.min=Ye,xn.parsingFlags=function(){return h({},d(this))},xn.set=function(t,e){if("object"==typeof t)for(var n=function(t){var e=[];for(var n in t)e.push({unit:n,priority:R[n]});return e.sort((function(t,e){return t.priority-e.priority})),e}(t=j(t)),r=0;r<n.length;r++)this[n[r].unit](t[n[r].unit]);else if(P(this[t=Y(t)]))return this[t](e);return this},xn.startOf=function(t){var e;if(void 0===(t=Y(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?dn:fn;switch(t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=hn(e+(this._isUTC?0:this.utcOffset()*un),cn);break;case"minute":e=this._d.valueOf(),e-=hn(e,un);break;case"second":e=this._d.valueOf(),e-=hn(e,sn)}return this._d.setTime(e),r.updateOffset(this,!0),this},xn.subtract=en,xn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},xn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},xn.toDate=function(){return new Date(this.valueOf())},xn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?H(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):P(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",H(n,"Z")):H(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},xn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var n="["+t+'("]',r=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i=e+'[")]';return this.format(n+r+"-MM-DD[T]HH:mm:ss.SSS"+i)},xn.toJSON=function(){return this.isValid()?this.toISOString():null},xn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},xn.unix=function(){return Math.floor(this.valueOf()/1e3)},xn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},xn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},xn.year=Tt,xn.isLeapYear=function(){return Mt(this.year())},xn.weekYear=function(t){return yn.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},xn.isoWeekYear=function(t){return yn.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},xn.quarter=xn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},xn.month=Nt,xn.daysInMonth=function(){return Lt(this.year(),this.month())},xn.week=xn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},xn.isoWeek=xn.isoWeeks=function(t){var e=Bt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},xn.weeksInYear=function(){var t=this.localeData()._week;return Zt(this.year(),t.dow,t.doy)},xn.isoWeeksInYear=function(){return Zt(this.year(),1,4)},xn.date=mn,xn.day=xn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},xn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},xn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},xn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},xn.hour=xn.hours=se,xn.minute=xn.minutes=gn,xn.second=xn.seconds=wn,xn.millisecond=xn.milliseconds=Sn,xn.utcOffset=function(t,e,n){var i,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ve(at,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(i=Ue(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==t&&(!e||this._changeInProgress?Ke(this,qe(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Ue(this)},xn.utc=function(t){return this.utcOffset(0,t)},xn.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Ue(this),"m")),this},xn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ve(ot,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},xn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ce(t).utcOffset():0,(this.utcOffset()-t)%60==0)},xn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},xn.isLocal=function(){return!!this.isValid()&&!this._isUTC},xn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},xn.isUtc=Be,xn.isUTC=Be,xn.zoneAbbr=function(){return this._isUTC?"UTC":""},xn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},xn.dates=k("dates accessor is deprecated. Use date instead.",mn),xn.months=k("months accessor is deprecated. Use month instead",Nt),xn.years=k("years accessor is deprecated. Use year instead",Tt),xn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),xn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!a(this._isDSTShifted))return this._isDSTShifted;var t={};if(m(t,this),(t=Ee(t))._a){var e=t._isUTC?f(t._a):Ce(t._a);this._isDSTShifted=this.isValid()&&x(t._a,e.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var kn=E.prototype;function Mn(t,e,n,r){var i=ye(),o=f().set(r,e);return i[n](o,t)}function Dn(t,e,n){if(s(t)&&(e=t,t=void 0),t=t||"",null!=e)return Mn(t,e,n,"month");var r,i=[];for(r=0;r<12;r++)i[r]=Mn(t,r,n,"month");return i}function Tn(t,e,n,r){"boolean"==typeof t?(s(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,s(e)&&(n=e,e=void 0),e=e||"");var i,o=ye(),a=t?o._week.dow:0;if(null!=n)return Mn(e,(n+a)%7,r,"day");var u=[];for(i=0;i<7;i++)u[i]=Mn(e,(i+a)%7,r,"day");return u}kn.calendar=function(t,e,n){var r=this._calendar[t]||this._calendar.sameElse;return P(r)?r.call(e,n):r},kn.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.replace(/MMMM|MM|DD|dddd/g,(function(t){return t.slice(1)})),this._longDateFormat[t])},kn.invalidDate=function(){return this._invalidDate},kn.ordinal=function(t){return this._ordinal.replace("%d",t)},kn.preparse=On,kn.postformat=On,kn.relativeTime=function(t,e,n,r){var i=this._relativeTime[n];return P(i)?i(t,e,n,r):i.replace(/%d/i,t)},kn.pastFuture=function(t,e){var n=this._relativeTime[t>0?"future":"past"];return P(n)?n(e):n.replace(/%s/i,e)},kn.set=function(t){var e,n;for(n in t)P(e=t[n])?this[n]=e:this["_"+n]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},kn.months=function(t,e){return t?i(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||Ct).test(e)?"format":"standalone"][t.month()]:i(this._months)?this._months:this._months.standalone},kn.monthsShort=function(t,e){return t?i(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[Ct.test(e)?"format":"standalone"][t.month()]:i(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},kn.monthsParse=function(t,e,n){var r,i,o;if(this._monthsParseExact)return Rt.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),r=0;r<12;r++){if(i=f([2e3,r]),n&&!this._longMonthsParse[r]&&(this._longMonthsParse[r]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[r]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[r]||(o="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[r]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[r].test(t))return r;if(n&&"MMM"===e&&this._shortMonthsParse[r].test(t))return r;if(!n&&this._monthsParse[r].test(t))return r}},kn.monthsRegex=function(t){return this._monthsParseExact?(l(this,"_monthsRegex")||zt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=Wt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},kn.monthsShortRegex=function(t){return this._monthsParseExact?(l(this,"_monthsRegex")||zt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=Ft),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},kn.week=function(t){return Bt(t,this._week.dow,this._week.doy).week},kn.firstDayOfYear=function(){return this._week.doy},kn.firstDayOfWeek=function(){return this._week.dow},kn.weekdays=function(t,e){var n=i(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Xt(n,this._week.dow):t?n[t.day()]:n},kn.weekdaysMin=function(t){return!0===t?Xt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},kn.weekdaysShort=function(t){return!0===t?Xt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},kn.weekdaysParse=function(t,e,n){var r,i,o;if(this._weekdaysParseExact)return Qt.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),r=0;r<7;r++){if(i=f([2e3,1]).day(r),n&&!this._fullWeekdaysParse[r]&&(this._fullWeekdaysParse[r]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[r]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[r]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[r]||(o="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[r]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[r].test(t))return r;if(n&&"ddd"===e&&this._shortWeekdaysParse[r].test(t))return r;if(n&&"dd"===e&&this._minWeekdaysParse[r].test(t))return r;if(!n&&this._weekdaysParse[r].test(t))return r}},kn.weekdaysRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Kt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},kn.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=te),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},kn.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ee),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},kn.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},kn.meridiem=function(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"},de("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===S(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=k("moment.lang is deprecated. Use moment.locale instead.",de),r.langData=k("moment.langData is deprecated. Use moment.localeData instead.",ye);var Pn=Math.abs;function An(t,e,n,r){var i=qe(e,n);return t._milliseconds+=r*i._milliseconds,t._days+=r*i._days,t._months+=r*i._months,t._bubble()}function En(t){return t<0?Math.floor(t):Math.ceil(t)}function Ln(t){return 4800*t/146097}function Cn(t){return 146097*t/4800}function Yn(t){return function(){return this.as(t)}}var jn=Yn("ms"),Rn=Yn("s"),In=Yn("m"),Nn=Yn("h"),Fn=Yn("d"),Wn=Yn("w"),zn=Yn("M"),Gn=Yn("Q"),Vn=Yn("y");function Hn(t){return function(){return this.isValid()?this._data[t]:NaN}}var Un=Hn("milliseconds"),Bn=Hn("seconds"),Zn=Hn("minutes"),Xn=Hn("hours"),qn=Hn("days"),Jn=Hn("months"),$n=Hn("years"),Qn=Math.round,Kn={ss:44,s:45,m:45,h:22,d:26,M:11};function tr(t,e,n,r,i){return i.relativeTime(e||1,!!n,t,r)}var er=Math.abs;function nr(t){return(t>0)-(t<0)||+t}function rr(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n=er(this._milliseconds)/1e3,r=er(this._days),i=er(this._months);t=b(n/60),e=b(t/60),n%=60,t%=60;var o=b(i/12),a=i%=12,s=r,u=e,c=t,l=n?n.toFixed(3).replace(/\.?0+$/,""):"",h=this.asSeconds();if(!h)return"P0D";var f=h<0?"-":"",d=nr(this._months)!==nr(h)?"-":"",p=nr(this._days)!==nr(h)?"-":"",y=nr(this._milliseconds)!==nr(h)?"-":"";return f+"P"+(o?d+o+"Y":"")+(a?d+a+"M":"")+(s?p+s+"D":"")+(u||c||l?"T":"")+(u?y+u+"H":"")+(c?y+c+"M":"")+(l?y+l+"S":"")}var ir=Ne.prototype;return ir.isValid=function(){return this._isValid},ir.abs=function(){var t=this._data;return this._milliseconds=Pn(this._milliseconds),this._days=Pn(this._days),this._months=Pn(this._months),t.milliseconds=Pn(t.milliseconds),t.seconds=Pn(t.seconds),t.minutes=Pn(t.minutes),t.hours=Pn(t.hours),t.months=Pn(t.months),t.years=Pn(t.years),this},ir.add=function(t,e){return An(this,t,e,1)},ir.subtract=function(t,e){return An(this,t,e,-1)},ir.as=function(t){if(!this.isValid())return NaN;var e,n,r=this._milliseconds;if("month"===(t=Y(t))||"quarter"===t||"year"===t)switch(e=this._days+r/864e5,n=this._months+Ln(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(Cn(this._months)),t){case"week":return e/7+r/6048e5;case"day":return e+r/864e5;case"hour":return 24*e+r/36e5;case"minute":return 1440*e+r/6e4;case"second":return 86400*e+r/1e3;case"millisecond":return Math.floor(864e5*e)+r;default:throw new Error("Unknown unit "+t)}},ir.asMilliseconds=jn,ir.asSeconds=Rn,ir.asMinutes=In,ir.asHours=Nn,ir.asDays=Fn,ir.asWeeks=Wn,ir.asMonths=zn,ir.asQuarters=Gn,ir.asYears=Vn,ir.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*S(this._months/12):NaN},ir._bubble=function(){var t,e,n,r,i,o=this._milliseconds,a=this._days,s=this._months,u=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*En(Cn(s)+a),a=0,s=0),u.milliseconds=o%1e3,t=b(o/1e3),u.seconds=t%60,e=b(t/60),u.minutes=e%60,n=b(e/60),u.hours=n%24,a+=b(n/24),i=b(Ln(a)),s+=i,a-=En(Cn(i)),r=b(s/12),s%=12,u.days=a,u.months=s,u.years=r,this},ir.clone=function(){return qe(this)},ir.get=function(t){return t=Y(t),this.isValid()?this[t+"s"]():NaN},ir.milliseconds=Un,ir.seconds=Bn,ir.minutes=Zn,ir.hours=Xn,ir.days=qn,ir.weeks=function(){return b(this.days()/7)},ir.months=Jn,ir.years=$n,ir.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),n=function(t,e,n){var r=qe(t).abs(),i=Qn(r.as("s")),o=Qn(r.as("m")),a=Qn(r.as("h")),s=Qn(r.as("d")),u=Qn(r.as("M")),c=Qn(r.as("y")),l=i<=Kn.ss&&["s",i]||i<Kn.s&&["ss",i]||o<=1&&["m"]||o<Kn.m&&["mm",o]||a<=1&&["h"]||a<Kn.h&&["hh",a]||s<=1&&["d"]||s<Kn.d&&["dd",s]||u<=1&&["M"]||u<Kn.M&&["MM",u]||c<=1&&["y"]||["yy",c];return l[2]=e,l[3]=+t>0,l[4]=n,tr.apply(null,l)}(this,!t,e);return t&&(n=e.pastFuture(+this,n)),e.postformat(n)},ir.toISOString=rr,ir.toString=rr,ir.toJSON=rr,ir.locale=rn,ir.localeData=an,ir.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",rr),ir.lang=on,V("X",0,0,"unix"),V("x",0,0,"valueOf"),ct("x",it),ct("X",/[+-]?\d+(\.\d{1,3})?/),dt("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t,10))})),dt("x",(function(t,e,n){n._d=new Date(S(t))})),r.version="2.24.0",e=Ce,r.fn=xn,r.min=function(){return Re("isBefore",[].slice.call(arguments,0))},r.max=function(){return Re("isAfter",[].slice.call(arguments,0))},r.now=function(){return Date.now?Date.now():+new Date},r.utc=f,r.unix=function(t){return Ce(1e3*t)},r.months=function(t,e){return Dn(t,e,"months")},r.isDate=u,r.locale=de,r.invalid=y,r.duration=qe,r.isMoment=w,r.weekdays=function(t,e,n){return Tn(t,e,n,"weekdays")},r.parseZone=function(){return Ce.apply(null,arguments).parseZone()},r.localeData=ye,r.isDuration=Fe,r.monthsShort=function(t,e){return Dn(t,e,"monthsShort")},r.weekdaysMin=function(t,e,n){return Tn(t,e,n,"weekdaysMin")},r.defineLocale=pe,r.updateLocale=function(t,e){if(null!=e){var n,r,i=ue;null!=(r=fe(t))&&(i=r._config),e=A(i,e),(n=new E(e)).parentLocale=ce[t],ce[t]=n,de(t)}else null!=ce[t]&&(null!=ce[t].parentLocale?ce[t]=ce[t].parentLocale:null!=ce[t]&&delete ce[t]);return ce[t]},r.locales=function(){return M(ce)},r.weekdaysShort=function(t,e,n){return Tn(t,e,n,"weekdaysShort")},r.normalizeUnits=Y,r.relativeTimeRounding=function(t){return void 0===t?Qn:"function"==typeof t&&(Qn=t,!0)},r.relativeTimeThreshold=function(t,e){return void 0!==Kn[t]&&(void 0===e?Kn[t]:(Kn[t]=e,"s"===t&&(Kn.ss=e-1),!0))},r.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},r.prototype=xn,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()})),Hx="undefined"!=typeof window&&window.moment||Vx,Ux=Ho((function(t,e){var n;t.exports=(n=null,function t(e,r){var i=r||{preventDefault:!1};if(e.Manager){var o=e,a=function(e,n){var r=Object.create(i);return n&&o.assign(r,n),t(new o(e,r),r)};return o.assign(a,o),a.Manager=function(e,n){var r=Object.create(i);return n&&o.assign(r,n),t(new o.Manager(e,r),r)},a}var s=Object.create(e),u=e.element;function c(t){return t.match(/[^ ]+/g)}function l(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var r=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof r&&(t.srcEvent.stopPropagation=function(){r(),t.stopPropagation()}),t.firstTarget=n;for(var i=n;i&&!e;){var o=i.hammer;if(o)for(var a,s=0;s<o.length;s++)if(a=o[s]._handlers[t.type])for(var u=0;u<a.length&&!e;u++)a[u](t);i=i.parentNode}}return u.hammer||(u.hammer=[]),u.hammer.push(s),e.on("hammer.input",(function(t){!0!==i.preventDefault&&i.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(n=t.target)})),s._handlers={},s.on=function(t,n){return c(t).forEach((function(t){var r=s._handlers[t];r||(s._handlers[t]=r=[],e.on(t,l)),r.push(n)})),s},s.off=function(t,n){return c(t).forEach((function(t){var r=s._handlers[t];r&&((r=n?r.filter((function(t){return t!==n})):[]).length>0?s._handlers[t]=r:(e.off(t,l),delete s._handlers[t]))})),s},s.emit=function(t,r){n=r.target,e.emit(t,r)},s.destroy=function(){var t=e.element.hammer,n=t.indexOf(s);-1!==n&&t.splice(n,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s})})),Bx=Ho((function(t){!function(e,n,r,i){var o,a=["","webkit","Moz","MS","ms","o"],s=n.createElement("div"),u="function",c=Math.round,l=Math.abs,h=Date.now;function f(t,e,n){return setTimeout(_(t,n),e)}function d(t,e,n){return!!Array.isArray(t)&&(p(t,n[e],n),!0)}function p(t,e,n){var r;if(t)if(t.forEach)t.forEach(e,n);else if(t.length!==i)for(r=0;r<t.length;)e.call(n,t[r],r,t),r++;else for(r in t)t.hasOwnProperty(r)&&e.call(n,t[r],r,t)}function y(t,n,r){var i="DEPRECATED METHOD: "+n+"\n"+r+" AT \n";return function(){var n=new Error("get-stack-trace"),r=n&&n.stack?n.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=e.console&&(e.console.warn||e.console.log);return o&&o.call(e.console,i,r),t.apply(this,arguments)}}o="function"!=typeof Object.assign?function(t){if(t===i||null===t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),n=1;n<arguments.length;n++){var r=arguments[n];if(r!==i&&null!==r)for(var o in r)r.hasOwnProperty(o)&&(e[o]=r[o])}return e}:Object.assign;var v=y((function(t,e,n){for(var r=Object.keys(e),o=0;o<r.length;)(!n||n&&t[r[o]]===i)&&(t[r[o]]=e[r[o]]),o++;return t}),"extend","Use `assign`."),m=y((function(t,e){return v(t,e,!0)}),"merge","Use `assign`.");function g(t,e,n){var r,i=e.prototype;(r=t.prototype=Object.create(i)).constructor=t,r._super=i,n&&o(r,n)}function _(t,e){return function(){return t.apply(e,arguments)}}function w(t,e){return typeof t==u?t.apply(e&&e[0]||i,e):t}function b(t,e){return t===i?e:t}function S(t,e,n){p(M(e),(function(e){t.addEventListener(e,n,!1)}))}function x(t,e,n){p(M(e),(function(e){t.removeEventListener(e,n,!1)}))}function O(t,e){for(;t;){if(t==e)return!0;t=t.parentNode}return!1}function k(t,e){return t.indexOf(e)>-1}function M(t){return t.trim().split(/\s+/g)}function D(t,e,n){if(t.indexOf&&!n)return t.indexOf(e);for(var r=0;r<t.length;){if(n&&t[r][n]==e||!n&&t[r]===e)return r;r++}return-1}function T(t){return Array.prototype.slice.call(t,0)}function P(t,e,n){for(var r=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];D(i,a)<0&&r.push(t[o]),i[o]=a,o++}return n&&(r=e?r.sort((function(t,n){return t[e]>n[e]})):r.sort()),r}function A(t,e){for(var n,r,o=e[0].toUpperCase()+e.slice(1),s=0;s<a.length;){if((r=(n=a[s])?n+o:e)in t)return r;s++}return i}var E=1;function L(t){var n=t.ownerDocument||t;return n.defaultView||n.parentWindow||e}var C="ontouchstart"in e,Y=A(e,"PointerEvent")!==i,j=C&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),R=25,I=1,N=2,F=4,W=8,z=1,G=2,V=4,H=8,U=16,B=G|V,Z=H|U,X=B|Z,q=["x","y"],J=["clientX","clientY"];function $(t,e){var n=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){w(t.options.enable,[t])&&n.handler(e)},this.init()}function Q(t,e,n){var r=n.pointers.length,o=n.changedPointers.length,a=e&I&&r-o==0,s=e&(F|W)&&r-o==0;n.isFirst=!!a,n.isFinal=!!s,a&&(t.session={}),n.eventType=e,function(t,e){var n=t.session,r=e.pointers,o=r.length;n.firstInput||(n.firstInput=K(e));o>1&&!n.firstMultiple?n.firstMultiple=K(e):1===o&&(n.firstMultiple=!1);var a=n.firstInput,s=n.firstMultiple,u=s?s.center:a.center,c=e.center=tt(r);e.timeStamp=h(),e.deltaTime=e.timeStamp-a.timeStamp,e.angle=it(u,c),e.distance=rt(u,c),function(t,e){var n=e.center,r=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==I&&o.eventType!==F||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},r=t.offsetDelta={x:n.x,y:n.y});e.deltaX=i.x+(n.x-r.x),e.deltaY=i.y+(n.y-r.y)}(n,e),e.offsetDirection=nt(e.deltaX,e.deltaY);var f=et(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=f.x,e.overallVelocityY=f.y,e.overallVelocity=l(f.x)>l(f.y)?f.x:f.y,e.scale=s?(d=s.pointers,p=r,rt(p[0],p[1],J)/rt(d[0],d[1],J)):1,e.rotation=s?function(t,e){return it(e[1],e[0],J)+it(t[1],t[0],J)}(s.pointers,r):0,e.maxPointers=n.prevInput?e.pointers.length>n.prevInput.maxPointers?e.pointers.length:n.prevInput.maxPointers:e.pointers.length,function(t,e){var n,r,o,a,s=t.lastInterval||e,u=e.timeStamp-s.timeStamp;if(e.eventType!=W&&(u>R||s.velocity===i)){var c=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,f=et(u,c,h);r=f.x,o=f.y,n=l(f.x)>l(f.y)?f.x:f.y,a=nt(c,h),t.lastInterval=e}else n=s.velocity,r=s.velocityX,o=s.velocityY,a=s.direction;e.velocity=n,e.velocityX=r,e.velocityY=o,e.direction=a}(n,e);var d,p;var y=t.element;O(e.srcEvent.target,y)&&(y=e.srcEvent.target);e.target=y}(t,n),t.emit("hammer.input",n),t.recognize(n),t.session.prevInput=n}function K(t){for(var e=[],n=0;n<t.pointers.length;)e[n]={clientX:c(t.pointers[n].clientX),clientY:c(t.pointers[n].clientY)},n++;return{timeStamp:h(),pointers:e,center:tt(e),deltaX:t.deltaX,deltaY:t.deltaY}}function tt(t){var e=t.length;if(1===e)return{x:c(t[0].clientX),y:c(t[0].clientY)};for(var n=0,r=0,i=0;i<e;)n+=t[i].clientX,r+=t[i].clientY,i++;return{x:c(n/e),y:c(r/e)}}function et(t,e,n){return{x:e/t||0,y:n/t||0}}function nt(t,e){return t===e?z:l(t)>=l(e)?t<0?G:V:e<0?H:U}function rt(t,e,n){n||(n=q);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return Math.sqrt(r*r+i*i)}function it(t,e,n){n||(n=q);var r=e[n[0]]-t[n[0]],i=e[n[1]]-t[n[1]];return 180*Math.atan2(i,r)/Math.PI}$.prototype={handler:function(){},init:function(){this.evEl&&S(this.element,this.evEl,this.domHandler),this.evTarget&&S(this.target,this.evTarget,this.domHandler),this.evWin&&S(L(this.element),this.evWin,this.domHandler)},destroy:function(){this.evEl&&x(this.element,this.evEl,this.domHandler),this.evTarget&&x(this.target,this.evTarget,this.domHandler),this.evWin&&x(L(this.element),this.evWin,this.domHandler)}};var ot={mousedown:I,mousemove:N,mouseup:F},at="mousedown",st="mousemove mouseup";function ut(){this.evEl=at,this.evWin=st,this.pressed=!1,$.apply(this,arguments)}g(ut,$,{handler:function(t){var e=ot[t.type];e&I&&0===t.button&&(this.pressed=!0),e&N&&1!==t.which&&(e=F),this.pressed&&(e&F&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))}});var ct={pointerdown:I,pointermove:N,pointerup:F,pointercancel:W,pointerout:W},lt={2:"touch",3:"pen",4:"mouse",5:"kinect"},ht="pointerdown",ft="pointermove pointerup pointercancel";function dt(){this.evEl=ht,this.evWin=ft,$.apply(this,arguments),this.store=this.manager.session.pointerEvents=[]}e.MSPointerEvent&&!e.PointerEvent&&(ht="MSPointerDown",ft="MSPointerMove MSPointerUp MSPointerCancel"),g(dt,$,{handler:function(t){var e=this.store,n=!1,r=t.type.toLowerCase().replace("ms",""),i=ct[r],o=lt[t.pointerType]||t.pointerType,a="touch"==o,s=D(e,t.pointerId,"pointerId");i&I&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(F|W)&&(n=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),n&&e.splice(s,1))}});var pt={touchstart:I,touchmove:N,touchend:F,touchcancel:W},yt="touchstart",vt="touchstart touchmove touchend touchcancel";function mt(){this.evTarget=yt,this.evWin=vt,this.started=!1,$.apply(this,arguments)}function gt(t,e){var n=T(t.touches),r=T(t.changedTouches);return e&(F|W)&&(n=P(n.concat(r),"identifier",!0)),[n,r]}g(mt,$,{handler:function(t){var e=pt[t.type];if(e===I&&(this.started=!0),this.started){var n=gt.call(this,t,e);e&(F|W)&&n[0].length-n[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:"touch",srcEvent:t})}}});var _t={touchstart:I,touchmove:N,touchend:F,touchcancel:W},wt="touchstart touchmove touchend touchcancel";function bt(){this.evTarget=wt,this.targetIds={},$.apply(this,arguments)}function St(t,e){var n=T(t.touches),r=this.targetIds;if(e&(I|N)&&1===n.length)return r[n[0].identifier]=!0,[n,n];var i,o,a=T(t.changedTouches),s=[],u=this.target;if(o=n.filter((function(t){return O(t.target,u)})),e===I)for(i=0;i<o.length;)r[o[i].identifier]=!0,i++;for(i=0;i<a.length;)r[a[i].identifier]&&s.push(a[i]),e&(F|W)&&delete r[a[i].identifier],i++;return s.length?[P(o.concat(s),"identifier",!0),s]:void 0}g(bt,$,{handler:function(t){var e=_t[t.type],n=St.call(this,t,e);n&&this.callback(this.manager,e,{pointers:n[0],changedPointers:n[1],pointerType:"touch",srcEvent:t})}});var xt=2500,Ot=25;function kt(){$.apply(this,arguments);var t=_(this.handler,this);this.touch=new bt(this.manager,t),this.mouse=new ut(this.manager,t),this.primaryTouch=null,this.lastTouches=[]}function Mt(t,e){t&I?(this.primaryTouch=e.changedPointers[0].identifier,Dt.call(this,e)):t&(F|W)&&Dt.call(this,e)}function Dt(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var n={x:e.clientX,y:e.clientY};this.lastTouches.push(n);var r=this.lastTouches;setTimeout((function(){var t=r.indexOf(n);t>-1&&r.splice(t,1)}),xt)}}function Tt(t){for(var e=t.srcEvent.clientX,n=t.srcEvent.clientY,r=0;r<this.lastTouches.length;r++){var i=this.lastTouches[r],o=Math.abs(e-i.x),a=Math.abs(n-i.y);if(o<=Ot&&a<=Ot)return!0}return!1}g(kt,$,{handler:function(t,e,n){var r="touch"==n.pointerType,i="mouse"==n.pointerType;if(!(i&&n.sourceCapabilities&&n.sourceCapabilities.firesTouchEvents)){if(r)Mt.call(this,e,n);else if(i&&Tt.call(this,n))return;this.callback(t,e,n)}},destroy:function(){this.touch.destroy(),this.mouse.destroy()}});var Pt=A(s.style,"touchAction"),At=Pt!==i,Et="auto",Lt="manipulation",Ct="none",Yt="pan-x",jt="pan-y",Rt=function(){if(!At)return!1;var t={},n=e.CSS&&e.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){t[r]=!n||e.CSS.supports("touch-action",r)})),t}();function It(t,e){this.manager=t,this.set(e)}It.prototype={set:function(t){"compute"==t&&(t=this.compute()),At&&this.manager.element.style&&Rt[t]&&(this.manager.element.style[Pt]=t),this.actions=t.toLowerCase().trim()},update:function(){this.set(this.manager.options.touchAction)},compute:function(){var t=[];return p(this.manager.recognizers,(function(e){w(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(k(t,Ct))return Ct;var e=k(t,Yt),n=k(t,jt);if(e&&n)return Ct;if(e||n)return e?Yt:jt;if(k(t,Lt))return Lt;return Et}(t.join(" "))},preventDefaults:function(t){var e=t.srcEvent,n=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var r=this.actions,i=k(r,Ct)&&!Rt[Ct],o=k(r,jt)&&!Rt[jt],a=k(r,Yt)&&!Rt[Yt];if(i){var s=1===t.pointers.length,u=t.distance<2,c=t.deltaTime<250;if(s&&u&&c)return}if(!a||!o)return i||o&&n&B||a&&n&Z?this.preventSrc(e):void 0}},preventSrc:function(t){this.manager.session.prevented=!0,t.preventDefault()}};var Nt=1,Ft=2,Wt=4,zt=8,Gt=zt,Vt=16;function Ht(t){this.options=o({},this.defaults,t||{}),this.id=E++,this.manager=null,this.options.enable=b(this.options.enable,!0),this.state=Nt,this.simultaneous={},this.requireFail=[]}function Ut(t){return t&Vt?"cancel":t&zt?"end":t&Wt?"move":t&Ft?"start":""}function Bt(t){return t==U?"down":t==H?"up":t==G?"left":t==V?"right":""}function Zt(t,e){var n=e.manager;return n?n.get(t):t}function Xt(){Ht.apply(this,arguments)}function qt(){Xt.apply(this,arguments),this.pX=null,this.pY=null}function Jt(){Xt.apply(this,arguments)}function $t(){Ht.apply(this,arguments),this._timer=null,this._input=null}function Qt(){Xt.apply(this,arguments)}function Kt(){Xt.apply(this,arguments)}function te(){Ht.apply(this,arguments),this.pTime=!1,this.pCenter=!1,this._timer=null,this._input=null,this.count=0}function ee(t,e){return(e=e||{}).recognizers=b(e.recognizers,ee.defaults.preset),new ne(t,e)}Ht.prototype={defaults:{},set:function(t){return o(this.options,t),this.manager&&this.manager.touchAction.update(),this},recognizeWith:function(t){if(d(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Zt(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},dropRecognizeWith:function(t){return d(t,"dropRecognizeWith",this)?this:(t=Zt(t,this),delete this.simultaneous[t.id],this)},requireFailure:function(t){if(d(t,"requireFailure",this))return this;var e=this.requireFail;return-1===D(e,t=Zt(t,this))&&(e.push(t),t.requireFailure(this)),this},dropRequireFailure:function(t){if(d(t,"dropRequireFailure",this))return this;t=Zt(t,this);var e=D(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},hasRequireFailures:function(){return this.requireFail.length>0},canRecognizeWith:function(t){return!!this.simultaneous[t.id]},emit:function(t){var e=this,n=this.state;function r(n){e.manager.emit(n,t)}n<zt&&r(e.options.event+Ut(n)),r(e.options.event),t.additionalEvent&&r(t.additionalEvent),n>=zt&&r(e.options.event+Ut(n))},tryEmit:function(t){if(this.canEmit())return this.emit(t);this.state=32},canEmit:function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(32|Nt)))return!1;t++}return!0},recognize:function(t){var e=o({},t);if(!w(this.options.enable,[this,e]))return this.reset(),void(this.state=32);this.state&(Gt|Vt|32)&&(this.state=Nt),this.state=this.process(e),this.state&(Ft|Wt|zt|Vt)&&this.tryEmit(e)},process:function(t){},getTouchAction:function(){},reset:function(){}},g(Xt,Ht,{defaults:{pointers:1},attrTest:function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},process:function(t){var e=this.state,n=t.eventType,r=e&(Ft|Wt),i=this.attrTest(t);return r&&(n&W||!i)?e|Vt:r||i?n&F?e|zt:e&Ft?e|Wt:Ft:32}}),g(qt,Xt,{defaults:{event:"pan",threshold:10,pointers:1,direction:X},getTouchAction:function(){var t=this.options.direction,e=[];return t&B&&e.push(jt),t&Z&&e.push(Yt),e},directionTest:function(t){var e=this.options,n=!0,r=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&B?(i=0===o?z:o<0?G:V,n=o!=this.pX,r=Math.abs(t.deltaX)):(i=0===a?z:a<0?H:U,n=a!=this.pY,r=Math.abs(t.deltaY))),t.direction=i,n&&r>e.threshold&&i&e.direction},attrTest:function(t){return Xt.prototype.attrTest.call(this,t)&&(this.state&Ft||!(this.state&Ft)&&this.directionTest(t))},emit:function(t){this.pX=t.deltaX,this.pY=t.deltaY;var e=Bt(t.direction);e&&(t.additionalEvent=this.options.event+e),this._super.emit.call(this,t)}}),g(Jt,Xt,{defaults:{event:"pinch",threshold:0,pointers:2},getTouchAction:function(){return[Ct]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.scale-1)>this.options.threshold||this.state&Ft)},emit:function(t){if(1!==t.scale){var e=t.scale<1?"in":"out";t.additionalEvent=this.options.event+e}this._super.emit.call(this,t)}}),g($t,Ht,{defaults:{event:"press",pointers:1,time:251,threshold:9},getTouchAction:function(){return[Et]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime>e.time;if(this._input=t,!r||!n||t.eventType&(F|W)&&!i)this.reset();else if(t.eventType&I)this.reset(),this._timer=f((function(){this.state=Gt,this.tryEmit()}),e.time,this);else if(t.eventType&F)return Gt;return 32},reset:function(){clearTimeout(this._timer)},emit:function(t){this.state===Gt&&(t&&t.eventType&F?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=h(),this.manager.emit(this.options.event,this._input)))}}),g(Qt,Xt,{defaults:{event:"rotate",threshold:0,pointers:2},getTouchAction:function(){return[Ct]},attrTest:function(t){return this._super.attrTest.call(this,t)&&(Math.abs(t.rotation)>this.options.threshold||this.state&Ft)}}),g(Kt,Xt,{defaults:{event:"swipe",threshold:10,velocity:.3,direction:B|Z,pointers:1},getTouchAction:function(){return qt.prototype.getTouchAction.call(this)},attrTest:function(t){var e,n=this.options.direction;return n&(B|Z)?e=t.overallVelocity:n&B?e=t.overallVelocityX:n&Z&&(e=t.overallVelocityY),this._super.attrTest.call(this,t)&&n&t.offsetDirection&&t.distance>this.options.threshold&&t.maxPointers==this.options.pointers&&l(e)>this.options.velocity&&t.eventType&F},emit:function(t){var e=Bt(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)}}),g(te,Ht,{defaults:{event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},getTouchAction:function(){return[Lt]},process:function(t){var e=this.options,n=t.pointers.length===e.pointers,r=t.distance<e.threshold,i=t.deltaTime<e.time;if(this.reset(),t.eventType&I&&0===this.count)return this.failTimeout();if(r&&i&&n){if(t.eventType!=F)return this.failTimeout();var o=!this.pTime||t.timeStamp-this.pTime<e.interval,a=!this.pCenter||rt(this.pCenter,t.center)<e.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&o?this.count+=1:this.count=1,this._input=t,0===this.count%e.taps)return this.hasRequireFailures()?(this._timer=f((function(){this.state=Gt,this.tryEmit()}),e.interval,this),Ft):Gt}return 32},failTimeout:function(){return this._timer=f((function(){this.state=32}),this.options.interval,this),32},reset:function(){clearTimeout(this._timer)},emit:function(){this.state==Gt&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))}}),ee.VERSION="2.0.7",ee.defaults={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,preset:[[Qt,{enable:!1}],[Jt,{enable:!1},["rotate"]],[Kt,{direction:B}],[qt,{direction:B},["swipe"]],[te],[te,{event:"doubletap",taps:2},["tap"]],[$t]],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function ne(t,e){var n;this.options=o({},ee.defaults,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((n=this).options.inputClass||(Y?dt:j?bt:C?kt:ut))(n,Q),this.touchAction=new It(this,this.options.touchAction),re(this,!0),p(this.options.recognizers,(function(t){var e=this.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}function re(t,e){var n,r=t.element;r.style&&(p(t.options.cssProps,(function(i,o){n=A(r.style,o),e?(t.oldCssProps[n]=r.style[n],r.style[n]=i):r.style[n]=t.oldCssProps[n]||""})),e||(t.oldCssProps={}))}ne.prototype={set:function(t){return o(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},stop:function(t){this.session.stopped=t?2:1},recognize:function(t){var e=this.session;if(!e.stopped){var n;this.touchAction.preventDefaults(t);var r=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&Gt)&&(i=e.curRecognizer=null);for(var o=0;o<r.length;)n=r[o],2===e.stopped||i&&n!=i&&!n.canRecognizeWith(i)?n.reset():n.recognize(t),!i&&n.state&(Ft|Wt|zt)&&(i=e.curRecognizer=n),o++}},get:function(t){if(t instanceof Ht)return t;for(var e=this.recognizers,n=0;n<e.length;n++)if(e[n].options.event==t)return e[n];return null},add:function(t){if(d(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},remove:function(t){if(d(t,"remove",this))return this;if(t=this.get(t)){var e=this.recognizers,n=D(e,t);-1!==n&&(e.splice(n,1),this.touchAction.update())}return this},on:function(t,e){if(t!==i&&e!==i){var n=this.handlers;return p(M(t),(function(t){n[t]=n[t]||[],n[t].push(e)})),this}},off:function(t,e){if(t!==i){var n=this.handlers;return p(M(t),(function(t){e?n[t]&&n[t].splice(D(n[t],e),1):delete n[t]})),this}},emit:function(t,e){this.options.domEvents&&function(t,e){var r=n.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var i=0;i<r.length;)r[i](e),i++}},destroy:function(){this.element&&re(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null}},o(ee,{INPUT_START:I,INPUT_MOVE:N,INPUT_END:F,INPUT_CANCEL:W,STATE_POSSIBLE:Nt,STATE_BEGAN:Ft,STATE_CHANGED:Wt,STATE_ENDED:zt,STATE_RECOGNIZED:Gt,STATE_CANCELLED:Vt,STATE_FAILED:32,DIRECTION_NONE:z,DIRECTION_LEFT:G,DIRECTION_RIGHT:V,DIRECTION_UP:H,DIRECTION_DOWN:U,DIRECTION_HORIZONTAL:B,DIRECTION_VERTICAL:Z,DIRECTION_ALL:X,Manager:ne,Input:$,TouchAction:It,TouchInput:bt,MouseInput:ut,PointerEventInput:dt,TouchMouseInput:kt,SingleTouchInput:mt,Recognizer:Ht,AttrRecognizer:Xt,Tap:te,Pan:qt,Swipe:Kt,Pinch:Jt,Rotate:Qt,Press:$t,on:S,off:x,each:p,merge:m,extend:v,assign:o,inherit:g,bindFn:_,prefixed:A}),(void 0!==e?e:"undefined"!=typeof self?self:{}).Hammer=ee,"function"==typeof i&&i.amd?i((function(){return ee})):t.exports?t.exports=ee:e.Hammer=ee}(window,document)})),Zx=Ho((function(t){if("undefined"!=typeof window){var e=Ux,n=window.Hammer||Bx;t.exports=e(n,{preventDefault:"mouse"})}else t.exports=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t}})),Xx=Ho((function(t,e){t.exports=function(t){var e,n=t&&t.preventDefault||!1,r=t&&t.container||window,i={},o={keydown:{},keyup:{}},a={};for(e=97;e<=122;e++)a[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)a[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)a[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)a["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)a["num"+e]={code:96+e,shift:!1};a["num*"]={code:106,shift:!1},a["num+"]={code:107,shift:!1},a["num-"]={code:109,shift:!1},a["num/"]={code:111,shift:!1},a["num."]={code:110,shift:!1},a.left={code:37,shift:!1},a.up={code:38,shift:!1},a.right={code:39,shift:!1},a.down={code:40,shift:!1},a.space={code:32,shift:!1},a.enter={code:13,shift:!1},a.shift={code:16,shift:void 0},a.esc={code:27,shift:!1},a.backspace={code:8,shift:!1},a.tab={code:9,shift:!1},a.ctrl={code:17,shift:!1},a.alt={code:18,shift:!1},a.delete={code:46,shift:!1},a.pageup={code:33,shift:!1},a.pagedown={code:34,shift:!1},a["="]={code:187,shift:!1},a["-"]={code:189,shift:!1},a["]"]={code:221,shift:!1},a["["]={code:219,shift:!1};var s=function(t){c(t,"keydown")},u=function(t){c(t,"keyup")},c=function(t,e){if(void 0!==o[e][t.keyCode]){for(var r=o[e][t.keyCode],i=0;i<r.length;i++)void 0===r[i].shift?r[i].fn(t):1==r[i].shift&&1==t.shiftKey?r[i].fn(t):0==r[i].shift&&0==t.shiftKey&&r[i].fn(t);1==n&&t.preventDefault()}};return i.bind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);void 0===o[n][a[t].code]&&(o[n][a[t].code]=[]),o[n][a[t].code].push({fn:e,shift:a[t].shift})},i.bindAll=function(t,e){for(var n in void 0===e&&(e="keydown"),a)a.hasOwnProperty(n)&&i.bind(n,t,e)},i.getKey=function(t){for(var e in a)if(a.hasOwnProperty(e)){if(1==t.shiftKey&&1==a[e].shift&&t.keyCode==a[e].code)return e;if(0==t.shiftKey&&0==a[e].shift&&t.keyCode==a[e].code)return e;if(t.keyCode==a[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},i.unbind=function(t,e,n){if(void 0===n&&(n="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);if(void 0!==e){var r=[],i=o[n][a[t].code];if(void 0!==i)for(var s=0;s<i.length;s++)i[s].fn==e&&i[s].shift==a[t].shift||r.push(o[n][a[t].code][s]);o[n][a[t].code]=r}else o[n][a[t].code]=[]},i.reset=function(){o={keydown:{},keyup:{}}},i.destroy=function(){o={keydown:{},keyup:{}},r.removeEventListener("keydown",s,!0),r.removeEventListener("keyup",u,!0)},r.addEventListener("keydown",s,!0),r.addEventListener("keyup",u,!0),i}})),qx=pS,Jx=Bo,$x=Mx.DataSet,Qx=Mx.DataView,Kx=Mx.Queue,tO=Gx,eO={Camera:WS,Filter:Px,Point2d:dS,Point3d:fS,Slider:vS,StepNumber:gS},nO=Hx,rO=Zx,iO=Xx,oO={util:qx,DOMutil:Jx,DataSet:$x,DataView:Qx,Queue:Kx,Graph3d:tO,graph3d:eO,moment:nO,Hammer:rO,keycharm:iO};t.DOMutil=Jx,t.DataSet=$x,t.DataView=Qx,t.Graph3d=tO,t.Hammer=rO,t.Queue=Kx,t.default=oO,t.graph3d=eO,t.keycharm=iO,t.moment=nO,t.util=qx,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
